/*
** This file has been pre-processed with DynASM.
** http://luajit.org/dynasm.html
** DynASM version 1.3.0, DynASM x64 version 1.3.0
** DO NOT EDIT! The original file is in "src/jit/x64/emit.dasc".
*/

#line 1 "src/jit/x64/emit.dasc"
/* -*-C-*- */
#include "moar.h"
#include "jit/internal.h"
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wimplicit-fallthrough"
#include "dasm_x86.h"
#pragma GCC diagnostic pop
#pragma GCC diagnostic ignored "-Wunused-variable"

#ifdef _MSC_VER
#pragma warning( disable : 4129 )
#endif

/**
 * CONVENTIONS

 * Much of this file contains snippets of assembly code, which are concatenated
 * at runtime in order to form a single executable routine. It is essential for
 * the correctness of the result that each of the snippets behaves
 * nicely. Because you can't be expected to know what that is, it is documented
 * here.

 * REGISTERS:

 * Register and calling conventions differ between POSIX and windows
 * systems. The registers rax, rcx, rdx, r8, r9, r10 and r11 are caller-saved,
 * meaning that you are free to overwrrite them, and functions you may call are
 * free to do thesame. Hence you should save their values on stack, if you wish
 * to keep them after calling. In contrast, rbx, rsp, rbp, and r12-r15 are
 * callee-saved, meaning that their values before entering and after returning
 * from a function must be the same. POSIX also makes rdi and rsi caller-saved,
 * windows makes them callee-saved. For this reason we avoid using them.  The
 * first 4 (windows) or 6 (POSIX) function call arguments are placed in
 * registers. These registers sets are not the same between windows and POSIX,
 * but they're always caller-saved.

 * To deal with the ambiguity, register names have been aliased.

 * + RV stands for 'return value', and is aliased to rax
 * + TMP1-6 are the 6 shared caller-saved registers
 * + ARG1-4 are (different) aliases for argument registers
 * + TC, CU, WORK are registers that hold interpreter variables; these are callee-
 *   saved registers set up at entry and restored at exit
 * + TMP5 (r10) is also aliased as FUNCTION; it never conflicts with an argument
 *   register, and neither does TMP6.
 * + The suffixes d, w, and b stand for the 4, 2, and 1 byte-width value of the
 *   registers.

 * Note that the current convention for function calls is to load the function
 * pointer as a 64 bit value in a register from the machine code, and call on
 * that register. This is not ideal, but call doesn't natively take 64 bit
 * values, and it is neccesary to ensure that the function lives within 32 bits
 * distance from the function otherwise. Other methods are being considered.

 * LABELS:

 * Don't use dynamic labels in this code, unless they have been passed to you
 * from outside. Dynamic labels need to be allocated and not conflict, hence
 * just picking one is typically unsafe. Local labels are usually safe.

 * WRITE BARRIERS:

 * Use of write barriers is tricky, because they may involve a function call, and
 * that may or may not mean you have to store your temporaries on the stack.
 * Hence, a write barrier (MVM_ASSIGN_REF) is split into two parts:

 * + check_wb (root, value, label)
 * + hit_wb (root, value)

 * You should have the label parameter point somewhere after hit_wb, and save
 * and restore your temporaries around the hit_wb.
 **/


//|.arch x64
#if DASM_VERSION != 10300
#error "Version mismatch between DynASM and included encoding engine"
#endif
#line 76 "src/jit/x64/emit.dasc"
//|.actionlist actions
static const unsigned char actions[6290] = {
  254,0,85,72,137,229,255,72,129,250,236,0,1,0,0,255,76,137,117,250,248,76,
  137,109,250,240,72,137,93,250,232,255,73,137,250,254,73,137,250,245,77,139,
  158,231,73,139,155,231,255,72,141,68,36,250,248,73,137,134,231,255,250,255,
  226,255,246,10,255,73,199,134,231,0,0,0,0,255,76,139,117,250,248,76,139,109,
  250,240,72,139,93,250,232,255,72,137,250,236,93,195,255,72,185,235,235,72,
  137,139,231,255,76,137,250,247,72,199,198,235,254,1,246,5,235,235,254,0,250,
  255,21,242,5,73,139,142,231,72,139,137,231,72,139,137,231,72,137,136,231,
  102,199,128,231,234,65,139,142,231,137,136,231,255,72,199,131,231,235,255,
  73,139,141,231,72,139,137,231,72,137,139,231,255,73,139,142,231,72,139,137,
  231,72,137,139,231,255,72,139,139,231,72,139,137,231,255,72,139,137,231,73,
  139,150,231,72,139,146,231,72,133,201,72,15,68,202,255,77,139,158,231,255,
  77,139,155,231,255,77,139,147,231,255,77,139,146,231,255,77,133,210,15,133,
  242,247,255,76,137,250,247,76,137,222,72,199,194,235,254,1,250,255,21,242,
  5,255,73,137,194,246,1,255,76,137,147,231,255,76,139,155,231,77,139,155,231,
  255,72,139,145,231,255,76,139,131,231,76,137,130,231,255,102,250,247,129,
  231,234,15,132,242,248,77,133,192,15,132,242,248,102,65,250,247,128,231,234,
  15,133,242,248,76,137,194,72,137,206,76,137,250,247,254,1,250,255,21,242,
  5,246,2,255,76,139,147,231,77,139,154,231,77,139,155,231,65,129,187,231,237,
  15,132,242,247,102,65,250,247,130,231,234,15,132,242,247,76,137,250,247,72,
  190,235,235,254,1,250,255,21,242,5,246,1,76,137,214,76,137,250,247,72,139,
  147,231,254,1,250,255,21,242,5,72,137,131,231,255,76,137,250,247,255,73,139,
  181,231,72,139,182,231,72,199,194,235,254,1,250,255,21,242,5,72,133,192,15,
  132,242,247,72,139,0,72,137,131,231,250,233,242,248,246,1,77,139,134,231,
  77,139,128,231,76,137,131,231,246,2,255,73,139,142,231,255,72,139,145,231,
  76,139,131,231,76,137,130,231,255,72,139,139,231,72,139,145,231,72,139,146,
  231,129,186,231,237,15,133,242,247,102,250,247,129,231,234,15,132,242,248,
  246,1,76,137,250,247,72,190,235,235,254,1,250,255,21,242,5,246,2,72,139,177,
  231,72,139,147,231,76,137,250,247,254,1,73,139,142,231,72,139,137,231,72,
  139,137,231,72,137,139,231,255,72,139,139,231,255,72,141,145,231,255,72,141,
  145,231,76,139,137,231,77,141,145,231,77,133,201,73,15,69,210,255,76,139,
  2,77,133,192,255,15,133,242,249,255,77,139,134,231,77,139,128,231,246,3,255,
  76,139,2,255,77,133,192,15,133,242,250,255,77,139,134,231,77,139,128,231,
  77,139,128,231,255,102,250,247,129,231,234,15,132,242,249,77,133,192,15,132,
  242,249,102,65,250,247,128,231,234,15,133,242,249,72,137,85,216,76,137,69,
  208,76,137,194,72,139,179,231,76,137,250,247,254,1,250,255,21,242,5,76,139,
  69,208,72,139,85,216,246,3,255,76,137,2,246,4,255,76,139,2,77,133,192,15,
  133,242,250,255,76,137,250,247,73,139,182,231,72,139,182,231,72,139,182,231,
  254,1,250,255,21,242,5,73,137,192,255,72,139,139,231,72,141,145,231,76,139,
  137,231,77,141,145,231,77,133,201,73,15,69,210,255,250,255,21,242,5,76,139,
  69,208,72,139,85,216,246,3,76,137,2,255,68,139,138,231,65,129,250,249,237,
  15,133,242,251,76,99,130,231,250,233,242,252,246,5,76,137,250,247,72,137,
  214,254,1,250,255,21,242,5,73,137,192,246,6,255,76,99,2,255,76,137,131,231,
  255,72,139,139,231,72,139,147,231,255,102,250,247,129,231,234,15,132,242,
  248,72,133,210,15,132,242,248,102,250,247,130,231,234,15,133,242,248,255,
  72,139,147,231,72,139,179,231,76,137,250,247,254,1,250,255,21,242,5,72,139,
  139,231,72,139,147,231,246,2,255,137,145,231,255,72,137,145,231,255,72,139,
  139,231,72,139,145,231,72,137,147,231,255,72,139,139,231,72,139,145,231,72,
  133,210,15,133,242,247,73,139,150,231,72,139,146,231,246,1,72,137,147,231,
  255,72,139,139,231,72,139,129,231,72,152,72,137,131,231,255,72,139,139,231,
  72,139,147,231,72,139,137,231,72,137,17,255,72,139,139,231,76,139,129,231,
  73,139,16,72,137,147,231,255,72,139,139,231,72,139,147,231,76,141,129,231,
  73,131,184,231,0,15,132,242,247,77,139,128,231,246,1,255,102,250,247,129,
  231,234,15,132,242,248,72,133,210,15,132,242,248,102,250,247,130,231,234,
  15,133,242,248,72,137,85,216,76,137,69,208,72,139,147,231,72,139,179,231,
  76,137,250,247,254,1,250,255,21,242,5,76,139,69,208,72,139,85,216,246,2,255,
  65,137,144,231,255,73,137,144,231,255,72,139,139,231,72,137,139,231,255,72,
  139,139,231,73,137,142,231,255,73,139,142,231,72,131,250,249,0,15,132,242,
  248,73,139,150,231,72,131,250,250,0,15,132,242,247,77,139,134,231,77,139,
  128,231,76,57,194,15,133,242,248,246,1,72,137,139,231,73,199,134,231,235,
  250,233,242,249,246,2,73,139,142,231,72,139,137,231,72,137,139,231,246,3,
  255,72,139,139,231,72,139,147,231,73,137,150,231,76,139,129,231,77,139,128,
  231,65,129,184,231,237,15,132,242,248,246,1,255,72,137,206,76,137,250,247,
  72,49,210,254,1,250,255,21,242,5,73,137,134,231,250,233,242,249,246,2,73,
  137,142,231,250,233,242,249,246,3,255,76,137,250,247,73,139,182,231,254,1,
  72,139,139,231,102,250,247,129,231,234,15,133,242,247,72,139,145,231,72,139,
  146,231,129,186,231,237,15,132,242,248,246,1,76,137,250,247,72,190,235,235,
  254,1,250,255,21,242,5,246,2,72,137,139,231,255,72,49,192,76,139,147,231,
  255,102,65,250,247,130,231,234,15,133,242,247,77,139,154,231,77,139,155,231,
  65,129,187,231,237,15,133,242,247,255,76,137,250,247,76,137,214,72,199,194,
  235,254,1,250,255,21,242,5,72,137,131,231,250,233,242,248,246,1,76,137,250,
  247,72,190,235,235,254,1,73,139,141,231,255,72,199,131,231,0,0,0,0,255,72,
  139,139,231,72,133,201,15,148,210,72,15,182,210,72,137,147,231,255,76,139,
  147,231,102,65,250,247,130,231,234,15,133,242,247,77,139,154,231,77,139,155,
  231,65,129,187,231,237,15,133,242,247,76,137,250,247,73,139,178,231,72,139,
  147,231,254,1,72,129,131,231,237,255,72,129,171,231,237,255,72,129,139,231,
  237,255,72,129,163,231,237,255,72,129,179,231,237,255,72,139,131,231,255,
  72,1,131,231,255,72,41,131,231,255,72,9,131,231,255,72,33,131,231,255,72,
  49,131,231,255,72,129,192,237,255,72,129,250,232,237,255,72,129,200,237,255,
  72,129,224,237,255,72,129,250,240,237,255,72,3,131,231,255,72,43,131,231,
  255,72,11,131,231,255,72,35,131,231,255,72,51,131,231,255,72,15,175,131,231,
  255,138,139,231,72,211,224,255,138,139,231,72,211,250,248,255,72,49,192,72,
  139,139,231,72,57,193,15,140,242,249,72,250,255,192,76,139,131,231,246,1,
  72,250,247,193,1,0,0,0,15,132,242,248,73,250,247,250,232,246,2,77,15,175,
  192,72,209,250,233,15,133,242,1,246,3,72,137,131,231,255,72,139,131,231,72,
  139,139,231,72,131,250,249,0,15,133,242,247,76,137,250,247,72,190,235,235,
  254,1,250,255,21,242,5,246,1,255,15,156,214,72,131,250,248,0,15,156,210,48,
  250,242,68,15,182,194,72,153,72,250,247,250,249,72,133,210,15,149,209,65,
  32,200,255,76,41,192,72,137,131,231,255,250,255,21,242,5,246,1,72,153,72,
  250,247,250,249,72,137,147,231,255,72,131,131,231,1,255,72,131,171,231,1,
  255,72,139,139,231,72,250,247,209,72,137,139,231,255,72,139,139,231,72,250,
  247,217,72,137,139,231,255,72,139,131,231,102,152,152,72,152,72,137,131,231,
  255,72,139,139,231,72,49,210,136,202,72,137,147,231,255,72,139,131,231,152,
  72,152,72,137,131,231,255,72,139,139,231,72,49,210,102,137,202,72,137,147,
  231,255,72,139,131,231,72,152,72,137,131,231,255,72,139,139,231,137,202,72,
  137,139,231,255,250,242,15,16,131,231,255,250,242,15,88,131,231,255,250,242,
  15,92,131,231,255,250,242,15,89,131,231,255,250,242,15,94,131,231,255,250,
  242,15,17,131,231,255,250,242,72,15,42,131,231,250,242,15,17,131,231,255,
  250,242,72,15,44,131,231,72,137,131,231,255,72,199,193,1,0,0,0,72,193,225,
  63,72,139,147,231,72,49,202,72,137,147,231,255,72,59,131,231,255,15,148,208,
  255,15,149,208,255,15,156,208,255,15,158,208,255,15,159,208,255,15,157,208,
  255,72,15,182,192,72,137,131,231,255,72,59,139,231,255,15,159,210,72,15,182,
  210,65,15,156,208,77,15,182,192,76,41,194,72,137,147,231,255,72,199,194,1,
  0,0,0,255,72,199,194,250,255,250,255,250,255,250,255,255,72,199,194,0,0,0,
  0,255,72,59,147,231,255,72,199,193,0,0,0,0,255,72,199,193,1,0,0,0,255,250,
  242,15,16,131,231,102,15,46,131,231,255,15,147,209,255,15,155,210,72,15,68,
  202,255,15,154,210,72,15,68,202,255,15,151,209,255,72,15,182,201,72,137,139,
  231,255,250,242,15,16,131,231,250,242,15,16,139,231,102,15,46,193,15,151,
  209,72,15,182,193,102,15,46,200,15,151,209,72,15,182,201,72,41,200,72,137,
  131,231,255,76,137,250,247,72,139,179,231,72,139,147,231,254,1,72,129,250,
  248,237,15,148,208,255,72,129,250,248,237,15,149,208,255,72,139,139,231,72,
  133,201,15,132,242,247,72,139,137,231,72,139,137,231,72,129,185,231,237,15,
  133,242,247,72,199,131,231,1,0,0,0,250,233,242,248,246,1,72,199,131,231,0,
  0,0,0,246,2,255,72,139,139,231,72,139,145,231,72,131,194,1,76,139,129,231,
  255,76,57,194,15,156,209,72,15,182,201,72,137,139,231,255,72,139,139,231,
  72,139,145,231,72,133,210,15,149,210,72,15,182,210,72,137,147,231,255,76,
  139,155,231,77,133,219,15,132,242,247,76,137,250,247,73,139,179,231,76,139,
  150,231,77,139,146,231,65,250,255,210,76,15,183,152,231,246,1,76,137,155,
  231,255,76,139,155,231,77,133,219,15,132,242,247,73,139,179,231,76,139,150,
  231,77,139,146,231,76,137,250,247,65,250,255,210,76,15,183,152,231,77,133,
  219,15,132,242,247,76,15,183,152,231,246,1,76,137,155,231,255,76,139,147,
  231,77,133,210,15,132,242,247,76,137,250,247,73,139,178,231,76,139,150,231,
  77,139,146,231,65,250,255,210,102,131,184,231,1,15,133,242,247,76,15,182,
  152,231,76,137,155,231,250,233,242,248,246,1,72,199,131,231,0,0,0,0,246,2,
  255,72,139,139,231,72,133,201,15,149,210,77,139,134,231,77,139,128,231,76,
  57,193,65,15,149,208,68,32,194,72,15,182,210,72,137,147,231,255,76,139,147,
  231,77,139,154,231,77,139,155,231,65,129,187,231,237,15,132,242,247,76,137,
  250,247,72,190,235,235,254,1,250,255,21,242,5,246,1,76,137,250,247,76,137,
  214,254,1,250,255,21,242,5,246,1,76,137,250,247,72,139,179,231,76,137,210,
  254,1,72,139,139,231,72,133,201,15,148,210,77,139,134,231,77,139,128,231,
  76,57,193,65,15,148,208,68,8,194,72,15,182,210,72,137,147,231,255,76,139,
  147,231,77,133,210,255,15,132,242,247,102,65,250,247,130,231,234,255,15,133,
  242,247,77,139,154,231,77,139,155,231,77,133,219,255,15,132,242,247,76,137,
  250,247,76,137,214,72,141,147,231,77,139,147,231,65,250,255,210,250,233,242,
  248,246,1,255,76,137,147,231,246,2,255,72,139,139,231,72,133,201,15,132,242,
  247,72,139,137,231,72,139,137,231,72,133,201,246,1,15,149,209,72,15,182,201,
  72,137,139,231,255,73,139,142,231,72,139,137,231,72,139,137,231,72,139,147,
  231,72,139,146,231,72,57,209,15,133,242,247,77,139,134,231,77,139,128,231,
  77,139,128,231,76,137,131,231,250,233,242,248,246,1,255,76,137,250,247,72,
  139,179,231,255,73,139,149,231,72,139,146,231,72,199,193,235,76,141,155,231,
  77,137,216,254,1,72,139,139,231,72,133,201,15,132,242,247,102,250,247,129,
  231,234,15,133,242,247,72,199,131,231,1,0,0,0,250,233,242,248,246,1,72,199,
  131,231,0,0,0,0,246,2,255,72,139,139,231,72,139,137,231,72,199,194,1,0,0,
  0,73,184,235,235,76,59,129,231,15,133,242,247,76,139,137,231,77,133,201,15,
  133,242,247,76,33,202,246,1,72,137,147,231,255,73,139,142,231,72,133,201,
  15,133,242,247,73,139,142,231,72,139,137,231,246,1,72,137,139,231,73,199,
  134,231,0,0,0,0,255,73,139,142,231,72,133,201,15,132,242,247,72,139,137,231,
  72,137,139,231,250,233,242,248,246,1,73,139,142,231,72,139,137,231,72,137,
  139,231,246,2,255,65,139,142,231,131,193,1,65,137,142,231,72,137,139,231,
  255,65,139,142,231,131,250,233,1,65,137,142,231,72,137,139,231,255,72,139,
  179,231,76,139,150,231,77,139,146,231,77,133,210,15,133,242,247,76,137,250,
  247,72,190,235,235,254,1,250,255,21,242,5,246,1,76,137,250,247,72,139,147,
  231,255,65,250,255,210,255,76,137,250,247,72,139,179,231,72,199,194,235,254,
  1,250,255,21,242,5,72,133,192,15,132,242,247,72,139,0,246,1,72,137,131,231,
  255,73,139,182,231,72,141,182,231,102,68,139,150,231,102,68,59,150,231,15,
  132,242,247,76,137,250,247,254,1,72,139,139,231,72,133,201,15,133,242,247,
  76,137,250,247,254,1,72,185,235,235,72,139,137,231,72,137,139,231,255,76,
  137,250,247,73,139,182,231,72,139,182,231,72,199,194,235,254,1,76,137,250,
  247,73,139,182,231,72,139,182,231,72,139,182,231,72,199,194,235,254,1,72,
  139,139,231,139,145,231,77,49,192,131,250,250,0,15,142,242,247,77,139,134,
  231,77,139,128,231,77,139,4,208,77,139,128,231,246,1,76,137,131,231,255,102,
  250,247,129,231,234,15,133,242,247,72,139,145,231,72,139,146,231,129,186,
  231,237,15,132,242,248,246,1,255,76,137,250,247,72,139,179,231,72,49,210,
  254,1,72,137,198,255,72,141,187,231,77,139,158,231,73,137,187,231,255,65,
  198,131,231,233,255,73,139,190,231,72,139,63,73,137,187,231,255,76,137,250,
  247,72,139,147,231,72,139,138,231,72,139,145,231,72,139,137,231,76,139,150,
  231,77,139,146,231,65,250,255,210,255,250,255,21,242,5,246,2,72,139,145,231,
  72,15,183,146,231,72,137,147,231,255,250,255,21,242,5,246,2,72,139,145,231,
  102,68,139,130,231,102,139,146,231,102,68,57,194,15,149,208,72,15,182,192,
  72,137,131,231,255,250,255,21,242,5,246,2,72,139,177,231,76,137,250,247,254,
  1,77,139,134,231,255,250,255,21,242,5,246,2,72,139,145,231,72,137,147,231,
  255,72,139,145,231,72,139,146,231,129,186,231,237,15,132,242,247,255,250,
  255,21,242,5,246,1,72,139,147,231,72,137,145,231,102,250,247,129,231,234,
  15,132,242,248,72,133,210,15,132,242,248,102,250,247,130,231,234,15,133,242,
  248,72,137,210,72,137,206,76,137,250,247,254,1,77,139,134,231,76,137,131,
  231,255,76,137,250,247,72,139,183,231,72,141,182,231,72,199,194,235,254,1,
  76,137,250,247,72,139,183,231,72,49,250,246,254,1,76,137,250,247,72,139,179,
  231,72,139,147,231,72,139,139,231,76,141,131,231,76,139,150,231,77,139,146,
  231,77,139,146,231,65,250,255,210,255,76,137,250,247,72,139,179,231,76,139,
  150,231,77,139,146,231,77,139,146,231,65,250,255,210,72,137,131,231,255,76,
  137,250,247,72,139,179,231,72,139,147,231,76,139,150,231,77,139,146,231,77,
  139,146,231,65,250,255,210,255,72,139,139,231,72,133,201,15,133,242,247,72,
  185,235,235,250,233,242,248,246,1,72,185,235,235,246,2,72,137,139,231,255,
  72,139,139,231,72,131,250,249,14,15,143,242,247,72,131,250,249,250,255,15,
  140,242,247,72,250,255,193,72,186,235,235,72,139,20,202,72,137,147,231,250,
  233,242,248,246,1,255,72,137,131,231,76,139,131,231,255,76,137,128,231,255,
  73,129,250,248,237,15,143,242,249,73,129,250,248,237,15,140,242,249,199,128,
  231,235,68,137,128,231,250,233,242,250,246,3,76,137,250,247,72,137,198,72,
  129,198,237,76,137,194,254,1,250,255,21,242,5,246,4,255,72,139,139,231,72,
  139,147,231,68,139,137,231,65,129,250,249,237,15,133,242,247,68,139,138,231,
  65,129,250,249,237,15,133,242,247,255,68,139,137,231,255,68,3,138,231,255,
  68,43,138,231,255,68,15,175,138,231,255,15,128,242,247,255,65,131,250,249,
  14,15,143,242,248,65,131,250,249,250,255,15,140,242,248,65,250,255,193,72,
  186,235,235,74,139,20,202,72,137,147,231,250,233,242,249,246,2,68,137,77,
  208,255,72,137,131,231,68,139,77,208,199,128,231,235,68,137,136,231,72,137,
  131,231,250,233,242,249,255,76,137,250,247,72,139,179,231,72,129,198,237,
  72,139,147,231,72,129,194,237,72,137,131,231,72,137,193,72,129,193,237,255,
  72,139,139,231,68,139,137,231,65,129,250,249,237,15,133,242,247,255,68,139,
  137,231,69,133,201,65,15,149,208,77,15,182,192,76,137,131,231,250,233,242,
  248,246,1,255,76,139,137,231,69,139,129,231,69,133,192,65,15,149,208,77,15,
  182,192,76,137,131,231,246,2,255,77,137,250,243,255,77,137,250,235,255,77,
  139,158,231,77,141,155,231,255,77,139,158,231,77,139,155,231,255,76,139,155,
  231,255,76,141,155,231,255,77,139,157,231,77,139,155,231,255,73,199,195,235,
  255,73,187,235,235,255,76,139,155,231,77,141,155,231,255,77,139,150,231,77,
  139,18,77,49,219,102,69,139,154,231,78,139,28,219,255,76,141,29,243,255,77,
  139,158,231,77,139,155,231,77,139,155,231,255,77,139,158,231,77,139,155,231,
  77,141,155,231,255,77,139,158,231,77,139,155,231,77,139,155,231,77,139,155,
  231,255,76,139,157,231,255,76,137,223,255,76,137,222,255,76,137,218,255,76,
  137,217,255,77,137,216,255,77,137,217,255,102,73,15,110,195,255,102,73,15,
  110,203,255,102,73,15,110,211,255,102,73,15,110,219,255,102,73,15,110,227,
  255,102,73,15,110,250,235,255,102,73,15,110,250,243,255,102,73,15,110,250,
  251,255,68,136,156,251,36,231,255,102,68,137,156,251,36,231,255,76,137,156,
  251,36,231,255,72,139,8,72,137,139,231,255,72,139,139,231,72,137,8,255,73,
  139,142,231,72,139,9,72,49,210,102,139,145,231,72,137,4,211,255,72,133,192,
  15,132,242,250,72,139,8,250,233,242,251,246,4,73,139,142,231,72,139,137,231,
  246,5,72,137,139,231,255,102,152,255,72,152,255,72,37,250,255,0,0,0,255,72,
  37,250,255,250,255,0,0,255,72,131,224,250,255,255,72,137,133,231,255,73,131,
  190,231,0,15,132,242,247,76,137,250,247,254,1,250,233,242,10,255,250,233,
  243,255,72,139,131,231,72,133,192,15,133,243,255,72,139,131,231,72,133,192,
  15,132,243,255,102,72,15,110,131,231,102,15,87,201,102,15,46,193,15,138,243,
  15,133,243,255,102,72,15,110,131,231,102,15,87,201,102,15,46,193,15,138,242,
  247,15,133,242,247,250,233,243,246,1,255,76,137,250,247,72,139,179,231,254,
  1,250,255,21,242,5,72,133,192,255,72,139,139,231,72,133,201,15,132,242,247,
  73,139,150,231,72,139,146,231,72,57,209,15,132,242,247,250,233,243,246,1,
  255,72,139,139,231,72,133,201,15,132,242,247,131,185,231,0,15,132,242,247,
  250,233,243,246,1,255,72,139,139,231,72,133,201,15,132,243,131,185,231,0,
  15,132,243,246,1,255,76,137,250,247,72,139,179,231,72,139,147,231,255,73,
  139,141,231,72,139,137,231,254,1,72,131,250,248,250,255,255,15,142,243,255,
  15,138,242,247,15,130,243,246,1,255,15,140,243,255,15,138,242,247,15,134,
  243,246,1,255,15,138,242,247,15,132,243,246,1,255,15,138,243,255,15,131,243,
  255,15,141,243,255,15,135,243,255,15,143,243,255,73,139,150,231,72,139,146,
  231,72,139,146,231,255,72,133,201,15,132,242,247,255,72,59,145,231,15,133,
  242,247,255,102,250,247,129,231,234,255,102,250,247,129,231,234,15,133,242,
  247,255,76,139,129,231,77,139,128,231,65,129,184,231,237,15,133,242,247,72,
  59,145,231,15,133,242,247,255,72,57,202,15,133,242,247,255,72,57,202,15,132,
  242,247,255,102,250,247,129,231,234,15,132,242,247,255,250,233,242,10,246,
  2,255,73,139,150,231,72,139,18,77,139,150,231,73,137,146,231,255,77,137,154,
  231,255,65,198,130,231,233,255,73,199,130,231,235,255,72,141,147,231,73,137,
  146,231,255,76,139,139,231,77,137,138,231,255,73,185,235,235,77,137,138,231,
  255,77,139,141,231,77,139,137,231,77,137,138,231,255,76,137,250,247,72,139,
  179,231,76,137,218,72,199,193,235,254,1,73,139,181,231,72,139,182,231,72,
  141,147,231,72,199,193,235,77,139,134,231,77,139,128,231,77,139,128,231,77,
  139,141,231,77,139,137,231,254,1,76,137,85,216,76,137,93,208,255,76,137,250,
  247,72,139,179,231,72,141,85,208,76,137,209,73,199,192,0,0,0,0,254,1,76,139,
  93,208,76,139,85,216,255,76,137,250,247,72,137,198,76,137,218,76,137,209,
  255,76,139,144,231,77,139,146,231,65,250,255,210,255,72,139,139,231,72,131,
  250,249,0,15,140,242,248,72,129,250,249,237,15,141,242,248,72,107,201,8,72,
  141,21,242,247,72,1,202,250,255,226,248,7,246,1,255,247,250,233,243,248,7,
  255,205,3,255,64,252,138,128,251,238,10,238,8,231,255,102,253,139,128,251,
  238,10,238,8,231,255,72,252,139,128,251,238,10,238,8,231,255,250,242,253,
  15,16,128,251,238,10,238,8,231,255,64,252,136,128,251,238,10,238,8,231,255,
  102,253,137,128,251,238,10,238,8,231,255,72,252,137,128,251,238,10,238,8,
  231,255,250,242,253,15,17,128,251,238,10,238,8,231,255,72,252,137,192,238,
  14,238,12,255,102,72,252,15,126,192,238,14,238,12,255,250,243,253,15,126,
  192,238,14,238,12,255,102,72,252,15,110,192,238,14,238,12,255,144,255,77,
  139,158,231,77,139,155,231,77,133,219,15,133,242,247,250,233,242,10,246,1,
  255,72,252,141,128,251,238,10,238,8,231,255,72,252,141,132,251,238,10,192,
  238,15,238,13,231,255,72,252,199,192,238,12,235,255,72,252,184,238,0,235,
  235,255,246,5,255,250,242,253,15,16,5,238,2,242,5,255,253,138,128,251,238,
  10,238,8,231,255,64,252,138,132,251,238,10,192,238,15,238,13,231,255,102,
  253,139,132,251,238,10,192,238,15,238,13,231,255,72,252,139,132,251,238,10,
  192,238,15,238,13,231,255,64,252,136,132,251,238,10,192,238,15,238,13,231,
  255,102,253,137,132,251,238,10,192,238,15,238,13,231,255,72,252,137,132,251,
  238,10,192,238,15,238,13,231,255,102,64,252,15,190,192,238,14,238,12,255,
  253,15,191,192,238,14,238,12,255,72,252,15,190,192,238,14,238,12,255,72,252,
  15,191,192,238,14,238,12,255,253,137,192,238,14,72,152,72,252,137,192,238,
  12,255,64,252,15,182,192,238,14,238,12,255,102,64,252,15,182,192,238,14,238,
  12,255,253,15,183,192,238,14,238,12,255,253,137,192,238,14,238,12,255,72,
  252,15,182,192,238,14,238,12,255,72,252,15,183,192,238,14,238,12,255,102,
  64,252,15,190,128,251,238,10,238,8,231,255,253,15,191,128,251,238,10,238,
  8,231,255,72,252,15,190,128,251,238,10,238,8,231,255,72,252,15,191,128,251,
  238,10,238,8,231,255,253,139,128,251,238,8,231,72,152,72,252,137,192,238,
  12,255,64,252,15,182,128,251,238,10,238,8,231,255,102,64,252,15,182,128,251,
  238,10,238,8,231,255,253,15,183,128,251,238,10,238,8,231,255,72,252,15,182,
  128,251,238,10,238,8,231,255,72,252,15,183,128,251,238,10,238,8,231,255,72,
  252,1,192,238,14,238,12,255,72,252,129,192,238,12,237,255,64,252,2,128,251,
  238,10,238,8,231,255,102,253,3,128,251,238,10,238,8,231,255,72,252,3,128,
  251,238,10,238,8,231,255,64,252,2,132,251,238,10,192,238,15,238,13,231,255,
  102,253,3,132,251,238,10,192,238,15,238,13,231,255,72,252,3,132,251,238,10,
  192,238,15,238,13,231,255,250,242,253,15,88,192,238,14,238,12,255,250,242,
  253,15,92,192,238,14,238,12,255,250,242,253,15,89,192,238,14,238,12,255,72,
  252,33,192,238,14,238,12,255,72,252,129,224,238,12,237,255,64,252,34,128,
  251,238,10,238,8,231,255,102,253,35,128,251,238,10,238,8,231,255,72,252,35,
  128,251,238,10,238,8,231,255,64,252,34,132,251,238,10,192,238,15,238,13,231,
  255,102,253,35,132,251,238,10,192,238,15,238,13,231,255,72,252,35,132,251,
  238,10,192,238,15,238,13,231,255,72,252,15,175,192,238,14,238,12,255,72,252,
  9,192,238,14,238,12,255,72,252,49,192,238,14,238,12,255,72,252,250,247,208,
  238,12,255,72,252,41,192,238,14,238,12,255,72,252,129,250,232,238,12,237,
  255,64,252,42,128,251,238,10,238,8,231,255,102,253,43,128,251,238,10,238,
  8,231,255,72,252,43,128,251,238,10,238,8,231,255,64,252,42,132,251,238,10,
  192,238,15,238,13,231,255,102,253,43,132,251,238,10,192,238,15,238,13,231,
  255,72,252,43,132,251,238,10,192,238,15,238,13,231,255,64,252,132,192,238,
  14,238,12,255,102,253,133,192,238,14,238,12,255,72,252,133,192,238,14,238,
  12,255,64,252,128,184,251,238,8,231,0,255,102,253,131,184,251,238,8,231,0,
  255,72,252,131,184,251,238,8,231,0,255,64,252,128,188,251,192,238,15,238,
  13,231,0,255,102,253,131,188,251,192,238,15,238,13,231,0,255,72,252,131,188,
  251,192,238,15,238,13,231,0,255,64,252,250,246,192,238,12,233,255,102,253,
  250,247,192,238,12,234,255,253,250,247,192,238,12,235,255,64,252,250,246,
  128,251,238,8,231,233,255,102,253,250,247,128,251,238,8,231,234,255,253,250,
  247,128,251,238,8,231,235,255,102,15,87,192,102,253,15,46,192,238,14,255,
  64,252,56,192,238,14,238,12,255,102,253,57,192,238,14,238,12,255,72,252,57,
  192,238,14,238,12,255,102,253,15,46,192,238,14,238,12,255,15,155,208,64,252,
  15,146,208,238,12,64,252,32,192,238,12,255,15,155,208,64,252,15,150,208,238,
  12,64,252,32,192,238,12,255,15,155,208,64,252,15,148,208,238,12,64,252,32,
  192,238,12,255,15,154,208,64,252,15,149,208,238,12,64,252,8,192,238,12,255,
  64,252,15,147,208,238,12,255,64,252,15,151,208,238,12,255,64,252,15,156,208,
  238,12,255,64,252,15,158,208,238,12,255,64,252,15,148,208,238,12,255,64,252,
  15,149,208,238,12,255,64,252,15,157,208,238,12,255,64,252,15,159,208,238,
  12,255,72,252,141,5,238,2,243,255,250,242,253,15,16,192,238,14,255,253,250,
  255,208,238,12,255,253,250,255,144,251,238,8,231,255
};

#line 77 "src/jit/x64/emit.dasc"
//|.section code, data
#define DASM_SECTION_CODE	0
#define DASM_SECTION_DATA	1
#define DASM_MAXSECTION		2
#line 78 "src/jit/x64/emit.dasc"
//|.globals MVM_JIT_LABEL_
enum {
  MVM_JIT_LABEL_exit,
  MVM_JIT_LABEL__MAX
};
#line 79 "src/jit/x64/emit.dasc"

#if MVM_JIT_LABEL__MAX > MVM_JIT_MAX_GLOBALS
#error "Not enough space for labels"
#endif

/* type declarations */
//|.type REGISTER, MVMRegister
#define Dt1(_V) (int)(ptrdiff_t)&(((MVMRegister *)0)_V)
#line 86 "src/jit/x64/emit.dasc"
//|.type FRAME, MVMFrame
#define Dt2(_V) (int)(ptrdiff_t)&(((MVMFrame *)0)_V)
#line 87 "src/jit/x64/emit.dasc"
//|.type ARGCTX, MVMArgProcContext
#define Dt3(_V) (int)(ptrdiff_t)&(((MVMArgProcContext *)0)_V)
#line 88 "src/jit/x64/emit.dasc"
//|.type CALLSITEPTR, MVMCallsite*
#define Dt4(_V) (int)(ptrdiff_t)&(((MVMCallsite* *)0)_V)
#line 89 "src/jit/x64/emit.dasc"
//|.type CAPTURE, MVMCallCapture
#define Dt5(_V) (int)(ptrdiff_t)&(((MVMCallCapture *)0)_V)
#line 90 "src/jit/x64/emit.dasc"
//|.type CAPTUREBODY, MVMCallCaptureBody
#define Dt6(_V) (int)(ptrdiff_t)&(((MVMCallCaptureBody *)0)_V)
#line 91 "src/jit/x64/emit.dasc"
//|.type ARGPROCCONTEXT, MVMArgProcContext
#define Dt7(_V) (int)(ptrdiff_t)&(((MVMArgProcContext *)0)_V)
#line 92 "src/jit/x64/emit.dasc"
//|.type STATICFRAME, MVMStaticFrame
#define Dt8(_V) (int)(ptrdiff_t)&(((MVMStaticFrame *)0)_V)
#line 93 "src/jit/x64/emit.dasc"
//|.type P6OPAQUE, MVMP6opaque
#define Dt9(_V) (int)(ptrdiff_t)&(((MVMP6opaque *)0)_V)
#line 94 "src/jit/x64/emit.dasc"
//|.type P6OBODY, MVMP6opaqueBody
#define DtA(_V) (int)(ptrdiff_t)&(((MVMP6opaqueBody *)0)_V)
#line 95 "src/jit/x64/emit.dasc"
//|.type MVMITER, MVMIter
#define DtB(_V) (int)(ptrdiff_t)&(((MVMIter *)0)_V)
#line 96 "src/jit/x64/emit.dasc"
//|.type MVMINSTANCE, MVMInstance
#define DtC(_V) (int)(ptrdiff_t)&(((MVMInstance *)0)_V)
#line 97 "src/jit/x64/emit.dasc"
//|.type MVMACTIVEHANDLERS, MVMActiveHandler
#define DtD(_V) (int)(ptrdiff_t)&(((MVMActiveHandler *)0)_V)
#line 98 "src/jit/x64/emit.dasc"
//|.type OBJECT, MVMObject
#define DtE(_V) (int)(ptrdiff_t)&(((MVMObject *)0)_V)
#line 99 "src/jit/x64/emit.dasc"
//|.type STOOGE, MVMObjectStooge
#define DtF(_V) (int)(ptrdiff_t)&(((MVMObjectStooge *)0)_V)
#line 100 "src/jit/x64/emit.dasc"
//|.type VMARRAY, MVMArray
#define Dt10(_V) (int)(ptrdiff_t)&(((MVMArray *)0)_V)
#line 101 "src/jit/x64/emit.dasc"
//|.type COLLECTABLE, MVMCollectable
#define Dt11(_V) (int)(ptrdiff_t)&(((MVMCollectable *)0)_V)
#line 102 "src/jit/x64/emit.dasc"
//|.type STABLE, MVMSTable
#define Dt12(_V) (int)(ptrdiff_t)&(((MVMSTable *)0)_V)
#line 103 "src/jit/x64/emit.dasc"
//|.type REPR, MVMREPROps
#define Dt13(_V) (int)(ptrdiff_t)&(((MVMREPROps *)0)_V)
#line 104 "src/jit/x64/emit.dasc"
//|.type STRING, MVMString
#define Dt14(_V) (int)(ptrdiff_t)&(((MVMString *)0)_V)
#line 105 "src/jit/x64/emit.dasc"
//|.type OBJECTPTR, MVMObject*
#define Dt15(_V) (int)(ptrdiff_t)&(((MVMObject* *)0)_V)
#line 106 "src/jit/x64/emit.dasc"
//|.type CONTEXT, MVMContext
#define Dt16(_V) (int)(ptrdiff_t)&(((MVMContext *)0)_V)
#line 107 "src/jit/x64/emit.dasc"
//|.type CONTAINERSPEC, MVMContainerSpec
#define Dt17(_V) (int)(ptrdiff_t)&(((MVMContainerSpec *)0)_V)
#line 108 "src/jit/x64/emit.dasc"
//|.type STORAGESPEC, MVMStorageSpec
#define Dt18(_V) (int)(ptrdiff_t)&(((MVMStorageSpec *)0)_V)
#line 109 "src/jit/x64/emit.dasc"
//|.type HLLCONFIG, MVMHLLConfig;
#define Dt19(_V) (int)(ptrdiff_t)&(((MVMHLLConfig *)0)_V)
#line 110 "src/jit/x64/emit.dasc"
//|.type SCREF, MVMSerializationContext
#define Dt1A(_V) (int)(ptrdiff_t)&(((MVMSerializationContext *)0)_V)
#line 111 "src/jit/x64/emit.dasc"
//|.type SCREFBODY, MVMSerializationContextBody
#define Dt1B(_V) (int)(ptrdiff_t)&(((MVMSerializationContextBody *)0)_V)
#line 112 "src/jit/x64/emit.dasc"
//|.type NFGSYNTH, MVMNFGSynthetic
#define Dt1C(_V) (int)(ptrdiff_t)&(((MVMNFGSynthetic *)0)_V)
#line 113 "src/jit/x64/emit.dasc"
//|.type CODE, MVMCode
#define Dt1D(_V) (int)(ptrdiff_t)&(((MVMCode *)0)_V)
#line 114 "src/jit/x64/emit.dasc"
//|.type BIGINTBODY, MVMP6bigintBody
#define Dt1E(_V) (int)(ptrdiff_t)&(((MVMP6bigintBody *)0)_V)
#line 115 "src/jit/x64/emit.dasc"
//|.type U8, MVMuint8
#define Dt1F(_V) (int)(ptrdiff_t)&(((MVMuint8 *)0)_V)
#line 116 "src/jit/x64/emit.dasc"
//|.type U16, MVMuint16
#define Dt20(_V) (int)(ptrdiff_t)&(((MVMuint16 *)0)_V)
#line 117 "src/jit/x64/emit.dasc"
//|.type U32, MVMuint32
#define Dt21(_V) (int)(ptrdiff_t)&(((MVMuint32 *)0)_V)
#line 118 "src/jit/x64/emit.dasc"
//|.type U64, MVMuint64
#define Dt22(_V) (int)(ptrdiff_t)&(((MVMuint64 *)0)_V)
#line 119 "src/jit/x64/emit.dasc"
//|.type MPINT, mp_int
#define Dt23(_V) (int)(ptrdiff_t)&(((mp_int *)0)_V)
#line 120 "src/jit/x64/emit.dasc"
//|.type MVMHASHENTRY, MVMHashEntry
#define Dt24(_V) (int)(ptrdiff_t)&(((MVMHashEntry *)0)_V)
#line 121 "src/jit/x64/emit.dasc"


/* Static allocation of relevant types to registers. I pick
 * callee-save registers for efficiency. It is likely we'll be calling
 * quite a C functions, and this saves us the trouble of storing
 * them. Moreover, C compilers preferentially do not use callee-saved
 * registers, and so in most cases, these won't be touched at all. */
//|.type TC, MVMThreadContext, r14
#define Dt25(_V) (int)(ptrdiff_t)&(((MVMThreadContext *)0)_V)
#line 129 "src/jit/x64/emit.dasc"
/* Alternative base pointer. I'll be using this often, so picking rbx
 * here rather than the extended registers will lead to smaller
 * bytecode */
//|.type WORK, MVMRegister, rbx
#define Dt26(_V) (int)(ptrdiff_t)&(((MVMRegister *)0)_V)
#line 133 "src/jit/x64/emit.dasc"
//|.type CU, MVMCompUnit, r13
#define Dt27(_V) (int)(ptrdiff_t)&(((MVMCompUnit *)0)_V)
#line 134 "src/jit/x64/emit.dasc"




MVMint32 MVM_jit_support(void) {
#ifdef __i386__
    /* Usually, this file should only be compiled only on a amd64
       platform; but when compiling 'fat' or 'universal' binaries, we
       may compile it for other platform. In this case we use the
       runtime check to disable the JIT */
    return 0;
#else
    return 1;
#endif
}

const unsigned char * MVM_jit_actions(void) {
    return actions;
}

/* C Call argument registers */
//|.if WIN32
//|.define ARG1, rcx
//|.define ARG2, rdx
//|.define ARG3, r8
//|.define ARG4, r9
//|.define ARG5, qword [rsp+0x20]
//|.define ARG6, qword [rsp+0x28]
//|.else
//|.define ARG1, rdi
//|.define ARG2, rsi
//|.define ARG3, rdx
//|.define ARG4, rcx
//|.define ARG5, r8
//|.define ARG6, r9
//|.endif

/* C call argument registers for floating point */
//|.if WIN32
//|.define ARG1F, xmm0
//|.define ARG2F, xmm1
//|.define ARG3F, xmm2
//|.define ARG4F, xmm3
//|.else
//|.define ARG1F, xmm0
//|.define ARG2F, xmm1
//|.define ARG3F, xmm2
//|.define ARG4F, xmm3
//|.define ARG5F, xmm4
//|.define ARG6F, xmm5
//|.define ARG7F, xmm6
//|.define ARG8F, xmm7
//|.endif

/* Special register for the function to be invoked
 * (chosen because it isn't involved in argument passing
 *  and volatile) */
//|.define FUNCTION, r10
/* all-purpose temporary registers */
//|.define TMP1, rcx
//|.define TMP2, rdx
//|.define TMP3, r8
//|.define TMP4, r9
//|.define TMP5, r10
//|.define TMP6, r11
/* same, but 32 bits wide */
//|.define TMP1d, ecx
//|.define TMP2d, edx
//|.define TMP3d, r8d
//|.define TMP4d, r9d
//|.define TMP5d, r10d
//|.define TMP6d, r11d
/* and 16 bits wide */
//|.define TMP1w, cx
//|.define TMP2w, dx
//|.define TMP3w, r8w
//|.define TMP4w, r9w
//|.define TMP5w, r10w
//|.define TMP6w, r11w
/* and 8 bits for good measure */
//|.define TMP1b, cl
//|.define TMP2b, dl
//|.define TMP3b, r8b
//|.define TMP4b, r9b
//|.define TMP5b, r10b
//|.define TMP6b, r11b


/* return value */
//|.define RV, rax
//|.define RVd, eax
//|.define RVF, xmm0


//|.macro callp, funcptr
//|.data
//|5:
//|.dword (MVMuint32)((uintptr_t)(funcptr)), (MVMuint32)((uintptr_t)(funcptr) >> 32);
//|.code
//| call qword [<5];
//|.endmacro


//|.macro check_wb, root, ref, lbl;
//| test word COLLECTABLE:root->flags, MVM_CF_SECOND_GEN;
//| jz lbl;
//| test ref, ref;
//| jz lbl;
//| test word COLLECTABLE:ref->flags, MVM_CF_SECOND_GEN;
//| jnz lbl;
//|.endmacro;

//|.macro hit_wb, obj, value
//| mov ARG3, value
//| mov ARG2, obj;
//| mov ARG1, TC;
//| callp &MVM_gc_write_barrier_hit_by;
//|.endmacro

//|.macro get_spesh_slot, reg, idx;
//| mov reg, TC->cur_frame;
//| mov reg, FRAME:reg->effective_spesh_slots;
//| mov reg, OBJECTPTR:reg[idx];
//|.endmacro

//|.macro get_vmnull, reg
//| mov reg, TC->instance;
//| mov reg, MVMINSTANCE:reg->VMNull;
//|.endmacro

//|.macro get_cur_op, reg
//| mov reg, TC->interp_cur_op
//| mov reg, [reg]
//|.endmacro

//|.macro get_string, reg, idx
//|| MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, idx);
//| mov reg, CU->body.strings;
//| mov reg, OBJECTPTR:reg[idx];
//|.endmacro

//|.macro test_type_object, reg
//| test word OBJECT:reg->header.flags, MVM_CF_TYPE_OBJECT
//|.endmacro

//|.macro gc_sync_point
//| cmp qword TC->gc_status, 0;
//| je >1;
//| mov ARG1, TC;
//| callp &MVM_gc_enter_from_interrupt;
//|1:
//|.endmacro

//|.macro throw_adhoc, msg
//| mov ARG1, TC;
//| mov64 ARG2, (uintptr_t)(msg);
//| callp &MVM_exception_throw_adhoc;
//|.endmacro

//|.macro get_stable, out, in
//| mov out, aword OBJECT:in->st;
//|.endmacro

//|.macro get_repr, out, in
//| get_stable out, in;
//| mov out, aword STABLE:out->REPR;
//|.endmacro

//|.macro cmp_repr_id, obj, tmp, id
//| get_repr tmp, obj;
//| cmp dword REPR:tmp->ID, id;
//|.endmacro

//|.define FRAME_NR, dword [rbp-0x20]

/* A function prologue is always the same in x86 / x64, because
 * we do not provide variable arguments, instead arguments are provided
 * via a frame. All JIT entry points receive a prologue. */

void MVM_jit_emit_prologue(MVMThreadContext *tc, MVMJitCompiler *compiler,
                           MVMJitGraph *jg) {
    //|.code
    dasm_put(Dst, 0);
#line 316 "src/jit/x64/emit.dasc"
    /* Setup stack */
    //| push rbp;
    //| mov rbp, rsp;
    dasm_put(Dst, 2);
#line 319 "src/jit/x64/emit.dasc"
    /* allocate stack space: 0x100 bytes = 256 bytes
     *
     * layout: [ a: 0x20 | b: 0x40 | c: 0xa0 | d: 0x20 ]
     * a: space for 4 callee-save registers
     * b: small scratch space
     * c: space for stack arguments to c calls
     * d: reserve space for GPR registers to c calls (win64) or more space for
     * stack arguments (posix) */
    //| sub rsp, 0x100;
    dasm_put(Dst, 7);
#line 328 "src/jit/x64/emit.dasc"
    /* save callee-save registers */
    //| mov [rbp-0x8],  TC;
    //| mov [rbp-0x10], CU;
    //| mov [rbp-0x18], WORK;
    dasm_put(Dst, 16);
#line 332 "src/jit/x64/emit.dasc"
    /* setup special frame variables */
    //| mov TC,   ARG1;
    //| mov CU,   ARG2;
    //| mov TMP6, TC->cur_frame;
    //| mov WORK, FRAME:TMP6->work;
    dasm_put(Dst, 32, Dt25(->cur_frame), Dt2(->work));
#line 337 "src/jit/x64/emit.dasc"
    /* If in the future we call a function, the return address into the JIT
     * frame will be stored in this position. */
    if (!jg->no_trampoline) {
        //| lea rax, [rsp-0x8];
        //| mov aword TC->jit_return_address, rax;
        dasm_put(Dst, 49, Dt25(->jit_return_address));
#line 342 "src/jit/x64/emit.dasc"
    }
    /* ARG3 contains our 'entry label' */
    //| jmp ARG3
    dasm_put(Dst, 60);
#line 345 "src/jit/x64/emit.dasc"
}

/* And a function epilogue is also always the same */
void MVM_jit_emit_epilogue(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg) {
    //| ->exit:
    dasm_put(Dst, 64);
#line 350 "src/jit/x64/emit.dasc"
    /* clear the return address, so that we know there's no longer a JIT frame
     * on the stack */
    if (!jg->no_trampoline) {
        //| mov aword TC->jit_return_address, 0;
        dasm_put(Dst, 67, Dt25(->jit_return_address));
#line 354 "src/jit/x64/emit.dasc"
    }
    /* restore callee-save registers */
    //| mov TC, [rbp-0x8];
    //| mov CU, [rbp-0x10];
    //| mov WORK, [rbp-0x18];
    dasm_put(Dst, 76);
#line 359 "src/jit/x64/emit.dasc"
    /* Restore stack */
    //| mov rsp, rbp;
    //| pop rbp;
    //| ret;
    dasm_put(Dst, 92);
#line 363 "src/jit/x64/emit.dasc"
}

static MVMuint64 try_emit_gen2_ref(MVMThreadContext *tc, MVMJitCompiler *compiler,
                                   MVMJitGraph *jg, MVMObject *obj, MVMint16 reg) {
    if (!(obj->header.flags & MVM_CF_SECOND_GEN))
        return 0;
    //| mov64 TMP1, (uintptr_t)obj;
    //| mov WORK[reg], TMP1;
    dasm_put(Dst, 99, (unsigned int)((uintptr_t)obj), (unsigned int)(((uintptr_t)obj)>>32), Dt26([reg]));
#line 371 "src/jit/x64/emit.dasc"
    return 1;
}

static MVMint64 fits_in_32_bit(MVMint64 number) {
    /* Used to determine if a 64 bit integer can be safely used as a
     * 32 bit constant for immediate mode access */
    return (number >= INT32_MIN) && (number <= INT32_MAX);
}

static void emit_fastcreate(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                            MVMSpeshIns *ins) {
    MVMuint16 size     = ins->operands[1].lit_i16;
    MVMint16 spesh_idx = ins->operands[2].lit_i16;
    //| mov ARG1, TC;
    //| mov ARG2, size;
    //| callp &MVM_gc_allocate_nursery;
    dasm_put(Dst, 108, size);
    dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_allocate_nursery)), (MVMuint32)((uintptr_t)(&MVM_gc_allocate_nursery) >> 32));
#line 387 "src/jit/x64/emit.dasc"
    //| get_spesh_slot TMP1, spesh_idx;
    //| mov aword OBJECT:RV->st, TMP1;  // st is 64 bit (pointer)
    //| mov word OBJECT:RV->header.size, size; // object size is 16 bit
    //| mov TMP1d, dword TC->thread_id;  // thread id is 32 bit
    //| mov dword OBJECT:RV->header.owner, TMP1d; // does this even work?
    dasm_put(Dst, 124, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]), DtE(->st), DtE(->header.size), size, Dt25(->thread_id), DtE(->header.owner));
#line 392 "src/jit/x64/emit.dasc"
}

/* compile per instruction, can't really do any better yet */
void MVM_jit_emit_primitive(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                            MVMJitPrimitive * prim) {
    MVMSpeshIns *ins = prim->ins;
    MVMuint16 op = ins->info->opcode;
    /* Quite a few of these opcodes are copies. Ultimately, I want to
     * move copies to their own node (MVMJitCopy or such), and reduce
     * the number of copies (and thereby increase the efficiency), but
     * currently that isn't really feasible. */
    switch (op) {
    case MVM_OP_const_i64_16:
    case MVM_OP_const_i64_32: {
        MVMint32 reg = ins->operands[0].reg.orig;
        /* Upgrade to 64 bit */
        MVMint64 val = (op == MVM_OP_const_i64_16 ? (MVMint64)ins->operands[1].lit_i16 :
                        (MVMint64)ins->operands[1].lit_i32);
        //| mov qword WORK[reg], val;
        dasm_put(Dst, 158, Dt26([reg]), val);
#line 411 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_const_i64: {
        MVMint32 reg = ins->operands[0].reg.orig;
        MVMint64 val = ins->operands[1].lit_i64;
        //| mov64 TMP1, val;
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 99, (unsigned int)(val), (unsigned int)((val)>>32), Dt26([reg]));
#line 418 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_const_n64: {
        MVMint16 reg = ins->operands[0].reg.orig;
        MVMint64 valbytes = ins->operands[1].lit_i64;
        //| mov64 TMP1, valbytes;
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 99, (unsigned int)(valbytes), (unsigned int)((valbytes)>>32), Dt26([reg]));
#line 425 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_inf:
    case MVM_OP_neginf:
    case MVM_OP_nan: {
        MVMint16 reg = ins->operands[0].reg.orig;
        MVMRegister tmp;
        if (op == MVM_OP_nan)
            tmp.n64 = MVM_num_nan(tc);
        else if (op == MVM_OP_inf)
            tmp.n64 = MVM_num_posinf(tc);
        else if (op == MVM_OP_neginf)
            tmp.n64 = MVM_num_neginf(tc);
        //| mov64 TMP1, tmp.i64;
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 99, (unsigned int)(tmp.i64), (unsigned int)((tmp.i64)>>32), Dt26([reg]));
#line 440 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_const_s: {
         MVMint16 reg = ins->operands[0].reg.orig;
         MVMuint32 idx = ins->operands[1].lit_str_idx;
         MVMStaticFrame *sf = jg->sg->sf;
         MVMString * s = MVM_cu_string(tc, sf->body.cu, idx);
         if (!try_emit_gen2_ref(tc, compiler, jg, (MVMObject*)s, reg)) {
             //| get_string TMP1, idx;
              MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, idx);
#line 449 "src/jit/x64/emit.dasc"
             //| mov WORK[reg], TMP1;
             dasm_put(Dst, 164, Dt27(->body.strings), Dt15([idx]), Dt26([reg]));
#line 450 "src/jit/x64/emit.dasc"
         }
         break;
    }
    case MVM_OP_null: {
        MVMint16 reg = ins->operands[0].reg.orig;
        //| get_vmnull TMP1;
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 177, Dt25(->instance), DtC(->VMNull), Dt26([reg]));
#line 457 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getwhat:
    case MVM_OP_getwho: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[obj];
        //| mov TMP1, OBJECT:TMP1->st;
        dasm_put(Dst, 190, Dt26([obj]), DtE(->st));
#line 465 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_getwho) {
            //| mov TMP1, STABLE:TMP1->WHO;
            //| get_vmnull TMP2;
            //| test TMP1, TMP1;
            //| cmovz TMP1, TMP2;
            dasm_put(Dst, 199, Dt12(->WHO), Dt25(->instance), DtC(->VMNull));
#line 470 "src/jit/x64/emit.dasc"
        } else {
            //| mov TMP1, STABLE:TMP1->WHAT;
            dasm_put(Dst, 194, Dt12(->WHAT));
#line 472 "src/jit/x64/emit.dasc"
        }
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 103, Dt26([dst]));
#line 474 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getlex:
    case MVM_OP_sp_getlex_o:
    case MVM_OP_sp_getlex_ins: {
        MVMuint16 *lexical_types;
        MVMStaticFrame * sf = jg->sg->sf;
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 idx = ins->operands[1].lex.idx;
        MVMint16 out = ins->operands[1].lex.outers;
        MVMint16 i;
        //| mov TMP6, TC->cur_frame;
        dasm_put(Dst, 219, Dt25(->cur_frame));
#line 486 "src/jit/x64/emit.dasc"
        for (i = 0; i < out; i++) {
            /* I'm going to skip compiling the check whether the outer
             * node really exists, because if the code has run N times
             * correctly, then the outer frame must have existed then,
             * and since this chain is static, it should still exist
             * now.  If it doesn't exist, that means we crash.
             *
             * NB: inlining /might/ make this all wrong! But, if that
             * happens, the interpreter will panic even without JIT */
            //| mov TMP6, FRAME:TMP6->outer;
            dasm_put(Dst, 224, Dt2(->outer));
#line 496 "src/jit/x64/emit.dasc"
            sf = sf->body.outer;
        }
        /* get array of lexicals */
        //| mov TMP5, FRAME:TMP6->env;
        dasm_put(Dst, 229, Dt2(->env));
#line 500 "src/jit/x64/emit.dasc"
        /* read value */
        //| mov TMP5, REGISTER:TMP5[idx];
        dasm_put(Dst, 234, Dt1([idx]));
#line 502 "src/jit/x64/emit.dasc"
        /* it seems that if at runtime, if the outer frame has been inlined,
         * this /could/ be wrong. But if that is so, the interpreted instruction
         * would also be wrong, because it'd refer to the wrong lexical. */
        lexical_types = (!out && jg->sg->lexical_types ?
                         jg->sg->lexical_types :
                         sf->body.lexical_types);
        if (lexical_types[idx] == MVM_reg_obj) {
            /* if it is zero, check if we need to auto-vivify */
            //| test TMP5, TMP5;
            //| jnz >1;
            dasm_put(Dst, 239);
#line 512 "src/jit/x64/emit.dasc"
            /* setup args */
            //| mov ARG1, TC;
            //| mov ARG2, TMP6;
            //| mov ARG3, idx;
            //| callp &MVM_frame_vivify_lexical;
            dasm_put(Dst, 247, idx);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_vivify_lexical)), (MVMuint32)((uintptr_t)(&MVM_frame_vivify_lexical) >> 32));
            dasm_put(Dst, 260);
#line 517 "src/jit/x64/emit.dasc"
            /* use return value for the result */
            //| mov TMP5, RV;
            //|1:
            dasm_put(Dst, 266);
#line 520 "src/jit/x64/emit.dasc"
        }
        /* store the value */
        //| mov WORK[dst], TMP5;
        dasm_put(Dst, 272, Dt26([dst]));
#line 523 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_getlexvia_o:
    case MVM_OP_sp_getlexvia_ins: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 idx = ins->operands[1].lit_ui16;
        MVMint16 out = ins->operands[2].lit_ui16;
        MVMint16 via = ins->operands[3].reg.orig;
        MVMint16 i;
        /* Resolve the frame. */
        //| mov TMP6, WORK[via];
        //| mov TMP6, CODE:TMP6->body.outer;
        dasm_put(Dst, 277, Dt26([via]), Dt1D(->body.outer));
#line 535 "src/jit/x64/emit.dasc"
        for (i = 1; i < out; i++) /* From 1 as we are already at outer */
            //| mov TMP6, FRAME:TMP6->outer;
            dasm_put(Dst, 224, Dt2(->outer));
#line 537 "src/jit/x64/emit.dasc"
        /* get array of lexicals */
        //| mov TMP5, FRAME:TMP6->env;
        dasm_put(Dst, 229, Dt2(->env));
#line 539 "src/jit/x64/emit.dasc"
        /* read value */
        //| mov TMP5, REGISTER:TMP5[idx];
        dasm_put(Dst, 234, Dt1([idx]));
#line 541 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_getlexvia_o) {
            /* if it is zero, check if we need to auto-vivify */
            //| test TMP5, TMP5;
            //| jnz >1;
            dasm_put(Dst, 239);
#line 545 "src/jit/x64/emit.dasc"
            /* setup args */
            //| mov ARG1, TC;
            //| mov ARG2, TMP6;
            //| mov ARG3, idx;
            //| callp &MVM_frame_vivify_lexical;
            dasm_put(Dst, 247, idx);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_vivify_lexical)), (MVMuint32)((uintptr_t)(&MVM_frame_vivify_lexical) >> 32));
            dasm_put(Dst, 260);
#line 550 "src/jit/x64/emit.dasc"
            /* use return value for the result */
            //| mov TMP5, RV;
            //|1:
            dasm_put(Dst, 266);
#line 553 "src/jit/x64/emit.dasc"
        }
        /* store the value */
        //| mov WORK[dst], TMP5;
        dasm_put(Dst, 272, Dt26([dst]));
#line 556 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_bindlexvia_os:
    case MVM_OP_sp_bindlexvia_in: {
        MVMint16 idx = ins->operands[0].lit_ui16;
        MVMint16 out = ins->operands[1].lit_ui16;
        MVMint16 via = ins->operands[2].reg.orig;
        MVMint16 src = ins->operands[3].reg.orig;
        MVMint16 i;
        /* Resolve the frame. */
        //| mov TMP1, WORK[via];
        //| mov TMP1, CODE:TMP1->body.outer;
        dasm_put(Dst, 190, Dt26([via]), Dt1D(->body.outer));
#line 568 "src/jit/x64/emit.dasc"
        for (i = 1; i < out; i++) /* From 1 as we are already at outer */
            //| mov TMP1, FRAME:TMP1->outer;
            dasm_put(Dst, 194, Dt2(->outer));
#line 570 "src/jit/x64/emit.dasc"
        /* get array of lexicals */
        //| mov TMP2, FRAME:TMP1->env;
        dasm_put(Dst, 286, Dt2(->env));
#line 572 "src/jit/x64/emit.dasc"
        /* bind the lexical, and write barrier if needed */
        //| mov TMP3, WORK[src]
        //| mov REGISTER:TMP2[idx], TMP3;
        dasm_put(Dst, 291, Dt26([src]), Dt1([idx]));
#line 575 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_bindlexvia_os) {
            //| check_wb TMP1, TMP3, >2;
            //| hit_wb TMP1, TMP3;
            dasm_put(Dst, 300, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 578 "src/jit/x64/emit.dasc"
            //|2:
            dasm_put(Dst, 340);
#line 579 "src/jit/x64/emit.dasc"
        }
        break;
    }
    case MVM_OP_getlexreldyn: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 ctx  = ins->operands[1].reg.orig;
        MVMint16 name = ins->operands[2].reg.orig;
        //| mov TMP5, aword WORK[ctx];
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMContext;
        //| je >1;
        //| test_type_object TMP5;
        //| jz >1;
        //| throw_adhoc "getlexreldyn needs a context"
        dasm_put(Dst, 348, Dt26([ctx]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMContext, DtE(->header.flags), MVM_CF_TYPE_OBJECT, (unsigned int)((uintptr_t)("getlexreldyn needs a context")), (unsigned int)(((uintptr_t)("getlexreldyn needs a context"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 592 "src/jit/x64/emit.dasc"
        //|1:
        //| mov ARG2, TMP5
        //| mov ARG1, TC
        //| mov ARG3, aword WORK[name];
        //| callp &MVM_context_dynamic_lookup;
        dasm_put(Dst, 390, Dt26([name]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_context_dynamic_lookup)), (MVMuint32)((uintptr_t)(&MVM_context_dynamic_lookup) >> 32));
#line 597 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 598 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getlex_no:
    case MVM_OP_sp_getlex_no: {
        MVMint16  dst = ins->operands[0].reg.orig;
        MVMuint32 idx = ins->operands[1].lit_str_idx;
        //| mov ARG1, TC;
        //| get_string ARG2, idx;
        dasm_put(Dst, 420);
         MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, idx);
#line 606 "src/jit/x64/emit.dasc"
        //| mov ARG3, MVM_reg_obj;
        //| callp &MVM_frame_find_lexical_by_name;
        dasm_put(Dst, 425, Dt27(->body.strings), Dt15([idx]), MVM_reg_obj);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_find_lexical_by_name)), (MVMuint32)((uintptr_t)(&MVM_frame_find_lexical_by_name) >> 32));
#line 608 "src/jit/x64/emit.dasc"
        //| test RV, RV;
        //| jz >1;
        //| mov RV, [RV];
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| get_vmnull TMP3;
        //| mov WORK[dst], TMP3;
        //|2:
        dasm_put(Dst, 439, Dt26([dst]), Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 617 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_bindlex:
    case MVM_OP_sp_bindlex_os:
    case MVM_OP_sp_bindlex_in: {
        MVMuint16 *lexical_types;
        MVMStaticFrame *sf = jg->sg->sf;
        MVMint16 idx = ins->operands[0].lex.idx;
        MVMint16 out = ins->operands[0].lex.outers;
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 i;
        //| mov TMP1, TC->cur_frame;
        dasm_put(Dst, 479, Dt25(->cur_frame));
#line 629 "src/jit/x64/emit.dasc"
        for (i = 0; i < out; i++) {
            //| mov TMP1, FRAME:TMP1->outer;
            dasm_put(Dst, 194, Dt2(->outer));
#line 631 "src/jit/x64/emit.dasc"
            sf = sf->body.outer;
        }
        lexical_types = (!out && jg->sg->lexical_types ?
                         jg->sg->lexical_types :
                         sf->body.lexical_types);
        //| mov TMP2, FRAME:TMP1->env;
        //| mov TMP3, WORK[src];
        //| mov REGISTER:TMP2[idx], TMP3;
        dasm_put(Dst, 484, Dt2(->env), Dt26([src]), Dt1([idx]));
#line 639 "src/jit/x64/emit.dasc"
        if (lexical_types[idx] == MVM_reg_obj ||
            lexical_types[idx] == MVM_reg_str) {
            //| check_wb TMP1, TMP3, >2;
            //| hit_wb TMP1, TMP3;
            dasm_put(Dst, 300, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 643 "src/jit/x64/emit.dasc"
            //|2:
            dasm_put(Dst, 340);
#line 644 "src/jit/x64/emit.dasc"
        }
        break;
    }
    case MVM_OP_lexprimspec: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 ctx = ins->operands[1].reg.orig;
        MVMint16 name = ins->operands[2].reg.orig;
        //| mov TMP1, WORK[ctx];
        //| cmp_repr_id, TMP1, TMP2, MVM_REPR_ID_MVMContext;
        //| jne >1;
        //| test_type_object TMP1;
        //| jz >2;
        //|1:
        //| throw_adhoc "lexprimspec needs a context";
        dasm_put(Dst, 497, Dt26([ctx]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMContext, DtE(->header.flags), MVM_CF_TYPE_OBJECT, (unsigned int)((uintptr_t)("lexprimspec needs a context")), (unsigned int)(((uintptr_t)("lexprimspec needs a context"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 658 "src/jit/x64/emit.dasc"
        //|2:
        //| mov ARG2, CONTEXT:TMP1->body.context;
        //| mov ARG3, WORK[name];
        //| mov ARG1, TC;
        //| callp &MVM_frame_lexical_primspec;
        dasm_put(Dst, 539, Dt16(->body.context), Dt26([name]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_lexical_primspec)), (MVMuint32)((uintptr_t)(&MVM_frame_lexical_primspec) >> 32));
#line 663 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 664 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getarg_o:
    case MVM_OP_getarg_n:
    case MVM_OP_getarg_s:
    case MVM_OP_getarg_i: {
        MVMuint16 reg = ins->operands[0].reg.orig;
        MVMuint16 idx = ins->operands[1].reg.orig;
        //| mov TMP1, TC->cur_frame;
        //| mov TMP1, FRAME:TMP1->args;
        //| mov TMP1, REGISTER:TMP1[idx];
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 560, Dt25(->cur_frame), Dt2(->args), Dt1([idx]), Dt26([reg]));
#line 676 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_getarg_o:
    case MVM_OP_sp_getarg_n:
    case MVM_OP_sp_getarg_s:
    case MVM_OP_sp_getarg_i: {
        MVMint32 reg = ins->operands[0].reg.orig;
        MVMuint16 idx = ins->operands[1].callsite_idx;
        //| mov TMP1, TC->cur_frame;
        //| mov TMP1, FRAME:TMP1->params.args;
        //| mov TMP1, REGISTER:TMP1[idx];
        //| mov WORK[reg], TMP1;
        dasm_put(Dst, 560, Dt25(->cur_frame), Dt2(->params.args), Dt1([idx]), Dt26([reg]));
#line 688 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_p6oget_i:
    case MVM_OP_sp_p6oget_i32:
    case MVM_OP_sp_p6oget_n:
    case MVM_OP_sp_p6oget_s:
    case MVM_OP_sp_p6oget_bi:
    case MVM_OP_sp_p6oget_o:
    case MVM_OP_sp_p6ogetvc_o:
    case MVM_OP_sp_p6ogetvt_o:
    case MVM_OP_sp_getvc_o:
    case MVM_OP_sp_getvt_o: {
        MVMint16 dst    = ins->operands[0].reg.orig;
        MVMint16 obj    = ins->operands[1].reg.orig;
        MVMint16 body = offsetof(MVMP6opaque, body);
        MVMint16 offset = ins->operands[2].lit_i16;
        /* load address and object */
        //| mov TMP1, WORK[obj];
        dasm_put(Dst, 577, Dt26([obj]));
#line 706 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_getvc_o || op == MVM_OP_sp_getvt_o) {
            //| lea TMP2, [TMP1 + offset];
            dasm_put(Dst, 582, offset);
#line 708 "src/jit/x64/emit.dasc"
            body = 0; /* Offset is already from the start of the object */
        }
        else {
            //| lea TMP2, [TMP1 + (offset + body)];
            //| mov TMP4, P6OPAQUE:TMP1->body.replaced;
            //| lea TMP5, [TMP4 + offset];
            //| test TMP4, TMP4;
            //| cmovnz TMP2, TMP5;
            dasm_put(Dst, 587, (offset + body), Dt9(->body.replaced), offset);
#line 716 "src/jit/x64/emit.dasc"
        }
        /* TMP2 now contains address of item */
        if (op == MVM_OP_sp_p6oget_o) {
            //| mov TMP3, [TMP2];
            //| test TMP3, TMP3;
            dasm_put(Dst, 607);
#line 721 "src/jit/x64/emit.dasc"
            /* Check if object doesn't point to NULL */
            //| jnz >3;
            dasm_put(Dst, 614);
#line 723 "src/jit/x64/emit.dasc"
            /* Otherwise load VMNull */
            //| get_vmnull TMP3;
            //|3:
            dasm_put(Dst, 619, Dt25(->instance), DtC(->VMNull));
#line 726 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_sp_p6ogetvt_o || op == MVM_OP_sp_getvt_o) {
            /* vivify as type object */
            MVMint16 spesh_idx = ins->operands[3].lit_i16;
            MVMCollectable *spesh_value = jg->sg->spesh_slots[spesh_idx];
            //| mov TMP3, [TMP2];
            dasm_put(Dst, 630);
#line 731 "src/jit/x64/emit.dasc"
            /* check for null */
            //| test TMP3, TMP3;
            //| jnz >4;
            dasm_put(Dst, 634);
#line 734 "src/jit/x64/emit.dasc"
            /* if null, vivify as type object from spesh slot */
            //| get_spesh_slot TMP3, spesh_idx;
            dasm_put(Dst, 642, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]));
#line 736 "src/jit/x64/emit.dasc"
            if (!(spesh_value->flags & MVM_CF_SECOND_GEN)) {
                /* need to hit write barrier? */
                //| check_wb TMP1, TMP3, >3;
                //| mov qword [rbp-0x28], TMP2; // address
                //| mov qword [rbp-0x30], TMP3; // value
                //| hit_wb WORK[obj], TMP3; // write barrier for header
                dasm_put(Dst, 655, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN, Dt26([obj]));
                dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 742 "src/jit/x64/emit.dasc"
                //| mov TMP3, qword [rbp-0x30];
                //| mov TMP2, qword [rbp-0x28];
                //|3:
                dasm_put(Dst, 704);
#line 745 "src/jit/x64/emit.dasc"
            }
            /* store vivified type value in memory location */
            //| mov qword [TMP2], TMP3;
            //|4:
            dasm_put(Dst, 720);
#line 749 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_sp_p6ogetvc_o || op == MVM_OP_sp_getvc_o) {
            MVMint16 spesh_idx = ins->operands[3].lit_i16;
            //| mov TMP3, [TMP2];
            //| test TMP3, TMP3;
            //| jnz >4;
            dasm_put(Dst, 726);
#line 754 "src/jit/x64/emit.dasc"
            /* vivify as clone */
            //| mov ARG1, TC;
            //| get_spesh_slot ARG2, spesh_idx;
            //| callp &MVM_repr_clone;
            dasm_put(Dst, 737, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_repr_clone)), (MVMuint32)((uintptr_t)(&MVM_repr_clone) >> 32));
#line 758 "src/jit/x64/emit.dasc"
            //| mov TMP3, RV;
            dasm_put(Dst, 755);
#line 759 "src/jit/x64/emit.dasc"
            /* reload object and address */
            //| mov TMP1, WORK[obj];
            //| lea TMP2, [TMP1 + (offset + body)];
            //| mov TMP4, P6OPAQUE:TMP1->body.replaced;
            //| lea TMP5, [TMP4 + offset];
            //| test TMP4, TMP4;
            //| cmovnz TMP2, TMP5;
            dasm_put(Dst, 764, Dt26([obj]), (offset + body), Dt9(->body.replaced), offset);
#line 766 "src/jit/x64/emit.dasc"
            /* assign with write barrier */
            //| check_wb TMP1, TMP3, >3;
            //| mov qword [rbp-0x28], TMP2; // address
            //| mov qword [rbp-0x30], TMP3; // value
            //| hit_wb WORK[obj], TMP3; // write barrier for header
            dasm_put(Dst, 655, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN, Dt26([obj]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 771 "src/jit/x64/emit.dasc"
            //| mov TMP3, qword [rbp-0x30];
            //| mov TMP2, qword [rbp-0x28];
            //|3:
            //| mov qword [TMP2], TMP3;
            dasm_put(Dst, 788);
#line 775 "src/jit/x64/emit.dasc"
            /* done */
            //|4:
            dasm_put(Dst, 723);
#line 777 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_sp_p6oget_bi) {
            /* Big integer case */
            //| mov TMP4d, BIGINTBODY:TMP2->u.smallint.flag;
            //| cmp TMP4d, dword MVM_BIGINT_32_FLAG;
            //| jne >5;
            //| movsxd TMP3, dword BIGINTBODY:TMP2->u.smallint.value;
            //| jmp >6;
            //| 5:
            //| mov ARG1, TC;
            //| mov ARG2, TMP2;
            //| callp &MVM_p6bigint_get_int64;
            dasm_put(Dst, 807, Dt1E(->u.smallint.flag), MVM_BIGINT_32_FLAG, Dt1E(->u.smallint.value));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_p6bigint_get_int64)), (MVMuint32)((uintptr_t)(&MVM_p6bigint_get_int64) >> 32));
#line 788 "src/jit/x64/emit.dasc"
            //| mov TMP3, RV;
            //| 6:
            dasm_put(Dst, 839);
#line 790 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_sp_p6oget_i32) {
            //| movsxd TMP3, dword [TMP2];
            dasm_put(Dst, 850);
#line 792 "src/jit/x64/emit.dasc"
        }
        else {
            /* the regular case */
            //| mov TMP3, [TMP2];
            dasm_put(Dst, 630);
#line 796 "src/jit/x64/emit.dasc"
        }
        /* store in local register */
        //| mov WORK[dst], TMP3;
        dasm_put(Dst, 854, Dt26([dst]));
#line 799 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_bind_i64:
    case MVM_OP_sp_bind_i32:
    case MVM_OP_sp_bind_n:
    case MVM_OP_sp_bind_s:
    case MVM_OP_sp_bind_s_nowb:
    case MVM_OP_sp_bind_o: {
        MVMint16 obj    = ins->operands[0].reg.orig;
        MVMint16 offset = ins->operands[1].lit_i16;
        MVMint16 val    = ins->operands[2].reg.orig;
        //| mov TMP1, WORK[obj];            // object
        //| mov TMP2, WORK[val];            // value
        dasm_put(Dst, 859, Dt26([obj]), Dt26([val]));
#line 812 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_bind_o || op == MVM_OP_sp_bind_s) {
            /* check if we should hit write barrier */
            //| check_wb TMP1, TMP2, >2;
            dasm_put(Dst, 868, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN);
#line 815 "src/jit/x64/emit.dasc"
            /* note: it is uneccesary to store pointers, because they
               can just be loaded from memory */
            //| hit_wb WORK[obj], WORK[val];
            dasm_put(Dst, 896, Dt26([val]), Dt26([obj]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 818 "src/jit/x64/emit.dasc"
            //| mov TMP1, aword WORK[obj]; // reload object
            //| mov TMP2, aword WORK[val]; // reload value
            //|2: // done
            dasm_put(Dst, 910, Dt26([obj]), Dt26([val]));
#line 821 "src/jit/x64/emit.dasc"
        }
        if (op == MVM_OP_sp_bind_i32) {
            //| mov dword [TMP1+offset], TMP2d; // store value into body
            dasm_put(Dst, 926, offset);
#line 824 "src/jit/x64/emit.dasc"
        }
        else {
            //| mov qword [TMP1+offset], TMP2; // store value into body
            dasm_put(Dst, 930, offset);
#line 827 "src/jit/x64/emit.dasc"
        }
        break;
    }
    case MVM_OP_sp_get_i64:
    case MVM_OP_sp_get_n:
    case MVM_OP_sp_get_s: {
        MVMint16 dst    = ins->operands[0].reg.orig;
        MVMint16 obj    = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        //| mov TMP1, WORK[obj];             // object
        //| mov TMP2, qword [TMP1+offset];   // get value from body
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 935, Dt26([obj]), offset, Dt26([dst]));
#line 839 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_get_o: {
        MVMint16 dst    = ins->operands[0].reg.orig;
        MVMint16 obj    = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        //| mov TMP1, WORK[obj];             // object
        //| mov TMP2, qword [TMP1+offset];   // get value from body
        //| test TMP2, TMP2;
        //| jnz >1;
        //| get_vmnull TMP2;
        //|1:
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 948, Dt26([obj]), offset, Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 852 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_get_i32: {
        MVMint16 dst    = ins->operands[0].reg.orig;
        MVMint16 obj    = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        //| mov TMP1, WORK[obj];            // object
        //| mov RV, [TMP1+offset];   // get value from body
        //| cdqe;
        //| mov WORK[dst], RV;
        dasm_put(Dst, 978, Dt26([obj]), offset, Dt26([dst]));
#line 862 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_deref_bind_i64:
    case MVM_OP_sp_deref_bind_n: {
        MVMint16 obj    = ins->operands[0].reg.orig;
        MVMint16 val    = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        //| mov TMP1, WORK[obj];            // object
        //| mov TMP2, WORK[val];            // value
        //| mov TMP1, qword [TMP1+offset];  // find address of target
        //| mov qword [TMP1], TMP2;
        dasm_put(Dst, 993, Dt26([obj]), Dt26([val]), offset);
#line 873 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_deref_get_i64:
    case MVM_OP_sp_deref_get_n: {
        MVMint16 dst    = ins->operands[0].reg.orig;
        MVMint16 obj    = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        //| mov TMP1, WORK[obj];            // object
        //| mov TMP3, qword [TMP1+offset];  // get value pointer from body
        //| mov TMP2, qword [TMP3];         // deref the pointer
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1009, Dt26([obj]), offset, Dt26([dst]));
#line 884 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_p6obind_i:
    case MVM_OP_sp_p6obind_i32:
    case MVM_OP_sp_p6obind_n:
    case MVM_OP_sp_p6obind_s:
    case MVM_OP_sp_p6obind_o: {
        MVMint16 obj    = ins->operands[0].reg.orig;
        MVMint16 offset = ins->operands[1].lit_i16;
        MVMint16 val    = ins->operands[2].reg.orig;
        //| mov TMP1, WORK[obj];            // object
        //| mov TMP2, WORK[val];            // value
        //| lea TMP3, P6OPAQUE:TMP1->body;  // body
        //| cmp qword P6OBODY:TMP3->replaced, 0;
        //| je >1;
        //| mov TMP3, P6OBODY:TMP3->replaced; // replaced object body
        //|1:
        dasm_put(Dst, 1025, Dt26([obj]), Dt26([val]), Dt9(->body), DtA(->replaced), DtA(->replaced));
#line 901 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_p6obind_o || op == MVM_OP_sp_p6obind_s) {
            /* check if we should hit write barrier */
            //| check_wb TMP1, TMP2, >2;
            //| mov qword [rbp-0x28], TMP2; // store value
            //| mov qword [rbp-0x30], TMP3; // store body pointer
            //| hit_wb WORK[obj], WORK[val];
            dasm_put(Dst, 1053, Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN, Dt26([val]), Dt26([obj]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 907 "src/jit/x64/emit.dasc"
            //| mov TMP3, qword [rbp-0x30]; // restore body pointer
            //| mov TMP2, qword [rbp-0x28]; // restore value
            //|2: // done
            dasm_put(Dst, 1102);
#line 910 "src/jit/x64/emit.dasc"
        }
        if (op == MVM_OP_sp_p6obind_i32) {
            //| mov dword [TMP3+offset], TMP2d; // store value into body
            dasm_put(Dst, 1118, offset);
#line 913 "src/jit/x64/emit.dasc"
        }
        else {
            //| mov [TMP3+offset], TMP2; // store value into body
            dasm_put(Dst, 1123, offset);
#line 916 "src/jit/x64/emit.dasc"
        }
        break;
    }
    case MVM_OP_getwhere:
    case MVM_OP_set: {
         MVMint32 reg1 = ins->operands[0].reg.orig;
         MVMint32 reg2 = ins->operands[1].reg.orig;
         //| mov TMP1, WORK[reg2];
         //| mov WORK[reg1], TMP1;
         dasm_put(Dst, 1128, Dt26([reg2]), Dt26([reg1]));
#line 925 "src/jit/x64/emit.dasc"
         break;
    }
    case MVM_OP_sp_getspeshslot: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 spesh_idx = ins->operands[1].lit_i16;
        //| get_spesh_slot TMP1, spesh_idx;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 560, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]), Dt26([dst]));
#line 932 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_setdispatcher: {
        MVMint16 src = ins->operands[0].reg.orig;
        //| mov TMP1, aword WORK[src];
        //| mov aword TC->cur_dispatcher, TMP1;
        dasm_put(Dst, 1137, Dt26([src]), Dt25(->cur_dispatcher));
#line 938 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_takedispatcher: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, aword TC->cur_dispatcher;
        //| cmp TMP1, 0;
        //| je >2;
        //| mov TMP2, aword TC->cur_dispatcher_for;
        //| cmp TMP2, 0;
        //| je >1;
        //| mov TMP3, TC->cur_frame;
        //| mov TMP3, FRAME:TMP3->code_ref;
        //| cmp TMP2, TMP3;
        //| jne >2;
        //|1:
        //| mov aword WORK[dst], TMP1;
        //| mov aword TC->cur_dispatcher, NULL;
        //| jmp >3;
        //|2:
        //| get_vmnull TMP1;
        //| mov aword WORK[dst], TMP1;
        //|3:
        dasm_put(Dst, 1146, Dt25(->cur_dispatcher), Dt25(->cur_dispatcher_for), Dt25(->cur_frame), Dt2(->code_ref), Dt26([dst]), Dt25(->cur_dispatcher), NULL, Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 960 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_takenextdispatcher: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, aword TC->next_dispatcher;
        //| cmp TMP1, 0;
        //| je >2;
        //| mov TMP2, aword TC->next_dispatcher_for;
        //| cmp TMP2, 0;
        //| je >1;
        //| mov TMP3, TC->cur_frame;
        //| mov TMP3, FRAME:TMP3->code_ref;
        //| cmp TMP2, TMP3;
        //| jne >2;
        //|1:
        //| mov aword WORK[dst], TMP1;
        //| mov aword TC->next_dispatcher, NULL;
        //| jmp >3;
        //|2:
        //| get_vmnull TMP1;
        //| mov aword WORK[dst], TMP1;
        //|3:
        dasm_put(Dst, 1146, Dt25(->next_dispatcher), Dt25(->next_dispatcher_for), Dt25(->cur_frame), Dt2(->code_ref), Dt26([dst]), Dt25(->next_dispatcher), NULL, Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 982 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_nextdispatcherfor: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[src];
        //| mov TMP2, aword WORK[dst];
        //| mov aword TC->next_dispatcher, TMP2;
        //| cmp_repr_id TMP1, TMP3, MVM_REPR_ID_MVMCode;
        //| je >2;
        //|1:
        dasm_put(Dst, 1219, Dt26([src]), Dt26([dst]), Dt25(->next_dispatcher), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCode);
#line 993 "src/jit/x64/emit.dasc"
	/* On Windows TMP1 is ARG1, so read it before overwriting it! */
        //| mov ARG2, TMP1;
        //| mov ARG1, TC;
        //| xor ARG3, ARG3;
        //| callp &MVM_frame_find_invokee;
        dasm_put(Dst, 1251);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee)), (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee) >> 32));
#line 998 "src/jit/x64/emit.dasc"
        //| mov aword TC->next_dispatcher_for, RV;
        //| jmp >3;
        //|2:
        //| mov aword TC->next_dispatcher_for, TMP1;
        //| jmp >3;
        //|3:
        dasm_put(Dst, 1263, Dt25(->next_dispatcher_for), Dt25(->next_dispatcher_for));
#line 1004 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_ctx: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, TC->cur_frame;
        //| callp &MVM_context_from_frame;
        dasm_put(Dst, 1289, Dt25(->cur_frame));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_context_from_frame)), (MVMuint32)((uintptr_t)(&MVM_context_from_frame) >> 32));
#line 1011 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 1012 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_ctxlexpad: {
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, WORK[src];
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMContext;
        //| je >2;
        //|1:
        //| throw_adhoc "ctxlexpad needs an MVMContext";
        dasm_put(Dst, 1299, Dt26([src]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMContext, (unsigned int)((uintptr_t)("ctxlexpad needs an MVMContext")), (unsigned int)(((uintptr_t)("ctxlexpad needs an MVMContext"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1024 "src/jit/x64/emit.dasc"
        //|2:
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 1341, Dt26([dst]));
#line 1026 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_ctxcallerskipthunks: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 ctx = ins->operands[1].reg.orig;
        /* ctx = NULL */
        //| xor RV, RV;
        //| mov TMP5, aword WORK[ctx];
        dasm_put(Dst, 1353, Dt26([ctx]));
#line 1034 "src/jit/x64/emit.dasc"
        /* check concrete instance of type or throw */
        //| test_type_object TMP5;
        //| jnz >1;
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMContext;
        //| jne >1;
        dasm_put(Dst, 1361, DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMContext);
#line 1039 "src/jit/x64/emit.dasc"
        /* Call function to create context. */
        //| mov ARG1, TC
        //| mov ARG2, TMP5
        //| mov ARG3, MVM_CTX_TRAV_CALLER_SKIP_THUNKS
        //| callp &MVM_context_apply_traversal;
        dasm_put(Dst, 1390, MVM_CTX_TRAV_CALLER_SKIP_THUNKS);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_context_apply_traversal)), (MVMuint32)((uintptr_t)(&MVM_context_apply_traversal) >> 32));
#line 1044 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| throw_adhoc "ctxcallerskipthunks needs an MVMContext";
        dasm_put(Dst, 1403, Dt26([dst]), (unsigned int)((uintptr_t)("ctxcallerskipthunks needs an MVMContext")), (unsigned int)(((uintptr_t)("ctxcallerskipthunks needs an MVMContext"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1048 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1049 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_curcode: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, TC->cur_frame;
        //| mov TMP1, aword FRAME:TMP1->code_ref;
        //| mov aword WORK[dst], TMP1;
        dasm_put(Dst, 177, Dt25(->cur_frame), Dt2(->code_ref), Dt26([dst]));
#line 1056 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getcode: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMuint16 idx = ins->operands[1].coderef_idx;
        //| mov TMP1, aword CU->body.coderefs;
        //| mov TMP1, aword OBJECTPTR:TMP1[idx];
        //| mov aword WORK[dst], TMP1;
        dasm_put(Dst, 164, Dt27(->body.coderefs), Dt15([idx]), Dt26([dst]));
#line 1064 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_hllboxtype_n:
    case MVM_OP_hllboxtype_s:
    case MVM_OP_hllboxtype_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, CU->body.hll_config;
        dasm_put(Dst, 1428, Dt27(->body.hll_config));
#line 1071 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_hllboxtype_n) {
            //| mov TMP1, aword HLLCONFIG:TMP1->num_box_type;
            dasm_put(Dst, 194, Dt19(->num_box_type));
#line 1073 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_hllboxtype_s) {
            //| mov TMP1, aword HLLCONFIG:TMP1->str_box_type;
            dasm_put(Dst, 194, Dt19(->str_box_type));
#line 1075 "src/jit/x64/emit.dasc"
        } else {
            //| mov TMP1, aword HLLCONFIG:TMP1->int_box_type;
            dasm_put(Dst, 194, Dt19(->int_box_type));
#line 1077 "src/jit/x64/emit.dasc"
        }
        //| mov aword WORK[dst], TMP1;
        dasm_put(Dst, 103, Dt26([dst]));
#line 1079 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_null_s: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov qword WORK[dst], 0;
        dasm_put(Dst, 1433, Dt26([dst]));
#line 1084 "src/jit/x64/emit.dasc"
        break;
     }
    case MVM_OP_isnull_s: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| test TMP1, TMP1;
        //| setz TMP2b;
        //| movzx TMP2, TMP2b;
        //| mov qword WORK[dst], TMP2;
        dasm_put(Dst, 1442, Dt26([src]), Dt26([dst]));
#line 1094 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_captureposarg: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 pos = ins->operands[2].reg.orig;
        //| mov TMP5, qword WORK[src];
        //| test_type_object TMP5;
        //| jnz >1;
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMCallCapture;
        //| jne >1;
        //| mov ARG1, TC;
        //| mov ARG2, aword CAPTURE:TMP5->body.apc;
        //| mov ARG3, WORK[pos];
        //| callp &MVM_args_get_required_pos_obj;
        dasm_put(Dst, 1461, Dt26([src]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, Dt5(->body.apc), Dt26([pos]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_obj)), (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_obj) >> 32));
#line 1109 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| throw_adhoc "captureposarg needs a MVMCallCapture";
        dasm_put(Dst, 1403, Dt26([dst]), (unsigned int)((uintptr_t)("captureposarg needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("captureposarg needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1113 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1114 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_captureposarg_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 pos = ins->operands[2].reg.orig;
        //| mov TMP5, qword WORK[src];
        //| test_type_object TMP5;
        //| jnz >1;
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMCallCapture;
        //| jne >1;
        //| mov ARG1, TC;
        //| mov ARG2, aword CAPTURE:TMP5->body.apc;
        //| mov ARG3, qword WORK[pos];
        //| callp &MVM_args_get_required_pos_int;
        dasm_put(Dst, 1461, Dt26([src]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, Dt5(->body.apc), Dt26([pos]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_int)), (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_int) >> 32));
#line 1129 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| throw_adhoc "captureposarg_i needs a MVMCallCapture";
        dasm_put(Dst, 1403, Dt26([dst]), (unsigned int)((uintptr_t)("captureposarg_i needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("captureposarg_i needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1133 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1134 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_captureposarg_n: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 pos = ins->operands[2].reg.orig;
        //| mov TMP5, qword WORK[src];
        //| test_type_object TMP5;
        //| jnz >1;
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMCallCapture;
        //| jne >1;
        //| mov ARG1, TC;
        //| mov ARG2, aword CAPTURE:TMP5->body.apc;
        //| mov ARG3, qword WORK[pos];
        //| callp &MVM_args_get_required_pos_num;
        dasm_put(Dst, 1461, Dt26([src]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, Dt5(->body.apc), Dt26([pos]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_num)), (MVMuint32)((uintptr_t)(&MVM_args_get_required_pos_num) >> 32));
#line 1149 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| throw_adhoc "captureposarg_n needs a MVMCallCapture";
        dasm_put(Dst, 1403, Dt26([dst]), (unsigned int)((uintptr_t)("captureposarg_n needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("captureposarg_n needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1153 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1154 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_captureposarg_s: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        MVMint16 pos = ins->operands[2].reg.orig;
        //| mov TMP5, qword WORK[src];
        //| test_type_object TMP5;
        //| jnz >1;
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_MVMCallCapture;
        //| jne >1;
        //| mov ARG1, TC;
        //| mov ARG2, aword CAPTURE:TMP5->body.apc;
        //| mov ARG3, aword WORK[pos];
        //| callp MVM_args_get_required_pos_str;
        dasm_put(Dst, 1461, Dt26([src]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, Dt5(->body.apc), Dt26([pos]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(MVM_args_get_required_pos_str)), (MVMuint32)((uintptr_t)(MVM_args_get_required_pos_str) >> 32));
#line 1169 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        //| jmp >2;
        //|1:
        //| throw_adhoc "captureposarg_s needs a MVMCallCapture";
        dasm_put(Dst, 1403, Dt26([dst]), (unsigned int)((uintptr_t)("captureposarg_s needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("captureposarg_s needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1173 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1174 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_add_i:
    case MVM_OP_sub_i:
    case MVM_OP_bor_i:
    case MVM_OP_band_i:
    case MVM_OP_bxor_i: {
        MVMint32 reg_a = ins->operands[0].reg.orig;
        MVMint32 reg_b = ins->operands[1].reg.orig;
        MVMint32 reg_c = ins->operands[2].reg.orig;

        MVMSpeshFacts *operand_facts = MVM_spesh_get_facts(tc, jg->sg, ins->operands[2]);

        if (reg_a == reg_b) {
            if (operand_facts->flags & MVM_SPESH_FACT_KNOWN_VALUE &&
                fits_in_32_bit(operand_facts->value.i)) {
                MVMint64 value = operand_facts->value.i;
                MVM_spesh_graph_add_comment(tc, jg->sg, ins, "JIT optimized to memory/constant operation");
                switch(ins->info->opcode) {
                case MVM_OP_add_i:
                    //| add qword WORK[reg_a], qword value;
                    dasm_put(Dst, 1507, Dt26([reg_a]), value);
#line 1195 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_sub_i:
                    //| sub qword WORK[reg_a], qword value;
                    dasm_put(Dst, 1513, Dt26([reg_a]), value);
#line 1198 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bor_i:
                    //| or qword WORK[reg_a], qword value;
                    dasm_put(Dst, 1519, Dt26([reg_a]), value);
#line 1201 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_band_i:
                    //| and qword WORK[reg_a], qword value;
                    dasm_put(Dst, 1525, Dt26([reg_a]), value);
#line 1204 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bxor_i:
                    //| xor qword WORK[reg_a], qword value;
                    dasm_put(Dst, 1531, Dt26([reg_a]), value);
#line 1207 "src/jit/x64/emit.dasc"
                    break;
                }
            } else {
                MVM_spesh_graph_add_comment(tc, jg->sg, ins, "JIT optimized to memory/register operation");
                //| mov rax, WORK[reg_c];
                dasm_put(Dst, 1537, Dt26([reg_c]));
#line 1212 "src/jit/x64/emit.dasc"
                switch(ins->info->opcode) {
                case MVM_OP_add_i:
                    //| add WORK[reg_a], rax;
                    dasm_put(Dst, 1542, Dt26([reg_a]));
#line 1215 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_sub_i:
                    //| sub WORK[reg_a], rax;
                    dasm_put(Dst, 1547, Dt26([reg_a]));
#line 1218 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bor_i:
                    //| or WORK[reg_a], rax;
                    dasm_put(Dst, 1552, Dt26([reg_a]));
#line 1221 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_band_i:
                    //| and WORK[reg_a], rax;
                    dasm_put(Dst, 1557, Dt26([reg_a]));
#line 1224 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bxor_i:
                    //| xor WORK[reg_a], rax;
                    dasm_put(Dst, 1562, Dt26([reg_a]));
#line 1227 "src/jit/x64/emit.dasc"
                    break;
                }
            }
        } else {
            if (operand_facts->flags & MVM_SPESH_FACT_KNOWN_VALUE &&
                fits_in_32_bit(operand_facts->value.i)) {
                MVMint64 value = operand_facts->value.i;
                MVM_spesh_graph_add_comment(tc, jg->sg, ins, "JIT optimized to register/constant operation");
                //| mov rax, WORK[reg_b];
                dasm_put(Dst, 1537, Dt26([reg_b]));
#line 1236 "src/jit/x64/emit.dasc"
                switch(ins->info->opcode) {
                case MVM_OP_add_i:
                    //| add rax, qword value;
                    dasm_put(Dst, 1567, value);
#line 1239 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_sub_i:
                    //| sub rax, qword value;
                    dasm_put(Dst, 1572, value);
#line 1242 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bor_i:
                    //| or rax, qword value;
                    dasm_put(Dst, 1578, value);
#line 1245 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_band_i:
                    //| and rax, qword value;
                    dasm_put(Dst, 1583, value);
#line 1248 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bxor_i:
                    //| xor rax, qword value;
                    dasm_put(Dst, 1588, value);
#line 1251 "src/jit/x64/emit.dasc"
                    break;
                }
                //| mov WORK[reg_a], rax;
                dasm_put(Dst, 415, Dt26([reg_a]));
#line 1254 "src/jit/x64/emit.dasc"
            } else {
                //| mov rax, WORK[reg_b];
                dasm_put(Dst, 1537, Dt26([reg_b]));
#line 1256 "src/jit/x64/emit.dasc"
                switch(ins->info->opcode) {
                case MVM_OP_add_i:
                    //| add rax, WORK[reg_c];
                    dasm_put(Dst, 1594, Dt26([reg_c]));
#line 1259 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_sub_i:
                    //| sub rax, WORK[reg_c];
                    dasm_put(Dst, 1599, Dt26([reg_c]));
#line 1262 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bor_i:
                    //| or rax, WORK[reg_c];
                    dasm_put(Dst, 1604, Dt26([reg_c]));
#line 1265 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_band_i:
                    //| and rax, WORK[reg_c];
                    dasm_put(Dst, 1609, Dt26([reg_c]));
#line 1268 "src/jit/x64/emit.dasc"
                    break;
                case MVM_OP_bxor_i:
                    //| xor rax, WORK[reg_c];
                    dasm_put(Dst, 1614, Dt26([reg_c]));
#line 1271 "src/jit/x64/emit.dasc"
                    break;
                }
                //| mov WORK[reg_a], rax;
                dasm_put(Dst, 415, Dt26([reg_a]));
#line 1274 "src/jit/x64/emit.dasc"
            }
        }
        break;
    }
    case MVM_OP_mul_i:
    case MVM_OP_blshift_i:
    case MVM_OP_brshift_i: {
        MVMint32 reg_a = ins->operands[0].reg.orig;
        MVMint32 reg_b = ins->operands[1].reg.orig;
        MVMint32 reg_c = ins->operands[2].reg.orig;
        //| mov rax, WORK[reg_b];
        dasm_put(Dst, 1537, Dt26([reg_b]));
#line 1285 "src/jit/x64/emit.dasc"
        switch(ins->info->opcode) {
        case MVM_OP_mul_i:
            //| imul rax, WORK[reg_c];
            dasm_put(Dst, 1619, Dt26([reg_c]));
#line 1288 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_blshift_i:
            //| mov cl, byte WORK[reg_c];
            //| shl rax, cl;
            dasm_put(Dst, 1625, Dt26([reg_c]));
#line 1292 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_brshift_i:
            //| mov cl, byte WORK[reg_c];
            //| sar rax, cl;
            dasm_put(Dst, 1632, Dt26([reg_c]));
#line 1296 "src/jit/x64/emit.dasc"
            break;
        }
        //| mov WORK[reg_a], rax;
        dasm_put(Dst, 415, Dt26([reg_a]));
#line 1299 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_pow_i: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 base = ins->operands[1].reg.orig;
        MVMint16 exp  = ins->operands[2].reg.orig;
        //| xor rax, rax;
        //| mov rcx, WORK[exp];
        //| cmp rcx, rax;
        //| jl >3;
        //| inc rax;
        //| mov r8, WORK[base];
        //|1:
        //| test rcx, 1;
        //| jz >2;
        //| imul r8;
        //|2:
        //| imul r8, r8;
        //| shr rcx, 1;
        //| jnz <1;
        //|3:
        //| mov WORK[dst], rax;
        dasm_put(Dst, 1640, Dt26([exp]), Dt26([base]), Dt26([dst]));
#line 1321 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_div_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 a   = ins->operands[1].reg.orig;
        MVMint16 b   = ins->operands[2].reg.orig;
        //| mov rax, WORK[a];
        //| mov rcx, WORK[b];
        //| cmp rcx, 0;
        //| jnz >1;
        //| throw_adhoc "Division by zero";
        dasm_put(Dst, 1702, Dt26([a]), Dt26([b]), (unsigned int)((uintptr_t)("Division by zero")), (unsigned int)(((uintptr_t)("Division by zero"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1332 "src/jit/x64/emit.dasc"
        //|1:
        dasm_put(Dst, 1729);
#line 1333 "src/jit/x64/emit.dasc"
        /* either num < 0, or denom < 0, but not both */
        //| setl dh;
        //| cmp rax, 0;
        //| setl dl;
        //| xor dl, dh;
        //| movzx r8d, dl;
        //| cqo;
        //| idiv rcx;
        //| test rdx, rdx;
        //| setnz cl;
        //| and r8b, cl;
        dasm_put(Dst, 1737);
#line 1344 "src/jit/x64/emit.dasc"
        /* r8 = bias = (modulo != 0) & ((num < 0) ^ (denom < 0)) */
        //| sub rax, r8;
        //| mov WORK[dst], rax;
        dasm_put(Dst, 1772, Dt26([dst]));
#line 1347 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_mod_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 a   = ins->operands[1].reg.orig;
        MVMint16 b   = ins->operands[2].reg.orig;
        //| mov rax, WORK[a];
        //| mov rcx, WORK[b];
        //| cmp rcx, 0;
        //| jnz >1;
        //| throw_adhoc "Division by zero";
        dasm_put(Dst, 1702, Dt26([a]), Dt26([b]), (unsigned int)((uintptr_t)("Division by zero")), (unsigned int)(((uintptr_t)("Division by zero"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1358 "src/jit/x64/emit.dasc"
        //|1:
        //| cqo;
        //| idiv rcx;
        //| mov WORK[dst], rdx;
        dasm_put(Dst, 1780, Dt26([dst]));
#line 1362 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_inc_i: {
         MVMint32 reg = ins->operands[0].reg.orig;
         //| add qword WORK[reg], 1;
         dasm_put(Dst, 1799, Dt26([reg]));
#line 1367 "src/jit/x64/emit.dasc"
         break;
    }
    case MVM_OP_dec_i: {
        MVMint32 reg = ins->operands[0].reg.orig;
        //| sub qword WORK[reg], 1;
        dasm_put(Dst, 1805, Dt26([reg]));
#line 1372 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_bnot_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| not TMP1;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 1811, Dt26([src]), Dt26([dst]));
#line 1380 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_neg_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| neg TMP1;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 1824, Dt26([src]), Dt26([dst]));
#line 1388 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_i8: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov RV, WORK[src];
        //| cbw;
        //| cwde;
        //| cdqe;
        //| mov WORK[dst], RV;
        dasm_put(Dst, 1837, Dt26([src]), Dt26([dst]));
#line 1398 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_u8: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| xor TMP2, TMP2;
        //| mov TMP2b, TMP1b;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1851, Dt26([src]), Dt26([dst]));
#line 1407 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_i16: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov RV, WORK[src];
        //| cwde;
        //| cdqe;
        //| mov WORK[dst], RV;
        dasm_put(Dst, 1865, Dt26([src]), Dt26([dst]));
#line 1416 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_u16: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| xor TMP2, TMP2;
        //| mov TMP2w, TMP1w;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1877, Dt26([src]), Dt26([dst]));
#line 1425 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_i32: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov RV, WORK[src];
        //| cdqe;
        //| mov WORK[dst], RV;
        dasm_put(Dst, 1892, Dt26([src]), Dt26([dst]));
#line 1433 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_extend_u32: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| mov TMP2d, TMP1d;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 1903, Dt26([src]), Dt26([dst]));
#line 1441 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_trunc_u8:
    case MVM_OP_trunc_i8: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| xor TMP2, TMP2;
        //| mov TMP2b, TMP1b;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1851, Dt26([src]), Dt26([dst]));
#line 1451 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_trunc_u16:
    case MVM_OP_trunc_i16: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| xor TMP2, TMP2;
        //| mov TMP2w, TMP1w;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1877, Dt26([src]), Dt26([dst]));
#line 1461 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_trunc_u32:
    case MVM_OP_trunc_i32: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        dasm_put(Dst, 577, Dt26([src]));
#line 1468 "src/jit/x64/emit.dasc"
        /* x86-64 auto-truncates the upper 32 bits when using registers in 32
         * bit mode */
        //| mov TMP2d, TMP1d;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1885, Dt26([dst]));
#line 1472 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_add_n:
    case MVM_OP_sub_n:
    case MVM_OP_mul_n:
    case MVM_OP_div_n: {
        MVMint16 reg_a = ins->operands[0].reg.orig;
        MVMint16 reg_b = ins->operands[1].reg.orig;
        MVMint16 reg_c = ins->operands[2].reg.orig;
        /* Copying data to xmm (floating point) registers requires
         * a special move instruction */
        //| movsd xmm0, qword WORK[reg_b];
        dasm_put(Dst, 1914, Dt26([reg_b]));
#line 1484 "src/jit/x64/emit.dasc"
        switch(ins->info->opcode) {
        case MVM_OP_add_n:
            //| addsd xmm0, qword WORK[reg_c];
            dasm_put(Dst, 1921, Dt26([reg_c]));
#line 1487 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_sub_n:
            //| subsd xmm0, qword WORK[reg_c];
            dasm_put(Dst, 1928, Dt26([reg_c]));
#line 1490 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_mul_n:
            //| mulsd xmm0, qword WORK[reg_c];
            dasm_put(Dst, 1935, Dt26([reg_c]));
#line 1493 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_div_n:
            //| divsd xmm0, qword WORK[reg_c];
            dasm_put(Dst, 1942, Dt26([reg_c]));
#line 1496 "src/jit/x64/emit.dasc"
            break;
        }
        //| movsd qword WORK[reg_a], xmm0;
        dasm_put(Dst, 1949, Dt26([reg_a]));
#line 1499 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_coerce_iu:
    case MVM_OP_coerce_ui: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 1128, Dt26([src]), Dt26([dst]));
#line 1507 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_coerce_in: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        /* convert simple integer to double precision */
        //| cvtsi2sd xmm0, qword WORK[src];
        //| movsd qword WORK[dst], xmm0;
        dasm_put(Dst, 1956, Dt26([src]), Dt26([dst]));
#line 1515 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_coerce_ni: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        /* convert double precision to simple intege */
        //| cvttsd2si rax, qword WORK[src];
        //| mov WORK[dst], rax;
        dasm_put(Dst, 1970, Dt26([src]), Dt26([dst]));
#line 1523 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_neg_n: {
        /* Negation is xor-ing the highest byte. Pretty simple right */
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, 1;
        //| sal TMP1, 63;
        //| mov TMP2, qword WORK[src];
        //| xor TMP2, TMP1;
        //| mov qword WORK[dst], TMP2;
        dasm_put(Dst, 1982, Dt26([src]), Dt26([dst]));
#line 1534 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_eq_i:
    case MVM_OP_eqaddr:
    case MVM_OP_ne_i:
    case MVM_OP_lt_i:
    case MVM_OP_le_i:
    case MVM_OP_gt_i:
    case MVM_OP_ge_i: {
        MVMint32 reg_a = ins->operands[0].reg.orig;
        MVMint32 reg_b = ins->operands[1].reg.orig;
        MVMint32 reg_c = ins->operands[2].reg.orig;
        //| mov rax, WORK[reg_b];
        dasm_put(Dst, 1537, Dt26([reg_b]));
#line 1547 "src/jit/x64/emit.dasc"
        /* comparison result in the setting bits in the rflags register */
        //| cmp rax, WORK[reg_c];
        dasm_put(Dst, 2005, Dt26([reg_c]));
#line 1549 "src/jit/x64/emit.dasc"
        /* copy the right comparison bit to the lower byte of the rax
           register */
        switch(ins->info->opcode) {
        case MVM_OP_eqaddr:
        case MVM_OP_eq_i:
            //| sete al;
            dasm_put(Dst, 2010);
#line 1555 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_ne_i:
            //| setne al;
            dasm_put(Dst, 2014);
#line 1558 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_lt_i:
            //| setl al;
            dasm_put(Dst, 2018);
#line 1561 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_le_i:
            //| setle al;
            dasm_put(Dst, 2022);
#line 1564 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_gt_i:
            //| setg al;
            dasm_put(Dst, 2026);
#line 1567 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_ge_i:
            //| setge al;
            dasm_put(Dst, 2030);
#line 1570 "src/jit/x64/emit.dasc"
            break;
        }
        /* zero extend al (lower byte) to rax (whole register) */
        //| movzx rax, al;
        //| mov WORK[reg_a], rax;
        dasm_put(Dst, 2034, Dt26([reg_a]));
#line 1575 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_cmp_i : {
        MVMint32 reg_a = ins->operands[0].reg.orig;
        MVMint32 reg_b = ins->operands[1].reg.orig;
        MVMint32 reg_c = ins->operands[2].reg.orig;
        //| mov TMP1, WORK[reg_b];
        dasm_put(Dst, 577, Dt26([reg_b]));
#line 1582 "src/jit/x64/emit.dasc"
        /* comparison result in the setting bits in the rflags register */
        //| cmp TMP1, WORK[reg_c];
        dasm_put(Dst, 2043, Dt26([reg_c]));
#line 1584 "src/jit/x64/emit.dasc"
        /* copy the right comparison bit to the lower byte of the rax
           register */
        //| setg TMP2b;
        //| movzx TMP2, TMP2b;
        //| setl TMP3b;
        //| movzx TMP3, TMP3b;
        //| sub TMP2, TMP3;
        //| mov WORK[reg_a], TMP2;
        dasm_put(Dst, 2048, Dt26([reg_a]));
#line 1592 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_gt_s:
    case MVM_OP_ge_s:
    case MVM_OP_lt_s:
    case MVM_OP_le_s: {
        /* src/jit/graph.c already put a call to the MVM_string_compare
           function into the graph, so here we just have to deal with the
           returned integers. */
        MVMint32 reg = ins->operands[0].reg.orig;
        switch(ins->info->opcode) {
            case MVM_OP_gt_s:
                //| mov TMP2, 1;
                dasm_put(Dst, 2071);
#line 1605 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_lt_s:
                //| mov TMP2, -1;
                dasm_put(Dst, 2079);
#line 1608 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_ge_s: case MVM_OP_le_s:
                //| mov TMP2, 0;
                dasm_put(Dst, 2091);
#line 1611 "src/jit/x64/emit.dasc"
                break;
        }
        //| cmp TMP2, WORK[reg];
        dasm_put(Dst, 2099, Dt26([reg]));
#line 1614 "src/jit/x64/emit.dasc"
        /* Mind the reversedness of the constant and the value as compared to
         * interp.c */
        switch(ins->info->opcode) {
            case MVM_OP_gt_s:
                //| sete al;
                dasm_put(Dst, 2010);
#line 1619 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_ge_s:
                //| setle al;
                dasm_put(Dst, 2022);
#line 1622 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_lt_s:
                //| sete al;
                dasm_put(Dst, 2010);
#line 1625 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_le_s:
                //| setge al;
                dasm_put(Dst, 2030);
#line 1628 "src/jit/x64/emit.dasc"
                break;
        }
        //| movzx rax, al;
        //| mov WORK[reg], rax;
        dasm_put(Dst, 2034, Dt26([reg]));
#line 1632 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_not_i: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[src];
        //| test TMP1, TMP1;
        //| setz TMP2b;
        //| movzx TMP2, TMP2b;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 1442, Dt26([src]), Dt26([dst]));
#line 1642 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_eq_n:
    case MVM_OP_ne_n:
    case MVM_OP_le_n:
    case MVM_OP_lt_n:
    case MVM_OP_ge_n:
    case MVM_OP_gt_n: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 a   = ins->operands[1].reg.orig;
        MVMint16 b   = ins->operands[2].reg.orig;
        if (op == MVM_OP_eq_n) {
            //| mov TMP1, 0;
            dasm_put(Dst, 2104);
#line 1655 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_ne_n) {
            //| mov TMP1, 1;
            dasm_put(Dst, 2112);
#line 1657 "src/jit/x64/emit.dasc"
        }
        if (op == MVM_OP_lt_n || op == MVM_OP_le_n) {
            //| movsd xmm0, qword WORK[b];
            //| ucomisd xmm0, qword WORK[a];
            dasm_put(Dst, 2120, Dt26([b]), Dt26([a]));
#line 1661 "src/jit/x64/emit.dasc"
        } else {
            //| movsd xmm0, qword WORK[a];
            //| ucomisd xmm0, qword WORK[b];
            dasm_put(Dst, 2120, Dt26([a]), Dt26([b]));
#line 1664 "src/jit/x64/emit.dasc"
        }

        if (op == MVM_OP_le_n || op == MVM_OP_ge_n) {
            //| setae TMP1b;
            dasm_put(Dst, 2132);
#line 1668 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_eq_n) {
            //| setnp TMP2b; // zero if either is NaN, 1 otherwise
            //| cmove TMP1, TMP2; // if equal, overwrite 0 with 1
            dasm_put(Dst, 2136);
#line 1671 "src/jit/x64/emit.dasc"
        } else if (op == MVM_OP_ne_n) {
            //| setp TMP2b; // 1 if either is NaN (in which case they can't be equal)
            //| cmove TMP1, TMP2; // if equal, overwrite 1 with IsNan(a) | IsNaN(b)
            dasm_put(Dst, 2144);
#line 1674 "src/jit/x64/emit.dasc"
        } else {
            //| seta TMP1b;
            dasm_put(Dst, 2152);
#line 1676 "src/jit/x64/emit.dasc"
        }
        //| movzx TMP1, TMP1b;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 2156, Dt26([dst]));
#line 1679 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_cmp_n: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 a   = ins->operands[1].reg.orig;
        MVMint16 b   = ins->operands[2].reg.orig;
        //| movsd xmm0, qword WORK[a];
        //| movsd xmm1, qword WORK[b];
        //| ucomisd xmm0, xmm1
        //| seta TMP1b;
        //| movzx rax, TMP1b;
        //| ucomisd xmm1, xmm0
        //| seta TMP1b;
        //| movzx TMP1, TMP1b;
        //| sub rax, TMP1;
        //| mov WORK[dst], rax;
        dasm_put(Dst, 2165, Dt26([a]), Dt26([b]), Dt26([dst]));
#line 1695 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_eq_I:
    case MVM_OP_ne_I:
    case MVM_OP_lt_I:
    case MVM_OP_le_I:
    case MVM_OP_gt_I:
    case MVM_OP_ge_I: {
        MVMint32 reg_a = ins->operands[0].reg.orig;
        MVMint32 reg_b = ins->operands[1].reg.orig;
        MVMint32 reg_c = ins->operands[2].reg.orig;
        /* Call the bigint comparison function. */
        //| mov ARG1, TC;
        //| mov ARG2, WORK[reg_b];
        //| mov ARG3, WORK[reg_c];
        //| callp &MVM_bigint_cmp;
        dasm_put(Dst, 2207, Dt26([reg_b]), Dt26([reg_c]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_bigint_cmp)), (MVMuint32)((uintptr_t)(&MVM_bigint_cmp) >> 32));
        dasm_put(Dst, 260);
#line 1711 "src/jit/x64/emit.dasc"
        /* Handle result by opcode. */
        switch(ins->info->opcode) {
        case MVM_OP_eq_I:
            //| cmp RV, MP_EQ
            //| sete al;
            dasm_put(Dst, 2221, MP_EQ);
#line 1716 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_ne_I:
            //| cmp RV, MP_EQ
            //| setne al;
            dasm_put(Dst, 2230, MP_EQ);
#line 1720 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_lt_I:
            //| cmp RV, MP_LT
            //| sete al;
            dasm_put(Dst, 2221, MP_LT);
#line 1724 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_le_I:
            //| cmp RV, MP_GT
            //| setne al;
            dasm_put(Dst, 2230, MP_GT);
#line 1728 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_gt_I:
            //| cmp RV, MP_GT
            //| sete al;
            dasm_put(Dst, 2221, MP_GT);
#line 1732 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_ge_I:
            //| cmp RV, MP_LT
            //| setne al;
            dasm_put(Dst, 2230, MP_LT);
#line 1736 "src/jit/x64/emit.dasc"
            break;
        }
        /* zero extend al (lower byte) to rax (whole register) */
        //| movzx rax, al;
        //| mov WORK[reg_a], rax;
        dasm_put(Dst, 2034, Dt26([reg_a]));
#line 1741 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_isint:
    case MVM_OP_isnum:
    case MVM_OP_isstr:
    case MVM_OP_islist:
    case MVM_OP_ishash: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        MVMint32 reprid = op == MVM_OP_isint ? MVM_REPR_ID_P6int :
                          op == MVM_OP_isnum ? MVM_REPR_ID_P6num :
                          op == MVM_OP_isstr ? MVM_REPR_ID_P6str :
                          op == MVM_OP_islist ? MVM_REPR_ID_VMArray :
                     /*  op == MVM_OP_ishash */ MVM_REPR_ID_MVMHash;
        //| mov TMP1, aword WORK[obj];
        //| test TMP1, TMP1;
        //| jz >1;
        //| mov TMP1, OBJECT:TMP1->st;
        //| mov TMP1, STABLE:TMP1->REPR;
        //| cmp qword REPR:TMP1->ID, reprid;
        //| jne >1;
        //| mov qword WORK[dst], 1;
        //| jmp >2;
        //|1:
        //| mov qword WORK[dst], 0;
        //|2:
        dasm_put(Dst, 2239, Dt26([obj]), DtE(->st), Dt12(->REPR), Dt13(->ID), reprid, Dt26([dst]), Dt26([dst]));
#line 1767 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_boolify_iter_arr: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[obj];
        //| mov TMP2, MVMITER:TMP1->body.array_state.index;
        //| add TMP2, 1;
        //| mov TMP3, MVMITER:TMP1->body.array_state.limit;
        dasm_put(Dst, 2292, Dt26([obj]), DtB(->body.array_state.index), DtB(->body.array_state.limit));
#line 1776 "src/jit/x64/emit.dasc"
        /* index - limit will give a carry flag when index < limit */
        //| cmp TMP2, TMP3;
        //| setl TMP1b;
        //| movzx TMP1, TMP1b;
        //| mov aword WORK[dst], TMP1;
        dasm_put(Dst, 2309, Dt26([dst]));
#line 1781 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_boolify_iter_hash: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[obj];
        //| mov TMP2, MVMITER:TMP1->body.hash_state.next;
        //| test TMP2, TMP2;
        //| setnz TMP2b;
        //| movzx TMP2, TMP2b;
        //| mov aword WORK[dst], TMP2;
        dasm_put(Dst, 2324, Dt26([obj]), DtB(->body.hash_state.next), Dt26([dst]));
#line 1792 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_objprimspec: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 type = ins->operands[1].reg.orig;
        //| mov TMP6, aword WORK[type];
        //| test TMP6, TMP6;
        //| jz >1;
        //| mov ARG1, TC;
        //| mov ARG2, OBJECT:TMP6->st;
        //| mov FUNCTION, STABLE:ARG2->REPR;
        //| mov FUNCTION, REPR:FUNCTION->get_storage_spec;
        //| call FUNCTION;
        //| movzx TMP6, word STORAGESPEC:RV->boxed_primitive;
        //|1:
        //| mov aword WORK[dst], TMP6;
        dasm_put(Dst, 2347, Dt26([type]), DtE(->st), Dt12(->REPR), Dt13(->get_storage_spec), Dt18(->boxed_primitive), Dt26([dst]));
#line 1808 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_objprimbits: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 type = ins->operands[1].reg.orig;
        //| mov TMP6, aword WORK[type];
        //| test TMP6, TMP6;
        //| jz >1;
        //| mov ARG2, OBJECT:TMP6->st;
        //| mov FUNCTION, STABLE:ARG2->REPR;
        //| mov FUNCTION, REPR:FUNCTION->get_storage_spec;
        //| mov ARG1, TC;
        //| call FUNCTION;
        //| movzx TMP6, word STORAGESPEC:RV->boxed_primitive;
        //| test TMP6, TMP6;
        //| jz >1;
        //| movzx TMP6, word STORAGESPEC:RV->bits;
        //|1:
        //| mov aword WORK[dst], TMP6;
        dasm_put(Dst, 2390, Dt26([type]), DtE(->st), Dt12(->REPR), Dt13(->get_storage_spec), Dt18(->boxed_primitive), Dt18(->bits), Dt26([dst]));
#line 1827 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_objprimunsigned: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 type = ins->operands[1].reg.orig;
        //| mov TMP5, aword WORK[type];
        //| test TMP5, TMP5;
        //| jz >1;
        //| mov ARG1, TC;
        //| mov ARG2, OBJECT:TMP5->st;
        //| mov FUNCTION, STABLE:ARG2->REPR;
        //| mov FUNCTION, REPR:FUNCTION->get_storage_spec;
        //| call FUNCTION;
        //| cmp word STORAGESPEC:RV->boxed_primitive, 1;
        //| jne >1;
        //| movzx TMP6, byte STORAGESPEC:RV->is_unsigned;
        //| mov WORK[dst], TMP6;
        //| jmp >2;
        //|1:
        //| mov aword WORK[dst], 0;
        //|2:
        dasm_put(Dst, 2445, Dt26([type]), DtE(->st), Dt12(->REPR), Dt13(->get_storage_spec), Dt18(->boxed_primitive), Dt18(->is_unsigned), Dt26([dst]), Dt26([dst]));
#line 1848 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_isnonnull: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[obj];
        //| test TMP1, TMP1;
        //| setnz TMP2b;
        //| get_vmnull TMP3;
        //| cmp TMP1, TMP3;
        //| setne TMP3b;
        //| and TMP2b, TMP3b;
        //| movzx TMP2, TMP2b;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 2511, Dt26([obj]), Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 1862 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_scgethandle: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 sc  = ins->operands[1].reg.orig;
        //| mov TMP5, aword WORK[sc];
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_SCRef;
        //| je >1;
        //| throw_adhoc "Must provide an SCRef operand to scgethandle"
        dasm_put(Dst, 2548, Dt26([sc]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_SCRef, (unsigned int)((uintptr_t)("Must provide an SCRef operand to scgethandle")), (unsigned int)(((uintptr_t)("Must provide an SCRef operand to scgethandle"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1871 "src/jit/x64/emit.dasc"
        //|1:
        //| mov ARG1, TC;
        //| mov ARG2, SCREF:TMP5;
        //| callp &MVM_sc_get_handle;
        dasm_put(Dst, 2579);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_sc_get_handle)), (MVMuint32)((uintptr_t)(&MVM_sc_get_handle) >> 32));
#line 1875 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 1876 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_scobjcount: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 sc  = ins->operands[1].reg.orig;
        //| mov TMP5, aword WORK[dst];
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_SCRef;
        //| je >1;
        //| throw_adhoc "Must provide an SCRef operand to scobjcount"
        dasm_put(Dst, 2548, Dt26([dst]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_SCRef, (unsigned int)((uintptr_t)("Must provide an SCRef operand to scobjcount")), (unsigned int)(((uintptr_t)("Must provide an SCRef operand to scobjcount"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1885 "src/jit/x64/emit.dasc"
        //|1:
        //| mov ARG1, TC;
        //| mov ARG2, SCREF:TMP5;
        //| callp &MVM_sc_get_object_count;
        dasm_put(Dst, 2579);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_sc_get_object_count)), (MVMuint32)((uintptr_t)(&MVM_sc_get_object_count) >> 32));
#line 1889 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 1890 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_setobjsc: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 sc  = ins->operands[1].reg.orig;
        //| mov TMP5, WORK[sc];
        //| cmp_repr_id TMP5, TMP6, MVM_REPR_ID_SCRef;
        //| je >1;
        //| throw_adhoc "Must provide an SCRef operand to setobjsc"
        dasm_put(Dst, 2548, Dt26([sc]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_SCRef, (unsigned int)((uintptr_t)("Must provide an SCRef operand to setobjsc")), (unsigned int)(((uintptr_t)("Must provide an SCRef operand to setobjsc"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 1899 "src/jit/x64/emit.dasc"
        //|1:
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[dst];
        //| mov ARG3, SCREF:TMP5;
        //| callp &MVM_sc_set_obj_sc;
        dasm_put(Dst, 2595, Dt26([dst]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_sc_set_obj_sc)), (MVMuint32)((uintptr_t)(&MVM_sc_set_obj_sc) >> 32));
        dasm_put(Dst, 260);
#line 1904 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_isnull: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[obj];
        //| test TMP1, TMP1;
        //| setz TMP2b;
        //| get_vmnull TMP3;
        //| cmp TMP1, TMP3;
        //| sete TMP3b;
        //| or TMP2b, TMP3b;
        //| movzx TMP2, TMP2b;
        //| mov WORK[dst], TMP2;
        dasm_put(Dst, 2615, Dt26([obj]), Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 1918 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_fastcreate: {
        MVMint16 dst = ins->operands[0].reg.orig;
        emit_fastcreate(tc, compiler, jg, ins);
        //| mov aword WORK[dst], RV;
        dasm_put(Dst, 415, Dt26([dst]));
#line 1924 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_decont:
    case MVM_OP_sp_decont: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP5, WORK[src];
        //| test TMP5, TMP5;
        dasm_put(Dst, 2652, Dt26([src]));
#line 1932 "src/jit/x64/emit.dasc"
        // obj is null
        //| jz >1;
        //| test_type_object TMP5;
        dasm_put(Dst, 2660, DtE(->header.flags), MVM_CF_TYPE_OBJECT);
#line 1935 "src/jit/x64/emit.dasc"
        // object is type object (not concrete)
        //| jnz >1;
        //| mov TMP6, OBJECT:TMP5->st;
        //| mov TMP6, STABLE:TMP6->container_spec;
        //| test TMP6, TMP6;
        dasm_put(Dst, 2672, DtE(->st), Dt12(->container_spec));
#line 1940 "src/jit/x64/emit.dasc"
        // container spec is zero
        //| jz >1;
        //| mov ARG1, TC;
        //| mov ARG2, TMP5;      // object
        //| lea ARG3, WORK[dst]; // destination register
        //| mov FUNCTION, CONTAINERSPEC:TMP6->fetch; // get function pointer
        //| call FUNCTION;
        //| jmp >2;
        //|1:
        dasm_put(Dst, 2688, Dt26([dst]), Dt17(->fetch));
#line 1949 "src/jit/x64/emit.dasc"
        // otherwise just move the object into the register
        //| mov WORK[dst], TMP5;
        //|2:
        dasm_put(Dst, 2718, Dt26([dst]));
#line 1952 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_iscont: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[obj];
        //| test TMP1, TMP1;
        //| jz >1;
        //| mov TMP1, OBJECT:TMP1->st;
        //| mov TMP1, STABLE:TMP1->container_spec;
        //| test TMP1, TMP1;
        //|1:
        //| setnz TMP1b;
        //| movzx TMP1, TMP1b;
        //| mov qword WORK[dst], TMP1;
        dasm_put(Dst, 2725, Dt26([obj]), DtE(->st), Dt12(->container_spec), Dt26([dst]));
#line 1967 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_findmeth: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        MVMint32 str_idx = ins->operands[2].lit_str_idx;
        MVMuint16 ss_idx = ins->operands[3].lit_i16;
        //| get_spesh_slot TMP1, ss_idx;
        //| mov TMP2, WORK[obj];
        //| mov TMP2, OBJECT:TMP2->st;
        //| cmp TMP1, TMP2;
        //| jne >1;
        //| get_spesh_slot TMP3, ss_idx + 1;
        //| mov WORK[dst], TMP3;
        //| jmp >2;
        //|1:
        dasm_put(Dst, 2761, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([ss_idx]), Dt26([obj]), DtE(->st), Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([ss_idx + 1]), Dt26([dst]));
#line 1983 "src/jit/x64/emit.dasc"
        /* call find_method_spesh */
        //| mov ARG1, TC;
        //| mov ARG2, WORK[obj];
        //| get_string ARG3, str_idx;
        dasm_put(Dst, 2811, Dt26([obj]));
         MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, str_idx);
#line 1987 "src/jit/x64/emit.dasc"
        //| mov ARG4, ss_idx;
        //| lea TMP6, WORK[dst];
        //| mov ARG5, TMP6;
        //| callp &MVM_6model_find_method_spesh;
        dasm_put(Dst, 2820, Dt27(->body.strings), Dt15([str_idx]), ss_idx, Dt26([dst]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_6model_find_method_spesh)), (MVMuint32)((uintptr_t)(&MVM_6model_find_method_spesh) >> 32));
#line 1991 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 1992 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_isconcrete: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[obj];
        //| test TMP1, TMP1;
        //| jz >1;
        //| test_type_object TMP1;
        //| jnz >1;
        //| mov qword WORK[dst], 1;
        //| jmp >2;
        //|1:
        //| mov qword WORK[dst], 0;
        //|2:
        dasm_put(Dst, 2841, Dt26([obj]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, Dt26([dst]), Dt26([dst]));
#line 2007 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_isinvokable: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 src = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[src];
        //| mov TMP1, OBJECT:TMP1->st;
        //| mov TMP2, 1;
        //| mov64 TMP3, ((uintptr_t)(MVM_6model_invoke_default));
        //| cmp TMP3, STABLE:TMP1->invoke;
        //| jne >1;
        //| mov TMP4, STABLE:TMP1->invocation_spec;
        //| test TMP4, TMP4;
        //| jnz >1;
        //| and TMP2, TMP4;
        //|1:
        //| mov aword WORK[dst], TMP2;
        dasm_put(Dst, 2887, Dt26([src]), DtE(->st), (unsigned int)(((uintptr_t)(MVM_6model_invoke_default))), (unsigned int)((((uintptr_t)(MVM_6model_invoke_default)))>>32), Dt12(->invoke), Dt12(->invocation_spec), Dt26([dst]));
#line 2024 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_takehandlerresult: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, aword TC->last_handler_result;
        //| test TMP1, TMP1;
        //| jnz >1;
        //| get_vmnull TMP1;
        //|1:
        //| mov aword WORK[dst], TMP1;
        //| mov aword TC->last_handler_result, 0;
        dasm_put(Dst, 2935, Dt25(->last_handler_result), Dt25(->instance), DtC(->VMNull), Dt26([dst]), Dt25(->last_handler_result));
#line 2035 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_exception: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1, TC->active_handlers;
        //| test TMP1, TMP1;
        //| jz >1;
        //| mov TMP1, MVMACTIVEHANDLERS:TMP1->ex_obj;
        //| mov WORK[dst], TMP1;
        //| jmp >2;
        //|1:
        //| get_vmnull TMP1;
        //| mov WORK[dst], TMP1;
        //|2:
        dasm_put(Dst, 2969, Dt25(->active_handlers), DtD(->ex_obj), Dt26([dst]), Dt25(->instance), DtC(->VMNull), Dt26([dst]));
#line 2049 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_scwbdisable: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1d, dword TC->sc_wb_disable_depth;
        //| add TMP1d, 1;
        //| mov dword TC->sc_wb_disable_depth, TMP1d;
        //| mov qword WORK[dst], TMP1;
        dasm_put(Dst, 3009, Dt25(->sc_wb_disable_depth), Dt25(->sc_wb_disable_depth), Dt26([dst]));
#line 2057 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_scwbenable: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP1d, dword TC->sc_wb_disable_depth; // should do zero-extension
        //| sub TMP1d, 1;
        //| mov dword TC->sc_wb_disable_depth, TMP1d;
        //| mov qword WORK[dst], TMP1;
        dasm_put(Dst, 3025, Dt25(->sc_wb_disable_depth), Dt25(->sc_wb_disable_depth), Dt26([dst]));
#line 2065 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_assign:
    case MVM_OP_assignunchecked: {
        MVMint16 cont = ins->operands[0].reg.orig;
        MVMint16 obj  = ins->operands[1].reg.orig;
        //| mov ARG2, aword WORK[cont];
        //| mov FUNCTION, OBJECT:ARG2->st;
        //| mov FUNCTION, STABLE:FUNCTION->container_spec;
        //| test FUNCTION, FUNCTION;
        //| jnz >1;
        //| throw_adhoc "Cannot assign to an immutable value";
        dasm_put(Dst, 3042, Dt26([cont]), DtE(->st), Dt12(->container_spec), (unsigned int)((uintptr_t)("Cannot assign to an immutable value")), (unsigned int)(((uintptr_t)("Cannot assign to an immutable value"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2077 "src/jit/x64/emit.dasc"
        //|1:
        //| mov ARG1, TC;
        //| mov ARG3, aword WORK[obj];
        dasm_put(Dst, 3071, Dt26([obj]));
#line 2080 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_assign) {
            //| mov FUNCTION, CONTAINERSPEC:FUNCTION->store;
            dasm_put(Dst, 234, Dt17(->store));
#line 2082 "src/jit/x64/emit.dasc"
        } else {
            //| mov FUNCTION, CONTAINERSPEC:FUNCTION->store_unchecked;
            dasm_put(Dst, 234, Dt17(->store_unchecked));
#line 2084 "src/jit/x64/emit.dasc"
        }
        //| call FUNCTION;
        dasm_put(Dst, 3087);
#line 2086 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getlexstatic_o:
    case MVM_OP_getlexperinvtype_o: {
        MVMint16 dst  = ins->operands[0].reg.orig;
        MVMint16 name = ins->operands[1].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[name];
        //| mov ARG3, MVM_reg_obj;
        //| callp &MVM_frame_find_lexical_by_name;
        dasm_put(Dst, 3092, Dt26([name]), MVM_reg_obj);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_find_lexical_by_name)), (MVMuint32)((uintptr_t)(&MVM_frame_find_lexical_by_name) >> 32));
#line 2096 "src/jit/x64/emit.dasc"
        //| test RV, RV;
        //| jz >1;
        //| mov RV, [RV];
        //|1:
        //| mov WORK[dst], RV;
        dasm_put(Dst, 3106, Dt26([dst]));
#line 2101 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_paramnamesused:
        //| mov ARG2, TC->cur_frame;
        //| lea ARG2, FRAME:ARG2->params;
        //| mov TMP5w, word ARGCTX:ARG2->num_pos;
        //| cmp TMP5w, word ARGCTX:ARG2->arg_count;
        //| je >1;
        //| mov ARG1, TC;
        //| callp &MVM_args_assert_nameds_used;
        dasm_put(Dst, 3128, Dt25(->cur_frame), Dt2(->params), Dt3(->num_pos), Dt3(->arg_count));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_assert_nameds_used)), (MVMuint32)((uintptr_t)(&MVM_args_assert_nameds_used) >> 32));
#line 2111 "src/jit/x64/emit.dasc"
        //|1:
        dasm_put(Dst, 1729);
#line 2112 "src/jit/x64/emit.dasc"
        break;
    case MVM_OP_assertparamcheck: {
        MVMint16 ok = ins->operands[0].reg.orig;
        //| mov TMP1, qword WORK[ok];
        //| test TMP1, TMP1;
        //| jnz >1;
        //| mov ARG1, TC;
        //| callp &MVM_args_bind_failed;
        dasm_put(Dst, 3156, Dt26([ok]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_bind_failed)), (MVMuint32)((uintptr_t)(&MVM_args_bind_failed) >> 32));
#line 2120 "src/jit/x64/emit.dasc"
        //|1:
        dasm_put(Dst, 1729);
#line 2121 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_gethashentryvalue: {
        MVMint16 dst   = ins->operands[0].reg.orig;
        MVMint64 entry = ins->operands[1].lit_i64;
        //| mov64 TMP1, entry;
        //| mov TMP1, MVMHASHENTRY:TMP1->value;
        //| mov WORK[dst], TMP1;
        dasm_put(Dst, 3173, (unsigned int)(entry), (unsigned int)((entry)>>32), Dt24(->value), Dt26([dst]));
#line 2129 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_prof_enterspesh:
        //| mov ARG1, TC;
        //| mov ARG2, TC->cur_frame;
        //| mov ARG2, aword FRAME:ARG2->static_info;
        //| mov ARG3, aword MVM_PROFILE_ENTER_JIT;
        //| callp &MVM_profile_log_enter;
        dasm_put(Dst, 3186, Dt25(->cur_frame), Dt2(->static_info), MVM_PROFILE_ENTER_JIT);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_profile_log_enter)), (MVMuint32)((uintptr_t)(&MVM_profile_log_enter) >> 32));
        dasm_put(Dst, 260);
#line 2137 "src/jit/x64/emit.dasc"
        break;
    case MVM_OP_prof_enterinline: {
        MVMint16 spesh_idx = ins->operands[0].lit_i16;
        //| mov ARG1, TC;
        //| get_spesh_slot ARG2, spesh_idx;
        //| mov ARG3, aword MVM_PROFILE_ENTER_JIT_INLINE;
        //| callp &MVM_profile_log_enter;
        dasm_put(Dst, 3204, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]), MVM_PROFILE_ENTER_JIT_INLINE);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_profile_log_enter)), (MVMuint32)((uintptr_t)(&MVM_profile_log_enter) >> 32));
        dasm_put(Dst, 260);
#line 2144 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_prof_replaced: {
        MVMint16 spesh_idx = ins->operands[0].lit_i16;
        //| mov ARG1, TC;
        //| get_spesh_slot ARG2, spesh_idx;
        //| callp &MVM_profile_log_scalar_replaced;
        dasm_put(Dst, 737, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_profile_log_scalar_replaced)), (MVMuint32)((uintptr_t)(&MVM_profile_log_scalar_replaced) >> 32));
        dasm_put(Dst, 260);
#line 2151 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getobjsc: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[obj];
        //| mov TMP2d, dword COLLECTABLE:TMP1->sc_forward_u.sc.sc_idx;
        //| xor TMP3, TMP3;
        //| cmp TMP2d, 0;
        //| jle >1;
        //| mov TMP3, aword TC->instance;
        //| mov TMP3, aword MVMINSTANCE:TMP3->all_scs;
        //| mov TMP3, aword [TMP3 + TMP2d * 8];
        //| mov TMP3, SCREFBODY:TMP3->sc;
        //|1:
        //| mov aword WORK[dst], TMP3;
        dasm_put(Dst, 3226, Dt26([obj]), Dt11(->sc_forward_u.sc.sc_idx), Dt25(->instance), DtC(->all_scs), Dt1B(->sc), Dt26([dst]));
#line 2167 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_invokewithcapture: {
        MVMint16 dest    = ins->operands[0].reg.orig;
        MVMint16 code    = ins->operands[1].reg.orig;
        MVMint16 capture = ins->operands[2].reg.orig;
        //| mov TMP1, aword WORK[capture];
        dasm_put(Dst, 577, Dt26([capture]));
#line 2174 "src/jit/x64/emit.dasc"
        /* if (IS_CONCRETE(capture) && REPR(capture)->ID == MVM_REPR_ID_MVMCallCapture) */
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCallCapture;
        //| je >2;
        //|1:
        dasm_put(Dst, 3267, DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture);
#line 2180 "src/jit/x64/emit.dasc"
        /* else throw */
        //| throw_adhoc "invokewithcapture needs a MVMCallCapture";
        dasm_put(Dst, 380, (unsigned int)((uintptr_t)("invokewithcapture needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("invokewithcapture needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2182 "src/jit/x64/emit.dasc"
        //|2:
        dasm_put(Dst, 340);
#line 2183 "src/jit/x64/emit.dasc"
        /* code = MVM_frame_find_invokee(tc, code, NULL) */
        //| mov ARG1, TC;
        //| mov ARG2, WORK[code];
        //| xor ARG3, ARG3;
        //| callp &MVM_frame_find_invokee;
        dasm_put(Dst, 3296, Dt26([code]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee)), (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee) >> 32));
        dasm_put(Dst, 260);
#line 2188 "src/jit/x64/emit.dasc"

        //| mov ARG2, RV; // ARG2 = code
        dasm_put(Dst, 3309);
#line 2190 "src/jit/x64/emit.dasc"
        /* tc->cur_frame->return_value = &GET_REG(cur_op, 2) */
        //| lea ARG1, WORK[dest]; // ARG1 is used as scratch space
        //| mov TMP6, aword TC->cur_frame;
        //| mov aword FRAME:TMP6->return_value, ARG1;
        dasm_put(Dst, 3313, Dt26([dest]), Dt25(->cur_frame), Dt2(->return_value));
#line 2194 "src/jit/x64/emit.dasc"
        /* tc->cur_frame->return_type = MVM_RETURN_OBJ */
        //| mov byte FRAME:TMP6->return_type, MVM_RETURN_OBJ;
        dasm_put(Dst, 3326, Dt2(->return_type), MVM_RETURN_OBJ);
#line 2196 "src/jit/x64/emit.dasc"
        /* tc->cur_frame->return_address = cur_op */
        //| get_cur_op ARG1;
        //| mov aword FRAME:TMP6->return_address, ARG1;
        dasm_put(Dst, 3332, Dt25(->interp_cur_op), Dt2(->return_address));
#line 2199 "src/jit/x64/emit.dasc"
        /* STABLE(code)->invoke(tc, code, capture->body.apc->effective_callsite,
           capture->body.apc->arg) */
        //| mov ARG1, TC;
        //| mov ARG3, WORK[capture];
        //| mov ARG4, aword CAPTURE:ARG3->body.apc;
        //| mov ARG3, aword ARGCTX:ARG4->callsite;
        //| mov ARG4, aword ARGCTX:ARG4->args;
        //| mov FUNCTION, OBJECT:ARG2->st;
        //| mov FUNCTION, STABLE:FUNCTION->invoke;
        //| call FUNCTION;
        dasm_put(Dst, 3344, Dt26([capture]), Dt5(->body.apc), Dt3(->callsite), Dt3(->args), DtE(->st), Dt12(->invoke));
#line 2209 "src/jit/x64/emit.dasc"
        /* jumping out is handled by invokish */
        break;
    }
    case MVM_OP_captureposelems: {
        MVMint16 dest    = ins->operands[0].reg.orig;
        MVMint16 capture = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[capture];
        dasm_put(Dst, 577, Dt26([capture]));
#line 2216 "src/jit/x64/emit.dasc"
        /* if (IS_CONCRETE(capture) && REPR(capture)->ID == MVM_REPR_ID_MVMCallCapture) */
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCallCapture;
        //| je >2;
        //|1:
        dasm_put(Dst, 3267, DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture);
#line 2222 "src/jit/x64/emit.dasc"
        /* else throw */
        //| throw_adhoc "captureposelems needs a concrete MVMCallCapture";
        dasm_put(Dst, 380, (unsigned int)((uintptr_t)("captureposelems needs a concrete MVMCallCapture")), (unsigned int)(((uintptr_t)("captureposelems needs a concrete MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2224 "src/jit/x64/emit.dasc"
        //|2:
        //| mov TMP2, aword CAPTURE:TMP1->body.apc;
        //| movzx TMP2, word ARGPROCCONTEXT:TMP2->num_pos;
        //| mov WORK[dest], TMP2;
        dasm_put(Dst, 3377, Dt5(->body.apc), Dt7(->num_pos), Dt26([dest]));
#line 2228 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_captureexistsnamed: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        MVMint16 name = ins->operands[2].reg.orig;
        //| mov TMP1, WORK[obj];
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCallCapture;
        //| je >2;
        //|1:
        //| throw_adhoc "captureexistsnamed needs a MVMCallCapture";
        dasm_put(Dst, 1299, Dt26([obj]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, (unsigned int)((uintptr_t)("captureexistsnamed needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("captureexistsnamed needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2241 "src/jit/x64/emit.dasc"
        //|2:
        //| mov ARG2, CAPTURE:TMP1->body.apc;
        //| mov ARG3, WORK[name];
        //| mov ARG1, TC;
        //| callp MVM_args_has_named;
        dasm_put(Dst, 539, Dt5(->body.apc), Dt26([name]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(MVM_args_has_named)), (MVMuint32)((uintptr_t)(MVM_args_has_named) >> 32));
#line 2246 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 2247 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_capturehasnameds: {
        MVMint16 dest    = ins->operands[0].reg.orig;
        MVMint16 capture = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[capture];
        dasm_put(Dst, 577, Dt26([capture]));
#line 2253 "src/jit/x64/emit.dasc"
        /* if (IS_CONCRETE(capture) && REPR(capture)->ID == MVM_REPR_ID_MVMCallCapture) */
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCallCapture;
        //| je >2;
        //|1:
        dasm_put(Dst, 3267, DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture);
#line 2259 "src/jit/x64/emit.dasc"
        /* else throw */
        //| throw_adhoc "capturehasnameds needs a concrete MVMCallCapture";
        dasm_put(Dst, 380, (unsigned int)((uintptr_t)("capturehasnameds needs a concrete MVMCallCapture")), (unsigned int)(((uintptr_t)("capturehasnameds needs a concrete MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2261 "src/jit/x64/emit.dasc"
        //|2:
        //| mov TMP2, CAPTURE:TMP1->body.apc;
        //| mov TMP3w, word ARGPROCCONTEXT:TMP2->num_pos;
        //| mov TMP2w, word ARGPROCCONTEXT:TMP2->arg_count;
        //| cmp TMP2w, TMP3w;
        //| setne al;
        //| movzx rax, al;
        //| mov WORK[dest], rax;
        dasm_put(Dst, 3398, Dt5(->body.apc), Dt7(->num_pos), Dt7(->arg_count), Dt26([dest]));
#line 2269 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_capturenamedshash: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 obj = ins->operands[1].reg.orig;
        //| mov TMP1, WORK[obj];
        //| test_type_object TMP1;
        //| jnz >1;
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCallCapture;
        //| je >2;
        //|1:
        //| throw_adhoc "capturenamedshash needs a MVMCallCapture";
        dasm_put(Dst, 1299, Dt26([obj]), DtE(->header.flags), MVM_CF_TYPE_OBJECT, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCallCapture, (unsigned int)((uintptr_t)("capturenamedshash needs a MVMCallCapture")), (unsigned int)(((uintptr_t)("capturenamedshash needs a MVMCallCapture"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2281 "src/jit/x64/emit.dasc"
        //|2:
        //| mov ARG2, CAPTURE:TMP1->body.apc;
        //| mov ARG1, TC;
        //| callp MVM_args_slurpy_named;
        dasm_put(Dst, 3434, Dt5(->body.apc));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(MVM_args_slurpy_named)), (MVMuint32)((uintptr_t)(MVM_args_slurpy_named) >> 32));
#line 2285 "src/jit/x64/emit.dasc"
        //| mov WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 2286 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getstdin:
    case MVM_OP_getstdout:
    case MVM_OP_getstderr: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP3, aword TC->instance;
        dasm_put(Dst, 3451, Dt25(->instance));
#line 2293 "src/jit/x64/emit.dasc"
        if (ins->info->opcode == MVM_OP_getstdin) {
            //| mov TMP3, aword MVMINSTANCE:TMP3->stdin_handle;
            dasm_put(Dst, 650, DtC(->stdin_handle));
#line 2295 "src/jit/x64/emit.dasc"
        } else if (ins->info->opcode == MVM_OP_getstdout) {
            //| mov TMP3, aword MVMINSTANCE:TMP3->stdout_handle;
            dasm_put(Dst, 650, DtC(->stdout_handle));
#line 2297 "src/jit/x64/emit.dasc"
        } else if (ins->info->opcode == MVM_OP_getstderr) {
            //| mov TMP3, aword MVMINSTANCE:TMP3->stderr_handle;
            dasm_put(Dst, 650, DtC(->stderr_handle));
#line 2299 "src/jit/x64/emit.dasc"
        }
        //| mov aword WORK[dst], TMP3;
        dasm_put(Dst, 854, Dt26([dst]));
#line 2301 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_ordat:
    case MVM_OP_ordbaseat:
    case MVM_OP_ordfirst: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 str = ins->operands[1].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[str];
        dasm_put(Dst, 2811, Dt26([str]));
#line 2310 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_ordat || op == MVM_OP_ordbaseat) {
            MVMint16 idx = ins->operands[2].reg.orig;
            //| mov ARG3, qword WORK[idx];
            dasm_put(Dst, 863, Dt26([idx]));
#line 2313 "src/jit/x64/emit.dasc"
        } else {
            //| mov ARG3, 0;
            dasm_put(Dst, 2091);
#line 2315 "src/jit/x64/emit.dasc"
        }
        if (op == MVM_OP_ordbaseat) {
            //| callp &MVM_string_ord_basechar_at;
            dasm_put(Dst, 116);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_string_ord_basechar_at)), (MVMuint32)((uintptr_t)(&MVM_string_ord_basechar_at) >> 32));
            dasm_put(Dst, 260);
#line 2318 "src/jit/x64/emit.dasc"
        } else {
            //| callp &MVM_string_ord_at;
            dasm_put(Dst, 116);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_string_ord_at)), (MVMuint32)((uintptr_t)(&MVM_string_ord_at) >> 32));
            dasm_put(Dst, 260);
#line 2320 "src/jit/x64/emit.dasc"
        }
        //| mov qword WORK[dst], RV;
        dasm_put(Dst, 415, Dt26([dst]));
#line 2322 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_getcodename: {
        MVMint16 obj  = ins->operands[0].reg.orig;
        MVMint16 code = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[code];
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCode;
        //| jne >1;
        //| test_type_object TMP1;
        //| jz >2;
        //|1:
        //| throw_adhoc "getcodename requires a concrete object";
        dasm_put(Dst, 497, Dt26([code]), DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCode, DtE(->header.flags), MVM_CF_TYPE_OBJECT, (unsigned int)((uintptr_t)("getcodename requires a concrete object")), (unsigned int)(((uintptr_t)("getcodename requires a concrete object"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2334 "src/jit/x64/emit.dasc"
        //|2:
        //| mov TMP2, CODE:TMP1->body.name;
        //| mov WORK[obj], TMP2;
        dasm_put(Dst, 3456, Dt1D(->body.name), Dt26([obj]));
#line 2337 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_setcodeobj: {
        MVMint16 obj  = ins->operands[0].reg.orig;
        MVMint16 code = ins->operands[1].reg.orig;
        //| mov TMP1, aword WORK[obj];
        dasm_put(Dst, 577, Dt26([obj]));
#line 2343 "src/jit/x64/emit.dasc"
        /* if (REPR(obj)->ID == MVM_REPR_ID_MVMCode) */
        //| cmp_repr_id TMP1, TMP2, MVM_REPR_ID_MVMCode;
        //| je >1;
        dasm_put(Dst, 3472, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCode);
#line 2346 "src/jit/x64/emit.dasc"
        /* else throw */
        //| throw_adhoc "setcodeobj needs a code ref";
        dasm_put(Dst, 380, (unsigned int)((uintptr_t)("setcodeobj needs a code ref")), (unsigned int)(((uintptr_t)("setcodeobj needs a code ref"))>>32));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc)), (MVMuint32)((uintptr_t)(&MVM_exception_throw_adhoc) >> 32));
#line 2348 "src/jit/x64/emit.dasc"
        //|1:
        //| mov TMP2, aword WORK[code];
        //| mov aword CODE:TMP1->body.code_object, TMP2;
        //| check_wb TMP1, TMP2, >2;
        //| hit_wb TMP1, TMP2
        dasm_put(Dst, 3489, Dt26([code]), Dt1D(->body.code_object), Dt11(->flags), MVM_CF_SECOND_GEN, Dt11(->flags), MVM_CF_SECOND_GEN);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by)), (MVMuint32)((uintptr_t)(&MVM_gc_write_barrier_hit_by) >> 32));
#line 2353 "src/jit/x64/emit.dasc"
        //|2:
        //|
        dasm_put(Dst, 340);
#line 2355 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_lastexpayload: {
        MVMint16 dst = ins->operands[0].reg.orig;
        //| mov TMP3, aword TC->last_payload;
        //| mov aword WORK[dst], TMP3;
        dasm_put(Dst, 3543, Dt25(->last_payload), Dt26([dst]));
#line 2361 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_param_sp: {
        MVMuint16 dst = ins->operands[0].reg.orig;
        MVMuint16 off = ins->operands[1].lit_ui16;
        //| mov ARG1, TC
        //| mov ARG2, TC:ARG1->cur_frame
        //| lea ARG2, FRAME:ARG2->params
        //| mov ARG3, off
        //| callp &MVM_args_slurpy_positional;
        dasm_put(Dst, 3552, Dt25(->cur_frame), Dt2(->params), off);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_slurpy_positional)), (MVMuint32)((uintptr_t)(&MVM_args_slurpy_positional) >> 32));
#line 2371 "src/jit/x64/emit.dasc"
        //| mov qword WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 2372 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_param_sn: {
        MVMuint16 dst = ins->operands[0].reg.orig;
        //| mov ARG1, TC
        //| mov ARG2, TC:ARG1->cur_frame
        //| xor ARG2, ARG2
        //| callp &MVM_args_slurpy_named;
        dasm_put(Dst, 3570, Dt25(->cur_frame));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_args_slurpy_named)), (MVMuint32)((uintptr_t)(&MVM_args_slurpy_named) >> 32));
#line 2380 "src/jit/x64/emit.dasc"
        //| mov qword WORK[dst], RV;
        dasm_put(Dst, 410, Dt26([dst]));
#line 2381 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_cas_o: {
        MVMint16 target = ins->operands[1].reg.orig;
        MVMint16 expected = ins->operands[2].reg.orig;
        MVMint16 value = ins->operands[3].reg.orig;
        MVMint16 result = ins->operands[0].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[target];
        //| mov ARG3, aword WORK[expected];
        //| mov ARG4, aword WORK[value];
        //|.if WIN32;
        //| lea TMP6, WORK[result]
        //| mov ARG5, TMP6
        //|.else;
        //| lea ARG5, WORK[result]
        //|.endif
        //| mov FUNCTION, OBJECT:ARG2->st;
        //| mov FUNCTION, STABLE:FUNCTION->container_spec;
        //| mov FUNCTION, CONTAINERSPEC:FUNCTION->cas;
        //| call FUNCTION;
        dasm_put(Dst, 3584, Dt26([target]), Dt26([expected]), Dt26([value]), Dt26([result]), DtE(->st), Dt12(->container_spec), Dt17(->cas));
#line 2402 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_atomicload_o: {
        MVMint16 target = ins->operands[1].reg.orig;
        MVMint16 result = ins->operands[0].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[target];
        //| mov FUNCTION, OBJECT:ARG2->st;
        //| mov FUNCTION, STABLE:FUNCTION->container_spec;
        //| mov FUNCTION, CONTAINERSPEC:FUNCTION->atomic_load;
        //| call FUNCTION;
        //| mov WORK[result], RV
        dasm_put(Dst, 3621, Dt26([target]), DtE(->st), Dt12(->container_spec), Dt17(->atomic_load), Dt26([result]));
#line 2414 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_atomicstore_o: {
        MVMint16 target = ins->operands[0].reg.orig;
        MVMint16 value = ins->operands[1].reg.orig;
        //| mov ARG1, TC;
        //| mov ARG2, aword WORK[target];
        //| mov ARG3, aword WORK[value];
        //| mov FUNCTION, OBJECT:ARG2->st;
        //| mov FUNCTION, STABLE:FUNCTION->container_spec;
        //| mov FUNCTION, CONTAINERSPEC:FUNCTION->atomic_store;
        //| call FUNCTION;
        dasm_put(Dst, 3650, Dt26([target]), Dt26([value]), DtE(->st), Dt12(->container_spec), Dt17(->atomic_store));
#line 2426 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_hllbool: {
        MVMint16 target = ins->operands[0].reg.orig;
        MVMint16 value = ins->operands[1].reg.orig;
        MVMHLLConfig *hll_config = (MVMHLLConfig*)jg->sg->sf->body.cu->body.hll_config;
        uintptr_t  true_value = (uintptr_t)hll_config->true_value;
        uintptr_t false_value = (uintptr_t)hll_config->false_value;
        //| mov TMP1, WORK[value];
        //| test TMP1, TMP1;
        //| jnz >1;
        //| mov64 TMP1, false_value;
        //| jmp >2;
        //|1:
        //| mov64 TMP1, true_value;
        //|2:
        //| mov WORK[target], TMP1;
        dasm_put(Dst, 3679, Dt26([value]), (unsigned int)(false_value), (unsigned int)((false_value)>>32), (unsigned int)(true_value), (unsigned int)((true_value)>>32), Dt26([target]));
#line 2443 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_hllboolfor: {
        MVMint16 target = ins->operands[0].reg.orig;
        MVMint16 value = ins->operands[1].reg.orig;
        MVMHLLConfig *hll_config = (MVMHLLConfig*)ins->operands[2].lit_i64;
        uintptr_t  true_value = (uintptr_t)hll_config->true_value;
        uintptr_t false_value = (uintptr_t)hll_config->false_value;
        //| mov TMP1, WORK[value];
        //| test TMP1, TMP1;
        //| jnz >1;
        //| mov64 TMP1, false_value;
        //| jmp >2;
        //|1:
        //| mov64 TMP1, true_value;
        //|2:
        //| mov WORK[target], TMP1;
        dasm_put(Dst, 3679, Dt26([value]), (unsigned int)(false_value), (unsigned int)((false_value)>>32), (unsigned int)(true_value), (unsigned int)((true_value)>>32), Dt26([target]));
#line 2460 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_fastbox_i:
    case MVM_OP_sp_fastbox_i_ic:
    case MVM_OP_sp_fastbox_bi:
    case MVM_OP_sp_fastbox_bi_ic: {
        MVMint32 use_cache = op == MVM_OP_sp_fastbox_i_ic || op == MVM_OP_sp_fastbox_bi_ic;
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 offset = ins->operands[3].lit_i16;
        MVMint16 val = ins->operands[4].reg.orig;
        if (use_cache) {
            MVMObject **cache = tc->instance->int_const_cache->cache[ins->operands[5].lit_i16];
            MVMint16 dst = ins->operands[0].reg.orig;
            //| mov TMP1, WORK[val]
            //| cmp TMP1, 14
            //| jg >1
            //| cmp TMP1, -1
            //| jl >1
            //| inc TMP1
            //| mov64 TMP2, (MVMuint64)cache
            //| mov TMP2, [TMP2 + TMP1 * 8]
            //| mov WORK[dst], TMP2
            //| jmp >2
            //|1:
            dasm_put(Dst, 3711, Dt26([val]), (unsigned int)((MVMuint64)cache), (unsigned int)(((MVMuint64)cache)>>32), Dt26([dst]));
#line 2484 "src/jit/x64/emit.dasc"
        }
        emit_fastcreate(tc, compiler, jg, ins);
        //| mov aword WORK[dst], RV;
        //| mov TMP3, WORK[val];
        dasm_put(Dst, 3757, Dt26([dst]), Dt26([val]));
#line 2488 "src/jit/x64/emit.dasc"
        if (op == MVM_OP_sp_fastbox_i || op == MVM_OP_sp_fastbox_i_ic) {
            /* Normal integer */
            //| mov qword [RV+offset], TMP3;
            dasm_put(Dst, 3766, offset);
#line 2491 "src/jit/x64/emit.dasc"
        }
        else {
            /* Big integer; if it's in smallint range we poke it in directly,
             * and if not we do a function call to create a bigint. */
            MVMuint16 val_offset = offset + 4;
            //| cmp TMP3, qword 2147483647LL
            //| jg >3
            //| cmp TMP3, qword -2147483648LL
            //| jl >3
            //| mov dword [RV+offset], MVM_BIGINT_32_FLAG
            //| mov dword [RV+val_offset], TMP3d
            //| jmp >4
            //|3:
            //| mov ARG1, TC
            //| mov ARG2, RV
            //| add ARG2, offset
            //| mov ARG3, TMP3
            //| callp &MVM_p6bigint_store_as_mp_int;
            dasm_put(Dst, 3771, 2147483647LL, -2147483648LL, offset, MVM_BIGINT_32_FLAG, val_offset, offset);
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_p6bigint_store_as_mp_int)), (MVMuint32)((uintptr_t)(&MVM_p6bigint_store_as_mp_int) >> 32));
#line 2509 "src/jit/x64/emit.dasc"
            //|4:
            dasm_put(Dst, 3819);
#line 2510 "src/jit/x64/emit.dasc"
        }
        if (use_cache) {
            //|2:
            dasm_put(Dst, 345);
#line 2513 "src/jit/x64/emit.dasc"
        }
        break;
    }
    case MVM_OP_sp_add_I:
    case MVM_OP_sp_sub_I:
    case MVM_OP_sp_mul_I: {
        MVMint16 a = ins->operands[3].reg.orig;
        MVMint16 b = ins->operands[4].reg.orig;
        MVMint16 c = ins->operands[0].reg.orig;
        MVMint16 offset = ins->operands[5].lit_i16;
        MVMint16 val_offset = offset + 4;
        MVMObject **cache = tc->instance->int_const_cache->cache[ins->operands[6].lit_i16];

        /* See if they're both smallint. */
        //| mov TMP1, WORK[a];
        //| mov TMP2, WORK[b];
        //| mov TMP4d, dword [TMP1 + offset];
        //| cmp TMP4d, MVM_BIGINT_32_FLAG;
        //| jne >1;
        //| mov TMP4d, dword [TMP2 + offset];
        //| cmp TMP4d, MVM_BIGINT_32_FLAG;
        //| jne >1;
        dasm_put(Dst, 3827, Dt26([a]), Dt26([b]), offset, MVM_BIGINT_32_FLAG, offset, MVM_BIGINT_32_FLAG);
#line 2535 "src/jit/x64/emit.dasc"

        /* Both smallint, so try to do the addition. If it overflows, fall
         * back to the slow path. */
        //| mov TMP4d, dword [TMP1 + val_offset]
        dasm_put(Dst, 3862, val_offset);
#line 2539 "src/jit/x64/emit.dasc"
        switch (op) {
            case MVM_OP_sp_add_I:
                //| add TMP4d, dword [TMP2 + val_offset]
                dasm_put(Dst, 3867, val_offset);
#line 2542 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_sp_sub_I:
                //| sub TMP4d, dword [TMP2 + val_offset]
                dasm_put(Dst, 3872, val_offset);
#line 2545 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_sp_mul_I:
                //| imul TMP4d, dword [TMP2 + val_offset]
                dasm_put(Dst, 3877, val_offset);
#line 2548 "src/jit/x64/emit.dasc"
                break;
        }
        //| jo >1
        dasm_put(Dst, 3883);
#line 2551 "src/jit/x64/emit.dasc"

        /* No overflow. See if it's in integer cache range. */
        //| cmp TMP4d, 14
        //| jg >2
        //| cmp TMP4d, -1
        //| jl >2
        //| inc TMP4d
        //| mov64 TMP2, (MVMuint64)cache
        //| mov TMP2, [TMP2 + TMP4d * 8]
        //| mov WORK[c], TMP2
        //| jmp >3
        //|2:
        //| mov dword [rbp-0x30], TMP4d;
        dasm_put(Dst, 3888, (unsigned int)((MVMuint64)cache), (unsigned int)(((MVMuint64)cache)>>32), Dt26([c]));
#line 2564 "src/jit/x64/emit.dasc"
        emit_fastcreate(tc, compiler, jg, ins);
        //| mov aword WORK[c], RV;
        //| mov TMP4d, dword [rbp-0x30];
        //| mov dword [RV + offset], MVM_BIGINT_32_FLAG
        //| mov dword [RV + val_offset], TMP4d
        //| mov WORK[c], RV
        //| jmp >3
        dasm_put(Dst, 3934, Dt26([c]), offset, MVM_BIGINT_32_FLAG, val_offset, Dt26([c]));
#line 2571 "src/jit/x64/emit.dasc"

        /* The slow path does a function call. Make sure to read the args
         * before storing the result value, in case they're aimed at the
         * same register. */
        //|1:
        dasm_put(Dst, 269);
#line 2576 "src/jit/x64/emit.dasc"
        emit_fastcreate(tc, compiler, jg, ins);
        //| mov ARG1, TC;
        //| mov ARG2, WORK[a];
        //| add ARG2, offset
        //| mov ARG3, WORK[b];
        //| add ARG3, offset
        //| mov aword WORK[c], RV;
        //| mov ARG4, RV;
        //| add ARG4, offset
        dasm_put(Dst, 3959, Dt26([a]), offset, Dt26([b]), offset, Dt26([c]), offset);
#line 2585 "src/jit/x64/emit.dasc"
        switch (op) {
            case MVM_OP_sp_add_I:
                //| callp &MVM_bigint_fallback_add;
                dasm_put(Dst, 116);
                dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_add)), (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_add) >> 32));
                dasm_put(Dst, 260);
#line 2588 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_sp_sub_I:
                //| callp &MVM_bigint_fallback_sub;
                dasm_put(Dst, 116);
                dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_sub)), (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_sub) >> 32));
                dasm_put(Dst, 260);
#line 2591 "src/jit/x64/emit.dasc"
                break;
            case MVM_OP_sp_mul_I:
                //| callp &MVM_bigint_fallback_mul;
                dasm_put(Dst, 116);
                dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_mul)), (MVMuint32)((uintptr_t)(&MVM_bigint_fallback_mul) >> 32));
                dasm_put(Dst, 260);
#line 2594 "src/jit/x64/emit.dasc"
                break;
        }
        //|3:
        dasm_put(Dst, 627);
#line 2597 "src/jit/x64/emit.dasc"
        break;
    }
    case MVM_OP_sp_bool_I: {
        MVMint16 dst = ins->operands[0].reg.orig;
        MVMint16 a = ins->operands[1].reg.orig;
        MVMint16 offset = ins->operands[2].lit_i16;
        MVMint16 val_offset = offset + 4;
        /* Is this a smallint? */
        //| mov TMP1, WORK[a];
        //| mov TMP4d, dword [TMP1 + offset];
        //| cmp TMP4d, MVM_BIGINT_32_FLAG;
        //| jne >1;
        dasm_put(Dst, 3991, Dt26([a]), offset, MVM_BIGINT_32_FLAG);
#line 2609 "src/jit/x64/emit.dasc"
        /* Smallbigint. Test the 32bit value for nonzero. */
        //| mov TMP4d, dword [TMP1 + val_offset]
        //| test TMP4d, TMP4d;
        //| setnz TMP3b;
        //| movzx TMP3, TMP3b;
        //| mov WORK[dst], TMP3;
        //| jmp >2
        //|1:
        dasm_put(Dst, 4009, val_offset, Dt26([dst]));
#line 2617 "src/jit/x64/emit.dasc"
        /* Bigint; check a->used for nonzero. */
        //| mov TMP4, [TMP1 + offset]
        //| mov TMP3d, dword MPINT:TMP4->used;
        //| test TMP3d, TMP3d;
        //| setnz TMP3b;
        //| movzx TMP3, TMP3b;
        //| mov WORK[dst], TMP3;
        //|2:
        dasm_put(Dst, 4035, offset, Dt23(->used), Dt26([dst]));
#line 2625 "src/jit/x64/emit.dasc"
        break;
    }
    default:
        MVM_panic(1, "Can't JIT opcode <%s>", ins->info->name);
    }
}



/* Call argument decoder */
static void load_call_arg(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                          MVMJitCallArg arg) {
    switch(arg.type) {
    case MVM_JIT_INTERP_VAR:
        switch (arg.v.ivar) {
        case MVM_JIT_INTERP_TC:
            //| mov TMP6, TC;
            dasm_put(Dst, 4061);
#line 2642 "src/jit/x64/emit.dasc"
            break;
        case MVM_JIT_INTERP_CU:
            //| mov TMP6, CU;
            dasm_put(Dst, 4066);
#line 2645 "src/jit/x64/emit.dasc"
            break;
        case MVM_JIT_INTERP_FRAME:
            //| mov TMP6, TC->cur_frame;
            dasm_put(Dst, 219, Dt25(->cur_frame));
#line 2648 "src/jit/x64/emit.dasc"
            break;
        case MVM_JIT_INTERP_PARAMS:
            //| mov TMP6, TC->cur_frame;
            //| lea TMP6, FRAME:TMP6->params;
            dasm_put(Dst, 4071, Dt25(->cur_frame), Dt2(->params));
#line 2652 "src/jit/x64/emit.dasc"
            break;
        case MVM_JIT_INTERP_CALLER:
            //| mov TMP6, TC->cur_frame;
            //| mov TMP6, aword FRAME:TMP6->caller;
            dasm_put(Dst, 4080, Dt25(->cur_frame), Dt2(->caller));
#line 2656 "src/jit/x64/emit.dasc"
            break;
        }
        break;
    case MVM_JIT_REG_VAL:
        //| mov TMP6, qword WORK[arg.v.reg];
        dasm_put(Dst, 4089, Dt26([arg.v.reg]));
#line 2661 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_REG_VAL_F:
        //| mov TMP6, qword WORK[arg.v.reg];
        dasm_put(Dst, 4089, Dt26([arg.v.reg]));
#line 2664 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_REG_ADDR:
        //| lea TMP6, WORK[arg.v.reg];
        dasm_put(Dst, 4094, Dt26([arg.v.reg]));
#line 2667 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_STR_IDX:
        //| get_string TMP6, arg.v.lit_i64;
         MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, arg.v.lit_i64);
        dasm_put(Dst, 4099, Dt27(->body.strings), Dt15([arg.v.lit_i64]));
#line 2670 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_LITERAL:
        //| mov TMP6, arg.v.lit_i64;
        dasm_put(Dst, 4108, arg.v.lit_i64);
#line 2673 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_LITERAL_64:
    case MVM_JIT_LITERAL_PTR:
    case MVM_JIT_LITERAL_F:
        //| mov64 TMP6, arg.v.lit_i64;
        dasm_put(Dst, 4113, (unsigned int)(arg.v.lit_i64), (unsigned int)((arg.v.lit_i64)>>32));
#line 2678 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_REG_STABLE:
        //| mov TMP6, qword WORK[arg.v.reg];
        //| mov TMP6, OBJECT:TMP6->st;
        dasm_put(Dst, 277, Dt26([arg.v.reg]), DtE(->st));
#line 2682 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_REG_OBJBODY:
        //| mov TMP6, qword WORK[arg.v.reg];
        //| lea TMP6, STOOGE:TMP6->data;
        dasm_put(Dst, 4118, Dt26([arg.v.reg]), DtF(->data));
#line 2686 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_REG_DYNIDX:
        //| get_cur_op TMP5;
        //| xor TMP6, TMP6;
        //| mov TMP6w, U16:TMP5[arg.v.reg];
        //| mov TMP6, qword [WORK + TMP6*8];
        dasm_put(Dst, 4127, Dt25(->interp_cur_op), Dt20([arg.v.reg]));
#line 2692 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_DATA_LABEL:
        //| lea TMP6, [=>(arg.v.lit_i64)];
        dasm_put(Dst, 4147, (arg.v.lit_i64));
#line 2695 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ARG_I64:
        //| mov TMP6, TC->cur_frame;
        //| mov TMP6, FRAME:TMP6->args;
        //| mov TMP6, qword REGISTER:TMP6[arg.v.lit_i64];
        dasm_put(Dst, 4152, Dt25(->cur_frame), Dt2(->args), Dt1([arg.v.lit_i64]));
#line 2700 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ARG_DOUBLE:
        //| mov TMP6, TC->cur_frame;
        //| mov TMP6, FRAME:TMP6->args;
        //| mov TMP6, qword REGISTER:TMP6[arg.v.lit_i64];
        dasm_put(Dst, 4152, Dt25(->cur_frame), Dt2(->args), Dt1([arg.v.lit_i64]));
#line 2705 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ARG_I64_RW:
        //| mov TMP6, TC->cur_frame;
        //| mov TMP6, FRAME:TMP6->args;
        //| lea TMP6, qword REGISTER:TMP6[arg.v.lit_i64];
        dasm_put(Dst, 4165, Dt25(->cur_frame), Dt2(->args), Dt1([arg.v.lit_i64]));
#line 2710 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ARG_PTR:
        //| mov TMP6, TC->cur_frame;
        //| mov TMP6, FRAME:TMP6->args;
        //| mov TMP6, qword REGISTER:TMP6[arg.v.lit_i64];
        //| mov TMP6, aword STOOGE:TMP6->data;
        dasm_put(Dst, 4178, Dt25(->cur_frame), Dt2(->args), Dt1([arg.v.lit_i64]), DtF(->data));
#line 2716 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ARG_VMARRAY:
        //| mov TMP6, TC->cur_frame;
        //| mov TMP6, FRAME:TMP6->args;
        //| mov TMP6, qword REGISTER:TMP6[arg.v.lit_i64];
        //| mov TMP6, aword VMARRAY:TMP6->body.slots;
        dasm_put(Dst, 4178, Dt25(->cur_frame), Dt2(->args), Dt1([arg.v.lit_i64]), Dt10(->body.slots));
#line 2722 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_PARAM_I64:
        //| mov TMP6, qword WORK[arg.v.lit_i64];
        dasm_put(Dst, 4089, Dt26([arg.v.lit_i64]));
#line 2725 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_PARAM_I64_RW:
        //| lea TMP6, qword WORK[arg.v.lit_i64];
        dasm_put(Dst, 4094, Dt26([arg.v.lit_i64]));
#line 2728 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_PARAM_DOUBLE:
        //| mov TMP6, qword WORK[arg.v.lit_i64];
        dasm_put(Dst, 4089, Dt26([arg.v.lit_i64]));
#line 2731 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_PARAM_PTR:
        //| mov TMP6, aword WORK[arg.v.lit_i64];
        //| mov TMP6, aword STOOGE:TMP6->data;
        dasm_put(Dst, 277, Dt26([arg.v.lit_i64]), DtF(->data));
#line 2735 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_PARAM_VMARRAY:
        //| mov TMP6, aword WORK[arg.v.lit_i64];
        //| mov TMP6, aword VMARRAY:TMP6->body.slots;
        dasm_put(Dst, 277, Dt26([arg.v.lit_i64]), Dt10(->body.slots));
#line 2739 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_SPESH_SLOT_VALUE:
        //| get_spesh_slot TMP6, arg.v.lit_i64;
        dasm_put(Dst, 4152, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([arg.v.lit_i64]));
#line 2742 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_STACK_VALUE:
        //| mov TMP6, [rbp-(0x28+arg.v.lit_i64*8)];
        dasm_put(Dst, 4195, -(0x28+arg.v.lit_i64*8));
#line 2745 "src/jit/x64/emit.dasc"
        break;
    default:
        MVM_oops(tc, "JIT: Unknown JIT argument type %d", arg.type);
    }
}

static void emit_gpr_arg(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                         MVMint32 i) {
    switch (i) {
    case 0:
        //| mov ARG1, TMP6;
        dasm_put(Dst, 4200);
#line 2756 "src/jit/x64/emit.dasc"
        break;
    case 1:
        //| mov ARG2, TMP6;
        dasm_put(Dst, 4204);
#line 2759 "src/jit/x64/emit.dasc"
        break;
    case 2:
        //| mov ARG3, TMP6;
        dasm_put(Dst, 4208);
#line 2762 "src/jit/x64/emit.dasc"
        break;
    case 3:
        //| mov ARG4, TMP6;
        dasm_put(Dst, 4212);
#line 2765 "src/jit/x64/emit.dasc"
        break;
//|.if POSIX
    case 4:
//|        mov ARG5, TMP6;
dasm_put(Dst, 4216);
       break;
#line 2770 "src/jit/x64/emit.dasc"
  case 5:
//|      mov ARG6, TMP6;
dasm_put(Dst, 4220);
     break;
#line 2773 "src/jit/x64/emit.dasc"
//|.endif
    default:
        MVM_oops(tc, "JIT: can't store %d arguments in GPR", i);
    }
}

static void emit_sse_arg(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                         MVMint32 i) {
    switch (i) {
    case 0:
        //| movd ARG1F, TMP6;
        dasm_put(Dst, 4224);
#line 2784 "src/jit/x64/emit.dasc"
        break;
    case 1:
        //| movd ARG2F, TMP6;
        dasm_put(Dst, 4230);
#line 2787 "src/jit/x64/emit.dasc"
        break;
    case 2:
        //| movd ARG3F, TMP6;
        dasm_put(Dst, 4236);
#line 2790 "src/jit/x64/emit.dasc"
        break;
    case 3:
        //| movd ARG4F, TMP6;
        dasm_put(Dst, 4242);
#line 2793 "src/jit/x64/emit.dasc"
        break;
//|.if POSIX
    case 4:
//|        movd ARG5F, TMP6;
dasm_put(Dst, 4248);
       break;
#line 2798 "src/jit/x64/emit.dasc"
    case 5:
//|         movd ARG6F, TMP6;
dasm_put(Dst, 4254);
        break;
#line 2801 "src/jit/x64/emit.dasc"
    case 6:
//|        movd ARG7F, TMP6;
dasm_put(Dst, 4261);
       break;
#line 2804 "src/jit/x64/emit.dasc"
    case 7:
//|        movd ARG8F, TMP6;
dasm_put(Dst, 4268);
       break;
#line 2807 "src/jit/x64/emit.dasc"
//|.endif
    default:
        MVM_oops(tc, "JIT: can't put  %d arguments in SSE", i);
    }
}

static void emit_stack_arg(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                           MVMint32 arg_size, MVMint32 pos) {
    /* basically, stack arguments are passed in right-to-left order
       on both POSIX and W64 backends, it seems. Thus the most logical
       thing to do is to count from the stack top upwards. */
    if (pos + arg_size > 160) {
        MVM_oops(tc, "JIT: trying to pass arguments "
                 " in local space (stack top offset:"
                 " %d, size: %d)", pos, arg_size);
    }
    switch(arg_size) {
    case 1:
        //| mov byte [rsp+pos], TMP6b;
        dasm_put(Dst, 4275, pos);
#line 2826 "src/jit/x64/emit.dasc"
        break;
    case 2:
        //| mov word [rsp+pos], TMP6w;
        dasm_put(Dst, 4282, pos);
#line 2829 "src/jit/x64/emit.dasc"
        break;
    case 4:
        //| mov dword [rsp+pos], TMP6d;
        dasm_put(Dst, 4283, pos);
#line 2832 "src/jit/x64/emit.dasc"
        break;
    case 8:
        //| mov qword [rsp+pos], TMP6;
        dasm_put(Dst, 4290, pos);
#line 2835 "src/jit/x64/emit.dasc"
        break;
    default:
        MVM_oops(tc, "JIT: can't pass arguments size %d bytes",
                 arg_size);
    }
}

static void emit_posix_callargs(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                                MVMJitCallArg args[], MVMint32 num_args) {
    MVMint32 num_gpr = 0, num_fpr = 0, num_stack = 0, i;
    MVMJitCallArg in_gpr[6], in_fpr[8], *on_stack = NULL;
    if (num_args > 6)
        on_stack = MVM_malloc(sizeof(MVMJitCallArg) * (num_args - 6));
    /* divide in gpr, fpr, stack values */
    for (i = 0; i < num_args; i++) {
        switch (args[i].type) {
        case MVM_JIT_INTERP_VAR:
        case MVM_JIT_REG_VAL:
        case MVM_JIT_REG_ADDR:
        case MVM_JIT_REG_OBJBODY:
        case MVM_JIT_REG_STABLE:
        case MVM_JIT_REG_DYNIDX:
        case MVM_JIT_STR_IDX:
        case MVM_JIT_LITERAL:
        case MVM_JIT_LITERAL_64:
        case MVM_JIT_LITERAL_PTR:
        case MVM_JIT_DATA_LABEL:
        case MVM_JIT_ARG_I64:
        case MVM_JIT_ARG_I64_RW:
        case MVM_JIT_ARG_PTR:
        case MVM_JIT_ARG_VMARRAY:
        case MVM_JIT_PARAM_I64:
        case MVM_JIT_PARAM_I64_RW:
        case MVM_JIT_PARAM_PTR:
        case MVM_JIT_PARAM_VMARRAY:
        case MVM_JIT_SPESH_SLOT_VALUE:
        case MVM_JIT_STACK_VALUE:
            if (num_gpr < 6) {
                in_gpr[num_gpr++] = args[i];
            } else {
                on_stack[num_stack++] = args[i];
            }
            break;
        case MVM_JIT_ARG_DOUBLE:
        case MVM_JIT_PARAM_DOUBLE:
        case MVM_JIT_REG_VAL_F:
        case MVM_JIT_LITERAL_F:
            if (num_fpr < 8) {
                in_fpr[num_fpr++] = args[i];
            } else {
                on_stack[num_stack++] = args[i];
            }
            break;
        default:
            MVM_oops(tc, "JIT: Unknown JIT argument type %d for emit_posix_callargs", args[i].type);
        }
    }
    for (i = 0; i < num_gpr; i++) {
        load_call_arg(tc, compiler, jg, in_gpr[i]);
        emit_gpr_arg(tc, compiler, jg, i);
    }
    for (i = 0; i < num_fpr; i++) {
        load_call_arg(tc, compiler, jg, in_fpr[i]);
        emit_sse_arg(tc, compiler, jg, i);
    }
    /* push right-to-left */
    for (i = 0; i < num_stack; i++) {
        load_call_arg(tc, compiler, jg, on_stack[i]);
        // I'm not sure this is correct, btw
        emit_stack_arg(tc, compiler, jg, 8, i*8);
    }
    if (on_stack)
        MVM_free(on_stack);
}

static void emit_win64_callargs(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                                MVMJitCallArg args[], MVMint32 num_args) {
    MVMint32 i;
    MVMint32 num_reg_args = (num_args > 4 ? 4 : num_args);
    for (i = 0; i < num_reg_args; i++) {
        load_call_arg(tc, compiler, jg, args[i]);
        if (args[i].type == MVM_JIT_REG_VAL_F ||
            args[i].type == MVM_JIT_LITERAL_F ||
            args[i].type == MVM_JIT_ARG_DOUBLE ||
            args[i].type == MVM_JIT_PARAM_DOUBLE) {
            emit_sse_arg(tc, compiler, jg, i);
        } else {
            emit_gpr_arg(tc, compiler, jg, i);
        }
    }
    for (; i < num_args; i++) {
        load_call_arg(tc, compiler, jg, args[i]);
        emit_stack_arg(tc, compiler, jg, 8, i * 8);
    }
}

void MVM_jit_emit_call_c(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                         MVMJitCallC * call_spec) {

    //|.if WIN32;
#line 2936 "src/jit/x64/emit.dasc"
    //|.else;
     emit_posix_callargs(tc, compiler, jg, call_spec->args, call_spec->num_args);
    //|.endif
    /* Emit the call. I think we should be able to do something smarter than
     * store the constant into the bytecode, like a data segment. But I'm
     * not sure. */
    //| callp call_spec->func_ptr;
    dasm_put(Dst, 116);
    dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(call_spec->func_ptr)), (MVMuint32)((uintptr_t)(call_spec->func_ptr) >> 32));
    dasm_put(Dst, 260);
#line 2943 "src/jit/x64/emit.dasc"
    /* right, now determine what to do with the return value */
    switch(call_spec->rv_mode) {
    case MVM_JIT_RV_VOID:
        break;
    case MVM_JIT_RV_INT:
    case MVM_JIT_RV_PTR:
        //| mov WORK[call_spec->rv_idx], RV;
        dasm_put(Dst, 415, Dt26([call_spec->rv_idx]));
#line 2950 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_NUM:
        //| movsd qword WORK[call_spec->rv_idx], RVF;
        dasm_put(Dst, 1949, Dt26([call_spec->rv_idx]));
#line 2953 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_DEREF:
        //| mov TMP1, [RV];
        //| mov WORK[call_spec->rv_idx], TMP1;
        dasm_put(Dst, 4297, Dt26([call_spec->rv_idx]));
#line 2957 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_ADDR:
        /* store local at address */
        //| mov TMP1, WORK[call_spec->rv_idx];
        //| mov [RV], TMP1;
        dasm_put(Dst, 4305, Dt26([call_spec->rv_idx]));
#line 2962 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_DYNIDX:
        /* store in register relative to cur_op */
        //| get_cur_op TMP1;
        //| xor TMP2, TMP2;
        //| mov TMP2w, word [TMP1 + call_spec->rv_idx*2];
        //| mov aword [WORK + TMP2*8], RV;
        dasm_put(Dst, 4313, Dt25(->interp_cur_op), call_spec->rv_idx*2);
#line 2969 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_DEREF_OR_VMNULL:
        //| test RV, RV;
        //| jz >4;
        //| mov TMP1, [RV];
        //| jmp >5;
        //|4:
        //| get_vmnull TMP1;
        //|5:
        //| mov WORK[call_spec->rv_idx], TMP1;
        dasm_put(Dst, 4332, Dt25(->instance), DtC(->VMNull), Dt26([call_spec->rv_idx]));
#line 2979 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_RV_TO_STACK:
        if (call_spec->rv_type == MVM_NATIVECALL_ARG_CHAR) {
        //| cbw;
        dasm_put(Dst, 4363);
#line 2983 "src/jit/x64/emit.dasc"
        }
        if (call_spec->rv_type == MVM_NATIVECALL_ARG_CHAR || call_spec->rv_type == MVM_NATIVECALL_ARG_SHORT) {
        //| cwde;
        dasm_put(Dst, 4364);
#line 2986 "src/jit/x64/emit.dasc"
        }
        if (call_spec->rv_type == MVM_NATIVECALL_ARG_CHAR || call_spec->rv_type == MVM_NATIVECALL_ARG_SHORT || call_spec->rv_type == MVM_NATIVECALL_ARG_INT) {
        //| cdqe;
        dasm_put(Dst, 4366);
#line 2989 "src/jit/x64/emit.dasc"
        }
        if (call_spec->rv_type == MVM_NATIVECALL_ARG_UCHAR) {
        //| and RV, 0xFF
        dasm_put(Dst, 4369);
#line 2992 "src/jit/x64/emit.dasc"
        }
        else if (call_spec->rv_type == MVM_NATIVECALL_ARG_USHORT) {
        //| and RV, 0xFFFF
        dasm_put(Dst, 4377);
#line 2995 "src/jit/x64/emit.dasc"
        }
        else if (call_spec->rv_type == MVM_NATIVECALL_ARG_UINT) {
        //| and RV, 0xFFFFFFFF
        dasm_put(Dst, 4386);
#line 2998 "src/jit/x64/emit.dasc"
        }
        else if (call_spec->rv_type == MVM_NATIVECALL_ARG_ULONG && sizeof(long) == 4) {
        //| and RV, 0xFFFFFFFF
        dasm_put(Dst, 4386);
#line 3001 "src/jit/x64/emit.dasc"
        }
        //| mov [rbp-(0x28+call_spec->rv_idx*8)], RV;
        dasm_put(Dst, 4392, -(0x28+call_spec->rv_idx*8));
#line 3003 "src/jit/x64/emit.dasc"
        break;
    }
}

void MVM_jit_emit_block_branch(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                               MVMJitBranch * branch) {
    MVMSpeshIns *ins = branch->ins;
    MVMint32 name = branch->dest;
    /* move gc sync point to the front so as to not have
     * awkward dispatching issues */
    //| gc_sync_point;
    dasm_put(Dst, 4397, Dt25(->gc_status));
    dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_gc_enter_from_interrupt)), (MVMuint32)((uintptr_t)(&MVM_gc_enter_from_interrupt) >> 32));
    dasm_put(Dst, 1729);
#line 3014 "src/jit/x64/emit.dasc"
    if (ins == NULL || ins->info->opcode == MVM_OP_goto) {
        if (name == MVM_JIT_BRANCH_EXIT) {
            //| jmp ->exit
            dasm_put(Dst, 4412);
#line 3017 "src/jit/x64/emit.dasc"
        } else {
            //| jmp =>(name)
            dasm_put(Dst, 4417, (name));
#line 3019 "src/jit/x64/emit.dasc"
        }
    } else {
        MVMint16 val = ins->operands[0].reg.orig;
        switch(ins->info->opcode) {
        case MVM_OP_if_i:
            //| mov rax, WORK[val];
            //| test rax, rax;
            //| jnz =>(name); // jump to dynamic label
            dasm_put(Dst, 4421, Dt26([val]), (name));
#line 3027 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_unless_i:
            //| mov rax, WORK[val];
            //| test rax, rax;
            //| jz =>(name);
            dasm_put(Dst, 4432, Dt26([val]), (name));
#line 3032 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_if_n:
            //| movd xmm0, qword WORK[val];
            //| xorpd xmm1, xmm1; // make it zero
            //| ucomisd xmm0, xmm1;
            //| jp =>(name);  // is NaN?
            //| jne =>(name); // not equal to zero? we're golden
            dasm_put(Dst, 4443, Dt26([val]), (name), (name));
#line 3039 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_unless_n:
            //| movd xmm0, qword WORK[val];
            //| xorpd xmm1, xmm1; // make it zero
            //| ucomisd xmm0, xmm1;
            //| jp >1; // is NaN
            //| jne >1; // is not zero
            //| jmp =>(name); // it is zero yay!
            //|1:
            dasm_put(Dst, 4464, Dt26([val]), (name));
#line 3048 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_if_s0:
        case MVM_OP_unless_s0:
            //| mov ARG1, TC;
            //| mov ARG2, WORK[val];
            //| callp &MVM_coerce_istrue_s;
            dasm_put(Dst, 4492, Dt26([val]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_coerce_istrue_s)), (MVMuint32)((uintptr_t)(&MVM_coerce_istrue_s) >> 32));
#line 3054 "src/jit/x64/emit.dasc"
            //| test RV, RV;
            dasm_put(Dst, 4502);
#line 3055 "src/jit/x64/emit.dasc"
            if (ins->info->opcode == MVM_OP_unless_s0)
                //| jz =>(name);
                dasm_put(Dst, 4439, (name));
#line 3057 "src/jit/x64/emit.dasc"
            else
                //| jnz =>(name);
                dasm_put(Dst, 4428, (name));
#line 3059 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_ifnonnull:
            //| mov TMP1, WORK[val];
            //| test TMP1, TMP1;
            //| jz >1;
            //| get_vmnull TMP2;
            //| cmp TMP1, TMP2;
            //| je >1;
            //| jmp =>(name);
            //|1:
            dasm_put(Dst, 4511, Dt26([val]), Dt25(->instance), DtC(->VMNull), (name));
#line 3069 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_if_s:
            //| mov TMP1, WORK[val];
            //| test TMP1, TMP1;
            //| jz >1;
            //| cmp dword STRING:TMP1->body.num_graphs, 0;
            //| je >1;
            //| jmp =>(name);
            //|1:
            dasm_put(Dst, 4543, Dt26([val]), Dt14(->body.num_graphs), (name));
#line 3078 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_unless_s:
            //| mov TMP1, WORK[val];
            //| test TMP1, TMP1;
            //| jz =>(name);
            //| cmp dword STRING:TMP1->body.num_graphs, 0;
            //| je =>(name);
            //|1:
            dasm_put(Dst, 4568, Dt26([val]), (name), Dt14(->body.num_graphs), (name));
#line 3086 "src/jit/x64/emit.dasc"
            break;
        case MVM_OP_indexat:
        case MVM_OP_indexnat: {
            MVMint16 offset = ins->operands[1].reg.orig;
            MVMuint32 str_idx = ins->operands[2].lit_str_idx;
            //| mov ARG1, TC;
            //| mov ARG2, WORK[val];
            //| mov ARG3, WORK[offset];
            //| get_string ARG4, str_idx;
            dasm_put(Dst, 4588, Dt26([val]), Dt26([offset]));
             MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, str_idx);
#line 3095 "src/jit/x64/emit.dasc"
            //| callp &MVM_string_char_at_in_string;
            dasm_put(Dst, 4601, Dt27(->body.strings), Dt15([str_idx]));
            dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_string_char_at_in_string)), (MVMuint32)((uintptr_t)(&MVM_string_char_at_in_string) >> 32));
            dasm_put(Dst, 260);
#line 3096 "src/jit/x64/emit.dasc"
            /* This subtlety is due to the value being overloaded to
             * -2 if it is out of bounds. Note that -1 is passed as a
             * 32 bit integer, but this magically works in a 64 bit
             * comparison because 32 bit values are sign-extended */
            //| cmp RV, -1;
            dasm_put(Dst, 4611);
#line 3101 "src/jit/x64/emit.dasc"
            if (ins->info->opcode == MVM_OP_indexat)
                //| jle =>(name);
                dasm_put(Dst, 4618, (name));
#line 3103 "src/jit/x64/emit.dasc"
            else {

                //| jne =>(name);
                dasm_put(Dst, 4428, (name));
#line 3106 "src/jit/x64/emit.dasc"
            }
            break;
        }
        default:
            MVM_panic(1, "JIT: Can't handle conditional <%s>", ins->info->name);
        }
    }
}

void MVM_jit_emit_label(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                        MVMint32 label) {
    //| =>(label):
    dasm_put(Dst, 245, (label));
#line 3118 "src/jit/x64/emit.dasc"
}

void MVM_jit_emit_branch(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMint32 label) {
    //| jmp =>(label);
    dasm_put(Dst, 4417, (label));
#line 3122 "src/jit/x64/emit.dasc"
}

void MVM_jit_emit_conditional_branch(MVMThreadContext *tc, MVMJitCompiler *compiler,
                                     MVMint32 cond, MVMint32 label, MVMuint8 test_type) {
    MVMint32 is_float = (test_type == MVM_reg_num32 || test_type == MVM_reg_num64);
    /* Intel Manual Vol 1 ch7 Table 7-4 'Conditional Jump Instructions',
     * also Table 8-7 'Setting of EFLAG Status Flags for Floating Point Number Comparisons' */
    switch (cond) {
    case MVM_JIT_LT:
        if (is_float) {
            /* CF & !PF */
            //| jp >1;
            //| jb =>(label);
            //|1:
            dasm_put(Dst, 4622, (label));
#line 3136 "src/jit/x64/emit.dasc"
        } else {
            /* SF ^ OF */
            //| jl =>(label);
            dasm_put(Dst, 4632, (label));
#line 3139 "src/jit/x64/emit.dasc"
        }
        break;
    case MVM_JIT_LE:
        if (is_float) {
            /* (CF | ZF) & !PF */
            //| jp >1;
            //| jbe =>(label);
            //|1:
            dasm_put(Dst, 4636, (label));
#line 3147 "src/jit/x64/emit.dasc"
        } else {
            /* (SF ^ OF) | ZF */
            //| jle =>(label);
            dasm_put(Dst, 4618, (label));
#line 3150 "src/jit/x64/emit.dasc"
        }
        break;
    case MVM_JIT_EQ:
        if (is_float) {
            /* ZF & !PF */
            //| jp >1;
            //| je =>(label);
            //|1:
            dasm_put(Dst, 4646, (label));
#line 3158 "src/jit/x64/emit.dasc"
        } else {
            /* ZF */
            //| je =>(label);
            dasm_put(Dst, 4439, (label));
#line 3161 "src/jit/x64/emit.dasc"
        }
        break;
    case MVM_JIT_NE:
        if (is_float) {
            /* PF | !ZF */
            //| jp =>(label);
            dasm_put(Dst, 4656, (label));
#line 3167 "src/jit/x64/emit.dasc"
        }
        /* !ZF */
        //| jne =>(label);
        dasm_put(Dst, 4428, (label));
#line 3170 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_GE:
        if (is_float) {
            /* !CF */
            //| jae =>(label);
            dasm_put(Dst, 4660, (label));
#line 3175 "src/jit/x64/emit.dasc"
        } else {
            /* !(SF ^ OF) */
            //| jge =>(label);
            dasm_put(Dst, 4664, (label));
#line 3178 "src/jit/x64/emit.dasc"
        }
        break;
    case MVM_JIT_GT:
        if (is_float) {
            /* !(CF | ZF) */
            //| ja =>(label);
            dasm_put(Dst, 4668, (label));
#line 3184 "src/jit/x64/emit.dasc"
        } else {
            /* !((SF ^ OF) | ZF) */
            //| jg =>(label);
            dasm_put(Dst, 4672, (label));
#line 3187 "src/jit/x64/emit.dasc"
        }
        break;
    case MVM_JIT_NZ:
        if (is_float) {
            /* PF set, Unordered to zero is nonzero */
            //| jp =>(label);
            dasm_put(Dst, 4656, (label));
#line 3193 "src/jit/x64/emit.dasc"
        }
        //| jnz =>(label);
        dasm_put(Dst, 4428, (label));
#line 3195 "src/jit/x64/emit.dasc"
        break;
    case MVM_JIT_ZR:
        if (is_float) {
            //| jp >1;
            //| jz =>(label);
            //|1:
            dasm_put(Dst, 4646, (label));
#line 3201 "src/jit/x64/emit.dasc"
        } else {
            //| jz =>(label);
            dasm_put(Dst, 4439, (label));
#line 3203 "src/jit/x64/emit.dasc"
        }
        break;
    default:
        abort();
    }

}

void MVM_jit_emit_guard(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                        MVMJitGuard *guard) {
    MVMint16 op        = guard->ins->info->opcode;
    MVMint16 obj       = guard->ins->operands[op == MVM_OP_sp_guardsf ? 0 : 1].reg.orig;
    /* load object and spesh slot value, except for those that don't need it */
    //| mov TMP1, WORK[obj];
    dasm_put(Dst, 577, Dt26([obj]));
#line 3217 "src/jit/x64/emit.dasc"
    if (op != MVM_OP_sp_guardjustconc && op != MVM_OP_sp_guardjusttype) {
        MVMint16 spesh_idx = guard->ins->operands[op == MVM_OP_sp_guardsf ? 1 : 2].lit_i16;
        //| get_spesh_slot TMP2, spesh_idx;
        dasm_put(Dst, 4676, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([spesh_idx]));
#line 3220 "src/jit/x64/emit.dasc"
    }
    if (op == MVM_OP_sp_guard) {
        /* object in question should just match the type, so it shouldn't
         * be zero, and the STABLE should be equal to the value in the spesh
         * slot */
        /* check for null */
        //| test TMP1, TMP1;
        //| jz >1;
        dasm_put(Dst, 4689);
#line 3228 "src/jit/x64/emit.dasc"
        /* get stable and compare */
        //| cmp TMP2, OBJECT:TMP1->st;
        //| jne >1;
        dasm_put(Dst, 4697, DtE(->st));
#line 3231 "src/jit/x64/emit.dasc"
        /* we're good, no need to deopt */
    } else if (op == MVM_OP_sp_guardtype) {
        /* object in question should be a type object, so it shouldn't
         * be zero, should not be concrete, and the STABLE should be
         * equal to the value in the spesh slot */
        /* check for null */
        //| test TMP1, TMP1;
        //| jz >1;
        dasm_put(Dst, 4689);
#line 3239 "src/jit/x64/emit.dasc"
        /* check if type object (not concrete) */
        //| test_type_object TMP1;
        dasm_put(Dst, 4706, DtE(->header.flags), MVM_CF_TYPE_OBJECT);
#line 3241 "src/jit/x64/emit.dasc"
        /* if zero, this is a concrete object, and we should deopt */
        //| jz >1;
        dasm_put(Dst, 3484);
#line 3243 "src/jit/x64/emit.dasc"
        /* get stable and compare */
        //| cmp TMP2, OBJECT:TMP1->st;
        //| jne >1;
        dasm_put(Dst, 4697, DtE(->st));
#line 3246 "src/jit/x64/emit.dasc"
        /* we're good, no need to deopt */
    } else if (op == MVM_OP_sp_guardconc) {
        /* object should be a non-null concrete (non-type) object */
        //| test TMP1, TMP1;
        //| jz >1;
        dasm_put(Dst, 4689);
#line 3251 "src/jit/x64/emit.dasc"
        /* shouldn't be type object */
        //| test_type_object TMP1;
        //| jnz >1;
        dasm_put(Dst, 4713, DtE(->header.flags), MVM_CF_TYPE_OBJECT);
#line 3254 "src/jit/x64/emit.dasc"
        /* should have our stable */
        //| cmp TMP2, OBJECT:TMP1->st;
        //| jne >1;
        dasm_put(Dst, 4697, DtE(->st));
#line 3257 "src/jit/x64/emit.dasc"
    } else if (op == MVM_OP_sp_guardsf) {
        /* Should be an MVMCode */
        //| cmp_repr_id TMP1, TMP3, MVM_REPR_ID_MVMCode;
        //| jne >1;
        //| cmp TMP2, CODE:TMP1->body.sf;
        //| jne >1;
        dasm_put(Dst, 4724, DtE(->st), Dt12(->REPR), Dt13(->ID), MVM_REPR_ID_MVMCode, Dt1D(->body.sf));
#line 3263 "src/jit/x64/emit.dasc"
    } else if (op == MVM_OP_sp_guardobj) {
        /* object should match that from the spesh slot */
        //| cmp TMP2, TMP1;
        //| jne >1;
        dasm_put(Dst, 4750);
#line 3267 "src/jit/x64/emit.dasc"
    } else if (op == MVM_OP_sp_guardnotobj) {
        /* object should not match that from the spesh slot */
        //| cmp TMP2, TMP1;
        //| je >1;
        dasm_put(Dst, 4758);
#line 3271 "src/jit/x64/emit.dasc"
    } else if (op == MVM_OP_sp_guardjustconc) {
        /* object should be a non-null concrete (non-type) object;
         * exact type doesn't matter */
        //| test TMP1, TMP1;
        //| jz >1;
        dasm_put(Dst, 4689);
#line 3276 "src/jit/x64/emit.dasc"
        /* shouldn't be type object */
        //| test_type_object TMP1;
        //| jnz >1;
        dasm_put(Dst, 4713, DtE(->header.flags), MVM_CF_TYPE_OBJECT);
#line 3279 "src/jit/x64/emit.dasc"
    } else if (op == MVM_OP_sp_guardjusttype) {
        /* object in question should be a type object, so it shouldn't
         * be zero, and should not be concrete */
        /* check for null */
        //| test TMP1, TMP1;
        //| jz >1;
        dasm_put(Dst, 4689);
#line 3285 "src/jit/x64/emit.dasc"
        /* should be type object */
        //| test_type_object TMP1;
        //| jz >1;
        dasm_put(Dst, 4766, DtE(->header.flags), MVM_CF_TYPE_OBJECT);
#line 3288 "src/jit/x64/emit.dasc"
    }
    /* If we're here, we didn't jump to deopt. Most of the time a guard
     * destination is the same real register, but if not then emit a store
     * here before jumping over the deopt code. */
    if (op != MVM_OP_sp_guardsf) {
        MVMint16 dest = guard->ins->operands[0].reg.orig;
        if (dest != obj)
            //| mov WORK[dest], TMP1
            dasm_put(Dst, 103, Dt26([dest]));
#line 3296 "src/jit/x64/emit.dasc"
    }
    //| jmp >2;
    //|1:
    dasm_put(Dst, 2711);
#line 3299 "src/jit/x64/emit.dasc"
    /* emit deopt */
    //| mov ARG1, TC;
    //| mov ARG2, guard->deopt_idx;
    //| callp &MVM_spesh_deopt_one;
    dasm_put(Dst, 108, guard->deopt_idx);
    dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_spesh_deopt_one)), (MVMuint32)((uintptr_t)(&MVM_spesh_deopt_one) >> 32));
    dasm_put(Dst, 260);
#line 3303 "src/jit/x64/emit.dasc"
    /* jump out */
    //| jmp ->exit;
    //|2:
    dasm_put(Dst, 4777);
#line 3306 "src/jit/x64/emit.dasc"
}

void MVM_jit_emit_invoke(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg, MVMJitInvoke *invoke) {
    MVMint16 i;
    MVMuint16 callsite_idx = invoke->callsite_idx;

    /* The return address for the interpreter */
    //| get_cur_op TMP2;
    //| mov TMP5, TC->cur_frame;
    //| mov aword FRAME:TMP5->return_address, TMP2;
    dasm_put(Dst, 4784, Dt25(->interp_cur_op), Dt25(->cur_frame), Dt2(->return_address));
#line 3316 "src/jit/x64/emit.dasc"

    /* Unless it's a resolve op (in which case we delay a lot of this)... */
    if (!invoke->is_resolve) {
        /* Store callsite in tmp6, which we use at the end of invoke */
        //| mov TMP6, CU->body.callsites;
        //| mov TMP6, CALLSITEPTR:TMP6[callsite_idx];
        dasm_put(Dst, 4099, Dt27(->body.callsites), Dt4([callsite_idx]));
#line 3322 "src/jit/x64/emit.dasc"

        /* Store callsite in the frame. I use TMP5 as it never conflicts
         * with argument passing (like TMP6, but unlike other TMP regs) */
        //| mov FRAME:TMP5->cur_args_callsite, TMP6;
        dasm_put(Dst, 4800, Dt2(->cur_args_callsite));
#line 3326 "src/jit/x64/emit.dasc"

        /* Setup the frame for returning to our current position */
        if (sizeof(MVMReturnType) == 1) {
            //| mov byte FRAME:TMP5->return_type, invoke->return_type;
            dasm_put(Dst, 4805, Dt2(->return_type), invoke->return_type);
#line 3330 "src/jit/x64/emit.dasc"
        } else {
            MVM_panic(1, "JIT: MVMReturnType has unexpected size");
        }

        /* The register for our return value */
        if (invoke->return_type == MVM_RETURN_VOID) {
            //| mov aword FRAME:TMP5->return_value, NULL;
            dasm_put(Dst, 4811, Dt2(->return_value), NULL);
#line 3337 "src/jit/x64/emit.dasc"
        } else {
            //| lea TMP2, WORK[invoke->return_register];
            //| mov aword FRAME:TMP5->return_value, TMP2;
            dasm_put(Dst, 4817, Dt26([invoke->return_register]), Dt2(->return_value));
#line 3340 "src/jit/x64/emit.dasc"
        }
    }

    /* Install invoke args */
    //| mov TMP5, FRAME:TMP5->args;
    dasm_put(Dst, 234, Dt2(->args));
#line 3345 "src/jit/x64/emit.dasc"
    for (i = 0;  i < invoke->arg_count; i++) {
        MVMSpeshIns *ins = invoke->arg_ins[i];
        switch (ins->info->opcode) {
        case MVM_OP_arg_i:
        case MVM_OP_arg_s:
        case MVM_OP_arg_n:
        case MVM_OP_arg_o: {
            MVMint16 dst = ins->operands[0].lit_i16;
            MVMint16 src = ins->operands[1].reg.orig;
            //| mov TMP4, WORK[src];
            //| mov REGISTER:TMP5[dst], TMP4;
            dasm_put(Dst, 4826, Dt26([src]), Dt1([dst]));
#line 3356 "src/jit/x64/emit.dasc"
            break;
        }
        case MVM_OP_argconst_n:
        case MVM_OP_argconst_i: {
            MVMint16 dst = ins->operands[0].lit_i16;
            MVMint64 val = ins->operands[1].lit_i64;
            //| mov64 TMP4, val;
            //| mov REGISTER:TMP5[dst], TMP4;
            dasm_put(Dst, 4835, (unsigned int)(val), (unsigned int)((val)>>32), Dt1([dst]));
#line 3364 "src/jit/x64/emit.dasc"
            break;
        }
        case MVM_OP_argconst_s: {
            MVMint16 dst = ins->operands[0].lit_i16;
            MVMint32 idx = ins->operands[1].lit_str_idx;
            //| get_string TMP4, idx;
             MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, idx);
#line 3370 "src/jit/x64/emit.dasc"
            //| mov REGISTER:TMP5[dst], TMP4;
            dasm_put(Dst, 4844, Dt27(->body.strings), Dt15([idx]), Dt1([dst]));
#line 3371 "src/jit/x64/emit.dasc"
            break;
        }
        default:
            MVM_panic(1, "JIT invoke: Can't add arg <%s>",
                      ins->info->name);
        }
    }

    if (invoke->is_fast) {
        /* call MVM_frame_invoke_code */
        //| mov ARG1, TC;
        //| mov ARG2, WORK[invoke->code_register_or_name];
        //| mov ARG3, TMP6; // this is the callsite object
        //| mov ARG4, invoke->spesh_cand_or_sf_slot;
        //| callp &MVM_frame_invoke_code;
        dasm_put(Dst, 4857, Dt26([invoke->code_register_or_name]), invoke->spesh_cand_or_sf_slot);
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_invoke_code)), (MVMuint32)((uintptr_t)(&MVM_frame_invoke_code) >> 32));
        dasm_put(Dst, 260);
#line 3386 "src/jit/x64/emit.dasc"
    } else if (invoke->is_resolve) {
        /* call MVM_spesh_plugin_resolve_jit, which will trampoline out of
         * the JIT-compiled code if need be */
        //| mov ARG1, TC;
        //| get_string ARG2, invoke->code_register_or_name;
        dasm_put(Dst, 420);
         MVM_cu_ensure_string_decoded(tc, jg->sg->sf->body.cu, invoke->code_register_or_name);
#line 3391 "src/jit/x64/emit.dasc"
        //| lea ARG3, WORK[invoke->return_register];
        //| mov ARG4, invoke->resolve_offset;
        //|.if WIN32
        //| get_spesh_slot rax, invoke->spesh_cand_or_sf_slot;
        //| mov ARG5, rax;
        //| mov rax, CU->body.callsites;
        //| mov rax, CALLSITEPTR:rax[callsite_idx];
        //| mov ARG6, rax;
        //|.else
        //| get_spesh_slot ARG5, invoke->spesh_cand_or_sf_slot;
        //| mov ARG6, CU->body.callsites;
        //| mov ARG6, CALLSITEPTR:ARG6[callsite_idx];
        //|.endif
        //| callp &MVM_spesh_plugin_resolve_jit;
        dasm_put(Dst, 4874, Dt27(->body.strings), Dt15([invoke->code_register_or_name]), Dt26([invoke->return_register]), invoke->resolve_offset, Dt25(->cur_frame), Dt2(->effective_spesh_slots), Dt15([invoke->spesh_cand_or_sf_slot]), Dt27(->body.callsites), Dt4([callsite_idx]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_spesh_plugin_resolve_jit)), (MVMuint32)((uintptr_t)(&MVM_spesh_plugin_resolve_jit) >> 32));
        dasm_put(Dst, 260);
#line 3405 "src/jit/x64/emit.dasc"
    } else {
        /* first, save callsite and args */
        //| mov qword [rbp-0x28], TMP5; // args
        //| mov qword [rbp-0x30], TMP6; // callsite
        dasm_put(Dst, 4912);
#line 3409 "src/jit/x64/emit.dasc"
        /* setup call MVM_frame_multi_ok(tc, code, &cur_callsite, args); */
        //| mov ARG1, TC;
        //| mov ARG2, WORK[invoke->code_register_or_name]; // code object
        //| lea ARG3, [rbp-0x30];                          // &cur_callsite
        //| mov ARG4, TMP5;                                // args
        //| mov ARG5, 0;                           // NULL to &was_multi
        //| callp &MVM_frame_find_invokee_multi_ok;
        dasm_put(Dst, 4921, Dt26([invoke->code_register_or_name]));
        dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee_multi_ok)), (MVMuint32)((uintptr_t)(&MVM_frame_find_invokee_multi_ok) >> 32));
        dasm_put(Dst, 260);
#line 3416 "src/jit/x64/emit.dasc"
        /* restore callsite, args, RV now holds code object */
        //| mov TMP6, [rbp-0x30]; // callsite
        //| mov TMP5, [rbp-0x28]; // args
        dasm_put(Dst, 4945);
#line 3419 "src/jit/x64/emit.dasc"
        /* setup args for call to invoke(tc, code, cur_callsite, args) */
        //| mov ARG1, TC;
        //| mov ARG2, RV;   // code object
        //| mov ARG3, TMP6; // callsite
        //| mov ARG4, TMP5; // args
        dasm_put(Dst, 4954);
#line 3424 "src/jit/x64/emit.dasc"
        /* get the actual function */
        //| mov FUNCTION, OBJECT:RV->st;
        //| mov FUNCTION, STABLE:FUNCTION->invoke;
        //| call FUNCTION;
        dasm_put(Dst, 4968, DtE(->st), Dt12(->invoke));
#line 3428 "src/jit/x64/emit.dasc"
    }
}

void MVM_jit_emit_jumplist(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitGraph *jg,
                           MVMJitJumpList *jumplist) {
    MVMint32 i;
    //| mov TMP1, WORK[jumplist->reg];
    //| cmp TMP1, 0;
    //| jl >2;
    //| cmp TMP1, jumplist->num_labels;
    //| jge >2;
    //| imul TMP1, 0x8; // 8 bytes per goto
    //| lea TMP2, [>1];
    //| add TMP2, TMP1;
    //| jmp TMP2;
    //|.align 8;
    //|1:
    dasm_put(Dst, 4981, Dt26([jumplist->reg]), jumplist->num_labels);
#line 3445 "src/jit/x64/emit.dasc"
    for (i = 0; i < jumplist->num_labels; i++) {
        //|=>(jumplist->in_labels[i]):
        //| jmp =>(jumplist->out_labels[i]);
        //|.align 8;
        dasm_put(Dst, 5023, (jumplist->in_labels[i]), (jumplist->out_labels[i]));
#line 3449 "src/jit/x64/emit.dasc"
    }
    //|2:
    dasm_put(Dst, 345);
#line 3451 "src/jit/x64/emit.dasc"
}

void MVM_jit_emit_control(MVMThreadContext *tc, MVMJitCompiler *compiler,
                          MVMJitControl *ctrl, MVMJitTile *tile) {
    MVMJitControlType type = (tile != NULL ? (MVMJitControlType)tile->args[0] : ctrl->type);
    if (type == MVM_JIT_CONTROL_BREAKPOINT) {
        /* Debug breakpoint */
        //| int 3;
        dasm_put(Dst, 5030);
#line 3459 "src/jit/x64/emit.dasc"
    } else {
        MVM_panic(1, "Unknown control code: <%s>", ctrl->ins->info->name);
    }
}


/* Convenience macros for testing the register class of a register id */
#define IS_GPR(x) ((x) >= MVM_JIT_REG(RAX) && (x) <= MVM_JIT_REG(R15))
#define IS_FPR(x) ((x) >= MVM_JIT_REG(XMM0) && (x) <= MVM_JIT_REG(XMM15))
#define REG_NUM(x) ((x) & 0xf)

void MVM_jit_emit_load(MVMThreadContext *tc, MVMJitCompiler *compiler,
                       MVMint8 reg_dst, MVMJitStorageClass mem_cls, MVMint32 mem_src, MVMint32 size) {
    MVMint8 mem_base;
    if (mem_cls == MVM_JIT_STORAGE_LOCAL) {
        mem_base = MVM_JIT_REG(RBX);
    } else if (mem_cls == MVM_JIT_STORAGE_STACK) {
        mem_base = MVM_JIT_REG(RSP);
    } else {
        abort();
    }
    if (IS_GPR(reg_dst)) {
        switch(size) {
        case 1:
            //| mov Rb(reg_dst), byte [Rq(mem_base)+mem_src];
            dasm_put(Dst, 5033, (reg_dst), (mem_base), mem_src);
#line 3484 "src/jit/x64/emit.dasc"
            return;
        case 2:
            //| mov Rw(reg_dst), word [Rq(mem_base)+mem_src];
            dasm_put(Dst, 5044, (reg_dst), (mem_base), mem_src);
#line 3487 "src/jit/x64/emit.dasc"
            return;
        case 4:
            //| mov Rd(reg_dst), dword [Rq(mem_base)+mem_src];
            dasm_put(Dst, 5045, (reg_dst), (mem_base), mem_src);
#line 3490 "src/jit/x64/emit.dasc"
            return;
        case 8:
            //| mov Rq(reg_dst), qword [Rq(mem_base)+mem_src];
            dasm_put(Dst, 5055, (reg_dst), (mem_base), mem_src);
#line 3493 "src/jit/x64/emit.dasc"
            return;
        }
    } else if (IS_FPR(reg_dst)) {
        MVMint8 reg_num = REG_NUM(reg_dst);
        switch(size) {
        case 8:
            //| movsd xmm(reg_num), qword [Rq(mem_base)+mem_src];
            dasm_put(Dst, 5066, (reg_num), (mem_base), mem_src);
#line 3500 "src/jit/x64/emit.dasc"
            return;
        }
    }
    abort();
}

void MVM_jit_emit_store(MVMThreadContext *tc, MVMJitCompiler *compiler,
                        MVMJitStorageClass mem_cls, MVMint32 mem_dst,
                        MVMint8 reg_src, MVMint32 size) {
    MVMint8 mem_base;
    if (mem_cls == MVM_JIT_STORAGE_LOCAL) {
        mem_base = MVM_JIT_REG(RBX);
    } else if (mem_cls == MVM_JIT_STORAGE_STACK) {
        mem_base = MVM_JIT_REG(RSP);
    } else {
        abort();
    }

    if (IS_GPR(reg_src)) {
        switch (size) {
        case 1:
            //| mov byte [Rq(mem_base)+mem_dst], Rb(reg_src);
            dasm_put(Dst, 5079, (reg_src), (mem_base), mem_dst);
#line 3522 "src/jit/x64/emit.dasc"
            return;
        case 2:
            //| mov word [Rq(mem_base)+mem_dst], Rw(reg_src);
            dasm_put(Dst, 5090, (reg_src), (mem_base), mem_dst);
#line 3525 "src/jit/x64/emit.dasc"
            return;
        case 4:
            //| mov dword [Rq(mem_base)+mem_dst], Rd(reg_src);
            dasm_put(Dst, 5091, (reg_src), (mem_base), mem_dst);
#line 3528 "src/jit/x64/emit.dasc"
            return;
        case 8:
            //| mov qword [Rq(mem_base)+mem_dst], Rq(reg_src);
            dasm_put(Dst, 5101, (reg_src), (mem_base), mem_dst);
#line 3531 "src/jit/x64/emit.dasc"
            return;
        }
    } else if (IS_FPR(reg_src)) {
        reg_src = reg_src & 0xf;
        switch (size) {
        case 8:
            //| movsd qword [Rq(mem_base)+mem_dst], xmm(reg_src);
            dasm_put(Dst, 5112, (reg_src), (mem_base), mem_dst);
#line 3538 "src/jit/x64/emit.dasc"
            return;
        }
    }
    abort();
}

void MVM_jit_emit_copy(MVMThreadContext *tc, MVMJitCompiler *compiler,
                       MVMint8 dst_reg, MVMint8 src_reg) {

    if (IS_GPR(dst_reg)) {
        if (IS_GPR(src_reg)) {
            //| mov Rq(dst_reg), Rq(src_reg);
            dasm_put(Dst, 5125, (src_reg), (dst_reg));
#line 3550 "src/jit/x64/emit.dasc"
        } else { // src_cls == MVM_JIT_STORAGE_FPR
            //| movd Rq(dst_reg), xmm(REG_NUM(src_reg));
            dasm_put(Dst, 5134, (REG_NUM(src_reg)), (dst_reg));
#line 3552 "src/jit/x64/emit.dasc"
        }
    } else if (IS_FPR(src_reg)) { // dst_cls == MVM_JIT_STORAGE_FPR
        //| movq xmm(REG_NUM(dst_reg)), xmm(REG_NUM(src_reg));
        dasm_put(Dst, 5145, (REG_NUM(dst_reg)), (REG_NUM(src_reg)));
#line 3555 "src/jit/x64/emit.dasc"
    } else { // src_cls == MVM_JIT_STORAGE_GPR
        //| movd xmm(REG_NUM(dst_reg)), Rq(src_reg);
        dasm_put(Dst, 5156, (REG_NUM(dst_reg)), (src_reg));
#line 3557 "src/jit/x64/emit.dasc"
    }
}


void MVM_jit_emit_marker(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMint32 num) {
    MVMint32 i;
    for (i = 0; i < num; i++) {
        //| nop;
        dasm_put(Dst, 5167);
#line 3565 "src/jit/x64/emit.dasc"
    }
}


void MVM_jit_emit_data(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitData *data) {
    MVMuint8 *bytes = data->data;
    size_t i;
    //|.data;
    dasm_put(Dst, 116);
#line 3573 "src/jit/x64/emit.dasc"
    //|=>(data->label):
    dasm_put(Dst, 245, (data->label));
#line 3574 "src/jit/x64/emit.dasc"
    for (i = 0; i < data->size; i++) {
        //|.byte bytes[i];
        dasm_put(Dst, 3330, bytes[i]);
#line 3576 "src/jit/x64/emit.dasc"
    }
    //|.code
    dasm_put(Dst, 0);
#line 3578 "src/jit/x64/emit.dasc"
}

void MVM_jit_emit_deopt_check(MVMThreadContext *tc, MVMJitCompiler *compiler) {
    //| mov TMP6, TC->cur_frame;
    //| mov TMP6, FRAME:TMP6->spesh_cand
    //| test TMP6, TMP6
    //| jnz >1
    //| jmp ->exit
    //|1:
    dasm_put(Dst, 5169, Dt25(->cur_frame), Dt2(->spesh_cand));
#line 3587 "src/jit/x64/emit.dasc"
}

/* import tiles */
//|.include src/jit/x64/tiles.dasc
#line 1 "src/jit/x64/tiles.dasc"
/* -*-C-*- */
#pragma GCC diagnostic ignored "-Wunused-variable"
#define DIE(...) do { MVM_oops(tc, __VA_ARGS__); } while (0)

/* NB: The rax/eax/ax/al/ah register is *reserved* for internal use in tiles by
 * the register allocator. Using rax will never overwrite an allocated value */

/* basic memory traffic tiles */
MVM_JIT_TILE_DECL(addr) {
    MVMint8 out  = tile->values[0];
    MVMint8 base = tile->values[1];
    MVMint32 ofs = tile->args[0];
    //| lea Rq(out), [Rq(base)+ofs];
    dasm_put(Dst, 5191, (out), (base), ofs);
#line 14 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(idx) {
    MVMint8 out  = tile->values[0];
    MVMint8 base = tile->values[1];
    MVMint8 idx  = tile->values[2];
    MVMint8 scl  = tile->args[0];
    if (scl == 8) {
        //| lea Rq(out), [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5202, (out), (idx), (base), 0);
#line 24 "src/jit/x64/tiles.dasc"
    } else {
        DIE("Unsupported scale: %d", scl);
    }
}


MVM_JIT_TILE_DECL(const_reg) {
    MVMint8 out = tile->values[0];
    MVMint32 val  = tile->args[0];
    MVMint32 size = tile->args[1];
    //| mov Rq(out), val;
    dasm_put(Dst, 5216, (out), val);
#line 35 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(const_large) {
    MVMint8 out = tile->values[0];
    MVMint64 val = tree->constants[tile->args[0]].i;
    //| mov64 Rq(out), val;
    dasm_put(Dst, 5224, (out), (unsigned int)(val), (unsigned int)((val)>>32));
#line 41 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(const_num) {
    MVMuint8 out = tile->values[0] - MVM_JIT_REG(XMM0);
    MVMnum64 val = tree->constants[tile->args[0]].n;
    unsigned char bytes[sizeof(val)];
    size_t i;
    memcpy(bytes, &val, sizeof(val));
    //|.data;
    dasm_put(Dst, 116);
#line 50 "src/jit/x64/tiles.dasc"
    //|5:
    dasm_put(Dst, 5232);
#line 51 "src/jit/x64/tiles.dasc"
    for (i = 0; i < sizeof(bytes); i++) {
        //|.byte bytes[i];
        dasm_put(Dst, 3330, bytes[i]);
#line 53 "src/jit/x64/tiles.dasc"
    }
    //|.code;
    dasm_put(Dst, 0);
#line 55 "src/jit/x64/tiles.dasc"
    //| movsd xmm(out), qword [<5];
    dasm_put(Dst, 5235, (out));
#line 56 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(load_reg) {
    MVMint8 out  = tile->values[0];
    MVMint8 base = tile->values[1];
    MVMint32 size = tile->args[0];
    switch (size) {
    case 1:
        //| mov Rb(out), [Rq(base)];
        dasm_put(Dst, 5246, (out), (base), 0);
#line 65 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov Rw(out), [Rq(base)];
        dasm_put(Dst, 5044, (out), (base), 0);
#line 68 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov Rd(out), [Rq(base)];
        dasm_put(Dst, 5045, (out), (base), 0);
#line 71 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov Rq(out), [Rq(base)];
        dasm_put(Dst, 5055, (out), (base), 0);
#line 74 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(load_addr) {
    MVMint8 out  = tile->values[0];
    MVMint8 base = tile->values[1];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    switch (tile->args[1]) {
    case 1:
        //| mov Rb(out), byte [Rq(base)+ofs];
        dasm_put(Dst, 5033, (out), (base), ofs);
#line 88 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov Rw(out), word [Rq(base)+ofs];
        dasm_put(Dst, 5044, (out), (base), ofs);
#line 91 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov Rd(out), dword [Rq(base)+ofs];
        dasm_put(Dst, 5045, (out), (base), ofs);
#line 94 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov Rq(out), qword [Rq(base)+ofs];
        dasm_put(Dst, 5055, (out), (base), ofs);
#line 97 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(load_idx) {
    MVMint8 out  = tile->values[0];
    MVMint8 base = tile->values[1];
    MVMint8 idx  = tile->values[2];
    MVMint8 scl  = tile->args[0];
    MVMint32 size = tile->args[1];
    if (scl != 8) {
        DIE("Unsupported scale size: %d\n", scl);
    }
    switch (size) {
    case 1:
        //| mov Rb(out), byte [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5256, (out), (idx), (base), 0);
#line 115 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov Rw(out), word [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5270, (out), (idx), (base), 0);
#line 118 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov Rd(out), dword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5271, (out), (idx), (base), 0);
#line 121 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov Rq(out), qword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5284, (out), (idx), (base), 0);
#line 124 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(load_num) {
    MVMint8 out = REG_NUM(tile->values[0]);
    MVMint8 addr = tile->values[1];
    //| movsd xmm(out), qword [Rq(addr)];
    dasm_put(Dst, 5066, (out), (addr), 0);
#line 134 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(load_num_addr) {
    MVMint8 out = REG_NUM(tile->values[0]);
    MVMint8 addr = tile->values[1];
    MVMint32 ofs  = tile->args[0];
    //| movsd xmm(out), qword [Rq(addr)+ofs];
    dasm_put(Dst, 5066, (out), (addr), ofs);
#line 141 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(store) {
    MVMint8 base  = tile->values[1];
    MVMint8 value = tile->values[2];
    MVMint32 size = tile->args[0];
    switch (size) {
    case 1:
        //| mov byte [Rq(base)], Rb(value);
        dasm_put(Dst, 5079, (value), (base), 0);
#line 151 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov word [Rq(base)], Rw(value);
        dasm_put(Dst, 5090, (value), (base), 0);
#line 154 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov dword [Rq(base)], Rd(value);
        dasm_put(Dst, 5091, (value), (base), 0);
#line 157 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov qword [Rq(base)], Rq(value);
        dasm_put(Dst, 5101, (value), (base), 0);
#line 160 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported store size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(store_addr) {
    MVMint8 base  = tile->values[1];
    MVMint8 value = tile->values[2];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    switch (size) {
    case 1:
        //| mov byte [Rq(base)+ofs], Rb(value);
        dasm_put(Dst, 5079, (value), (base), ofs);
#line 174 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov word [Rq(base)+ofs], Rw(value);
        dasm_put(Dst, 5090, (value), (base), ofs);
#line 177 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov dword [Rq(base)+ofs], Rd(value);
        dasm_put(Dst, 5091, (value), (base), ofs);
#line 180 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov qword [Rq(base)+ofs], Rq(value);
        dasm_put(Dst, 5101, (value), (base), ofs);
#line 183 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported store size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(store_idx) {
    MVMint8 base = tile->values[1];
    MVMint8 idx  = tile->values[2];
    MVMint8 scl  = tile->args[0];
    MVMint32 size = tile->args[1];
    MVMint8 value = tile->values[3];
    if (scl != 8)
        DIE("Scale %d NYI\n", scl);
    switch (size) {
    case 1:
        //| mov byte [Rq(base)+Rq(idx)*8], Rb(value);
        dasm_put(Dst, 5298, (value), (idx), (base), 0);
#line 200 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| mov word [Rq(base)+Rq(idx)*8], Rw(value);
        dasm_put(Dst, 5312, (value), (idx), (base), 0);
#line 203 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| mov dword [Rq(base)+Rq(idx)*8], Rd(value);
        dasm_put(Dst, 5313, (value), (idx), (base), 0);
#line 206 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| mov qword [Rq(base)+Rq(idx)*8], Rq(value);
        dasm_put(Dst, 5326, (value), (idx), (base), 0);
#line 209 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported store size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(store_num) {
    MVMint8 addr = tile->values[1];
    MVMint8 val =  tile->values[2] - MVM_JIT_REG(XMM0);
    //| movsd qword [Rq(addr)], xmm(val);
    dasm_put(Dst, 5112, (val), (addr), 0);
#line 219 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(store_num_addr) {
    MVMint8 addr  = tile->values[1];
    MVMint8 value = REG_NUM(tile->values[2]);
    MVMint32 ofs  = tile->args[0];
    //| movsd qword [Rq(addr)+ofs], xmm(value);
    dasm_put(Dst, 5112, (value), (addr), ofs);
#line 226 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(cast_signed) {
    MVMint32 to_size   = tile->args[0];
    MVMint32 from_size = tile->args[1];

    MVMint8  to_reg    = tile->values[0];
    MVMint8  from_reg  = tile->values[1];

    /* possible combinations: 1 -> 2, 4, 8; 2 -> 4, 8; 4 -> 8
     * Hence we can combine from_size | (to_size << 3) to get
     * the following options:
     * 1 + 2<<3 == 17
     * 1 + 4<<3 == 33
     * 1 + 8<<3 == 65
     * 2 + 4<<3 == 34
     * 2 + 8<<3 == 66
     * 4 + 8<<3 == 68
     */
    MVMint32 size_conv = (from_size) | (to_size << 3);
    switch (size_conv) {
    case 17:
        //| movsx Rw(to_reg), Rb(from_reg);
        dasm_put(Dst, 5340, (to_reg), (from_reg));
#line 250 "src/jit/x64/tiles.dasc"
        break;
    case 33:
        //| movsx Rd(to_reg), Rb(from_reg);
        dasm_put(Dst, 5341, (to_reg), (from_reg));
#line 253 "src/jit/x64/tiles.dasc"
        break;
    case 34:
        //| movsx Rd(to_reg), Rw(from_reg);
        dasm_put(Dst, 5351, (to_reg), (from_reg));
#line 256 "src/jit/x64/tiles.dasc"
        break;
    case 65:
        //| movsx Rq(to_reg), Rb(from_reg);
        dasm_put(Dst, 5360, (to_reg), (from_reg));
#line 259 "src/jit/x64/tiles.dasc"
        break;
    case 66:
        //| movsx Rq(to_reg), Rw(from_reg);
        dasm_put(Dst, 5370, (to_reg), (from_reg));
#line 262 "src/jit/x64/tiles.dasc"
        break;
    case 68:
        /* movsx is apparantly not defined for double-to-quadword conversions,
         * which forces us to use the rax register like it's 1978. It might be easier
         * to bithack the sign-extension manually, but I'm not sure how.. */
        //| mov eax, Rd(from_reg);
        //| cdqe;
        //| mov Rq(to_reg), rax;
        dasm_put(Dst, 5380, (from_reg), (to_reg));
#line 270 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported signed cast %d -> %d\n", from_size, to_size);
    }
}

MVM_JIT_TILE_DECL(cast_unsigned) {
    MVMint32 to_size   = tile->args[0];
    MVMint32 from_size = tile->args[1];

    MVMint8  to_reg    = tile->values[0];
    MVMint8  from_reg  = tile->values[1];

    /* Same combination set as above, but we also support casting down:
     * 8 -> 1 = 8  (1<<3 = 8, 8 | 8 = 8)
     * 4 -> 1 = 12
     * 2 -> 1 = 10
     * 8 -> 2 = 24
     * 4 -> 2 = 20
     * 8 -> 4 = 40
     */
    MVMint32 size_conv = (from_size) | (to_size << 3);
    switch (size_conv) {
    case 8:  /* 8 -> 1 */
    case 10: /* 2 -> 1 */
    case 12: /* 4 -> 1 */
        //| movzx Rd(to_reg), Rb(from_reg);
        dasm_put(Dst, 5394, (to_reg), (from_reg));
#line 297 "src/jit/x64/tiles.dasc"
        break;
    case 17: /* 1 -> 2 */
        //| movzx Rw(to_reg), Rb(from_reg);
        dasm_put(Dst, 5404, (to_reg), (from_reg));
#line 300 "src/jit/x64/tiles.dasc"
        break;
    case 20: /* 4 -> 2 */
    case 24: /* 8 -> 2 */
        //| movzx Rd(to_reg), Rw(to_reg);
        dasm_put(Dst, 5415, (to_reg), (to_reg));
#line 304 "src/jit/x64/tiles.dasc"
        break;
    case 33: /* 1 -> 4 */
        //| movzx Rd(to_reg), Rb(from_reg);
        dasm_put(Dst, 5394, (to_reg), (from_reg));
#line 307 "src/jit/x64/tiles.dasc"
        break;
    case 34: /* 2 -> 4 */
        //| movzx Rd(to_reg), Rw(from_reg);
        dasm_put(Dst, 5415, (to_reg), (from_reg));
#line 310 "src/jit/x64/tiles.dasc"
        break;
    case 40: /* 8 -> 4 */
        //| mov Rd(to_reg), Rd(from_reg);
        dasm_put(Dst, 5424, (from_reg), (to_reg));
#line 313 "src/jit/x64/tiles.dasc"
        break;
    case 65: /* 1 -> 8 */
        //| movzx Rq(to_reg), Rb(from_reg);
        dasm_put(Dst, 5432, (to_reg), (from_reg));
#line 316 "src/jit/x64/tiles.dasc"
        break;
    case 66: /* 2 -> 8 */
        //| movzx Rq(to_reg), Rw(from_reg);
        dasm_put(Dst, 5442, (to_reg), (from_reg));
#line 319 "src/jit/x64/tiles.dasc"
        break;
    case 68: /* 4 -> 8 */
        /* In contrast to signed cast, nothing special is necessary to cast
         * unsigned doublewords to quadwords, because using the lower 4 bytes
         * automatically clears the upper 4 */
        //| mov Rd(to_reg), Rd(from_reg);
        dasm_put(Dst, 5424, (from_reg), (to_reg));
#line 325 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported unsigned cast %d -> %d (%d)\n", from_size, to_size, size_conv);
    }

}


/* Logic is the same as cast above except loading from memory instead of reg */
/* See comments in cast above for more detail */
MVM_JIT_TILE_DECL(cast_signed_load_addr) {
    MVMint32 ofs       = tile->args[0];
    MVMint32 load_size = tile->args[1];
    MVMint32 to_size   = tile->args[2];
    MVMint32 from_size = tile->args[3];

    MVMint8  to_reg    = tile->values[0];
    MVMint8  base      = tile->values[1];

    MVMint32 size_conv = (from_size) | (to_size << 3);
    switch (size_conv) {
    case 17:
        //| movsx Rw(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5452, (to_reg), (base), ofs);
#line 348 "src/jit/x64/tiles.dasc"
        break;
    case 33:
        //| movsx Rd(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5453, (to_reg), (base), ofs);
#line 351 "src/jit/x64/tiles.dasc"
        break;
    case 34:
        //| movsx Rd(to_reg), word [Rq(base)+ofs];
        dasm_put(Dst, 5465, (to_reg), (base), ofs);
#line 354 "src/jit/x64/tiles.dasc"
        break;
    case 65:
        //| movsx Rq(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5476, (to_reg), (base), ofs);
#line 357 "src/jit/x64/tiles.dasc"
        break;
    case 66:
        //| movsx Rq(to_reg), word [Rq(base)+ofs];
        dasm_put(Dst, 5488, (to_reg), (base), ofs);
#line 360 "src/jit/x64/tiles.dasc"
        break;
    case 68:
        //| mov eax, dword [Rq(base)+ofs];
        //| cdqe;
        //| mov Rq(to_reg), rax;
        dasm_put(Dst, 5500, (base), ofs, (to_reg));
#line 365 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported signed cast with load %d -> %d\n", from_size, to_size);
    }
}

/* Logic is the same as cast above except loading from memory instead of reg */
/* See comments in cast above for more detail */
MVM_JIT_TILE_DECL(cast_unsigned_load_addr) {
    MVMint32 ofs       = tile->args[0];
    MVMint32 load_size = tile->args[1];
    MVMint32 to_size   = tile->args[2];
    MVMint32 from_size = tile->args[3];

    MVMint8  to_reg    = tile->values[0];
    MVMint8  base      = tile->values[1];

    MVMint32 size_conv = (from_size) | (to_size << 3);
    switch (size_conv) {
    case 8:  /* 8 -> 1 */
    case 10: /* 2 -> 1 */
    case 12: /* 4 -> 1 */
        //| movzx Rd(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5516, (to_reg), (base), ofs);
#line 388 "src/jit/x64/tiles.dasc"
        break;
    case 17: /* 1 -> 2 */
        //| movzx Rw(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5528, (to_reg), (base), ofs);
#line 391 "src/jit/x64/tiles.dasc"
        break;
    case 20: /* 4 -> 2 */
    case 24: /* 8 -> 2 */
        //| movzx Rd(to_reg), word [Rq(base)+ofs];
        dasm_put(Dst, 5541, (to_reg), (base), ofs);
#line 395 "src/jit/x64/tiles.dasc"
        break;
    case 33: /* 1 -> 4 */
        //| movzx Rd(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5516, (to_reg), (base), ofs);
#line 398 "src/jit/x64/tiles.dasc"
        break;
    case 34: /* 2 -> 4 */
        //| movzx Rd(to_reg), word [Rq(base)+ofs];
        dasm_put(Dst, 5541, (to_reg), (base), ofs);
#line 401 "src/jit/x64/tiles.dasc"
        break;
    case 40: /* 8 -> 4 */
        //| mov Rd(to_reg), dword [Rq(base)+ofs];
        dasm_put(Dst, 5045, (to_reg), (base), ofs);
#line 404 "src/jit/x64/tiles.dasc"
        break;
    case 65: /* 1 -> 8 */
        //| movzx Rq(to_reg), byte [Rq(base)+ofs];
        dasm_put(Dst, 5552, (to_reg), (base), ofs);
#line 407 "src/jit/x64/tiles.dasc"
        break;
    case 66: /* 2 -> 8 */
        //| movzx Rq(to_reg), word [Rq(base)+ofs];
        dasm_put(Dst, 5564, (to_reg), (base), ofs);
#line 410 "src/jit/x64/tiles.dasc"
        break;
    case 68: /* 4 -> 8 */
        //| mov Rd(to_reg),  dword [Rq(base)+ofs];
        dasm_put(Dst, 5045, (to_reg), (base), ofs);
#line 413 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported unsigned cast with load %d -> %d (size_conv=%d)\n", from_size, to_size, size_conv);
    }
}


/* binary operations have special requirements because x86 is two-operand form, e.g:
 * r0 = r0 <op> r1
 * whereas the JIT uses a three-operand model:
 * r0 = r1 <op> r2 */

static void ensure_two_operand_pre(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitTile *tile, MVMint8 reg[2]) {
    MVMint8 out = tile->values[0], in1 = tile->values[1], in2 = tile->values[2];
    assert(out == in1);
    reg[0] = REG_NUM(out);
    reg[1] = REG_NUM(in2);
}

static void ensure_two_operand_post(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitTile *tile, MVMint8 reg[2]) {
}


MVM_JIT_TILE_DECL(add_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| add Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5576, (reg[1]), (reg[0]));
#line 440 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(add_const) {
    MVMint8 out = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint32 val = tile->args[0];
    MVMint32 sz  = tile->args[1];
    if (out != in1) {
        //| mov Rq(out), Rq(in1);
        dasm_put(Dst, 5125, (in1), (out));
#line 450 "src/jit/x64/tiles.dasc"
    }
    //| add Rq(out), val;
    dasm_put(Dst, 5585, (out), val);
#line 452 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(add_load_addr) {
    MVMint8 out   = tile->values[0];
    MVMint8 in1   = tile->values[1];
    MVMint8 base  = tile->values[2];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out == in1);
    switch (size) {
    case 1:
        //| add Rb(out), byte [Rq(base)+ofs];
        dasm_put(Dst, 5593, (out), (base), ofs);
#line 464 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| add Rw(out), word [Rq(base)+ofs];
        dasm_put(Dst, 5604, (out), (base), ofs);
#line 467 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| add Rd(out), dword [Rq(base)+ofs];
        dasm_put(Dst, 5605, (out), (base), ofs);
#line 470 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| add Rq(out), qword [Rq(base)+ofs];
        dasm_put(Dst, 5615, (out), (base), ofs);
#line 473 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(add_load_idx) {
    MVMint8 out  = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint8 base = tile->values[2];
    MVMint8 idx  = tile->values[3];
    MVMint32 scl  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out == in1);
    if (scl != 8)
        DIE("IDX Scale %d NYI\n", scl);
    switch (size) {
    case 1:
        //| add Rb(out), byte [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5626, (out), (idx), (base), 0);
#line 492 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| add Rw(out), word [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5640, (out), (idx), (base), 0);
#line 495 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| add Rd(out), dword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5641, (out), (idx), (base), 0);
#line 498 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| add Rq(out), qword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5654, (out), (idx), (base), 0);
#line 501 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(add_num) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| addsd xmm(reg[0]), xmm(reg[1]);
    dasm_put(Dst, 5668, (reg[0]), (reg[1]));
#line 511 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(sub_num) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| subsd xmm(reg[0]), xmm(reg[1]);
    dasm_put(Dst, 5679, (reg[0]), (reg[1]));
#line 518 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(mul_num) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| mulsd xmm(reg[0]), xmm(reg[1]);
    dasm_put(Dst, 5690, (reg[0]), (reg[1]));
#line 525 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}



MVM_JIT_TILE_DECL(and_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| and Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5701, (reg[1]), (reg[0]));
#line 534 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(and_const) {
    MVMint8 out = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint32 val = tile->args[0];
    MVMint32 sz  = tile->args[1];
    assert(out == in1);
    //| and Rq(out), val;
    dasm_put(Dst, 5710, (out), val);
#line 544 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(and_load_addr) {
    MVMint8 out   = tile->values[0];
    MVMint8 in1   = tile->values[1];
    MVMint8 base  = tile->values[2];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out == in1);
    switch (size) {
    case 1:
        //| and Rb(out), byte [Rq(base)+ofs];
        dasm_put(Dst, 5718, (out), (base), ofs);
#line 556 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| and Rw(out), word [Rq(base)+ofs];
        dasm_put(Dst, 5729, (out), (base), ofs);
#line 559 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| and Rd(out), dword [Rq(base)+ofs];
        dasm_put(Dst, 5730, (out), (base), ofs);
#line 562 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| and Rq(out), qword [Rq(base)+ofs];
        dasm_put(Dst, 5740, (out), (base), ofs);
#line 565 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(and_load_idx) {
    MVMint8 out  = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint8 base = tile->values[2];
    MVMint8 idx  = tile->values[3];
    MVMint32 scl  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out == in1);
    if (scl != 8)
        DIE("IDX Scale %d NYI\n", scl);
    switch (size) {
    case 1:
        //| and Rb(out), byte [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5751, (out), (idx), (base), 0);
#line 584 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| and Rw(out), word [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5765, (out), (idx), (base), 0);
#line 587 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| and Rd(out), dword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5766, (out), (idx), (base), 0);
#line 590 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| and Rq(out), qword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5779, (out), (idx), (base), 0);
#line 593 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(mul_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| imul Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5793, (reg[0]), (reg[1]));
#line 603 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(or_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| or Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5803, (reg[1]), (reg[0]));
#line 610 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(xor_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| xor Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5812, (reg[1]), (reg[0]));
#line 617 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(not_reg) {
    MVMint8 out = tile->values[0];
    MVMint8 in  = tile->values[1];
    assert(out == in);
    //| not Rq(out);
    dasm_put(Dst, 5821, (out));
#line 625 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(sub_reg) {
    MVMint8 reg[2];
    ensure_two_operand_pre(tc, compiler, tile, reg);
    //| sub Rq(reg[0]), Rq(reg[1]);
    dasm_put(Dst, 5829, (reg[1]), (reg[0]));
#line 631 "src/jit/x64/tiles.dasc"
    ensure_two_operand_post(tc, compiler, tile, reg);
}

MVM_JIT_TILE_DECL(sub_const) {
    MVMint8 out = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint32 val = tile->args[0];
    MVMint32 sz  = tile->args[1];
    assert(out == in1);
    //| sub Rq(out), val;
    dasm_put(Dst, 5838, (out), val);
#line 641 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(sub_load_addr) {
    MVMint8 out   = tile->values[0];
    MVMint8 in1   = tile->values[1];
    MVMint8 base  = tile->values[2];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out == in1);
    switch (size) {
    case 1:
        //| sub Rb(out), byte [Rq(base)+ofs];
        dasm_put(Dst, 5847, (out), (base), ofs);
#line 653 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| sub Rw(out), word [Rq(base)+ofs];
        dasm_put(Dst, 5858, (out), (base), ofs);
#line 656 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| sub Rd(out), dword [Rq(base)+ofs];
        dasm_put(Dst, 5859, (out), (base), ofs);
#line 659 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| sub Rq(out), qword [Rq(base)+ofs];
        dasm_put(Dst, 5869, (out), (base), ofs);
#line 662 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}

MVM_JIT_TILE_DECL(sub_load_idx) {
    MVMint8 out  = tile->values[0];
    MVMint8 in1  = tile->values[1];
    MVMint8 base = tile->values[2];
    MVMint8 idx  = tile->values[3];
    MVMint32 scl  = tile->args[0];
    MVMint32 size = tile->args[1];
    assert(out != in1);
    if (scl != 8)
        DIE("IDX Scale %d NYI\n", scl);
    switch (size) {
    case 1:
        //| sub Rb(out), byte [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5880, (out), (idx), (base), 0);
#line 681 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| sub Rw(out), word [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5894, (out), (idx), (base), 0);
#line 684 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| sub Rd(out), dword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5895, (out), (idx), (base), 0);
#line 687 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| sub Rq(out), qword [Rq(base)+Rq(idx)*8];
        dasm_put(Dst, 5908, (out), (idx), (base), 0);
#line 690 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported load size: %d\n", size);
    }
}




MVM_JIT_TILE_DECL(test) {
    MVMint8 reg = tile->values[1];
    switch (tile->size) {
    case 1:
        //| test Rb(reg), Rb(reg);
        dasm_put(Dst, 5922, (reg), (reg));
#line 704 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| test Rw(reg), Rw(reg);
        dasm_put(Dst, 5931, (reg), (reg));
#line 707 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| test Rd(reg), Rd(reg);
        dasm_put(Dst, 5932, (reg), (reg));
#line 710 "src/jit/x64/tiles.dasc"
        break;
    case 8:
    default:
        /* NB - this is a hack, because we don't assign a size to the result of
         * CALL, its size would be 0, and we'd have nothing compiled. Better fix
         * would be to assign a result size to CALL. */
        //| test Rq(reg), Rq(reg);
        dasm_put(Dst, 5940, (reg), (reg));
#line 717 "src/jit/x64/tiles.dasc"
        break;
    }
}



MVM_JIT_TILE_DECL(test_addr) {
    MVMint8 base  = tile->values[1];
    MVMint32 ofs  = tile->args[0];
    MVMint32 size = tile->args[1];
    /* TODO - I now suspect that this can be OR [addr], 0, without loss of generality */
    switch (size) {
    case 1:
        //| cmp byte [Rq(base)+ofs], 0;
        dasm_put(Dst, 5949, (base), ofs);
#line 731 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| cmp word [Rq(base)+ofs], 0;
        dasm_put(Dst, 5959, (base), ofs);
#line 734 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| cmp dword [Rq(base)+ofs], 0;
        dasm_put(Dst, 5960, (base), ofs);
#line 737 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| cmp qword [Rq(base)+ofs], 0;
        dasm_put(Dst, 5969, (base), ofs);
#line 740 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported size %d for load\n", size);
    }
}


MVM_JIT_TILE_DECL(test_idx) {
    MVMint8 base = tile->values[1];
    MVMint8 idx  = tile->values[2];
    MVMint32 scl = tile->args[0];
    MVMint32 size = tile->args[1];
    if (scl != 8)
        DIE("Scale %d NYI\n", scl);
    switch(size) {
    case 1:
        //| cmp byte [Rq(base)+Rq(idx)*8], 0;
        dasm_put(Dst, 5979, (idx), (base), 0);
#line 757 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| cmp word [Rq(base)+Rq(idx)*8], 0;
        dasm_put(Dst, 5992, (idx), (base), 0);
#line 760 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| cmp dword [Rq(base)+Rq(idx)*8], 0;
        dasm_put(Dst, 5993, (idx), (base), 0);
#line 763 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| cmp qword [Rq(base)+Rq(idx)*8], 0;
        dasm_put(Dst, 6005, (idx), (base), 0);
#line 766 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported size %d for load\n", tile->size);
    }
}

MVM_JIT_TILE_DECL(test_and) {
    MVMint8 rega = tile->values[1];
    MVMint8 regb = tile->values[2];
    switch(tile->size) {
    case 1:
        //| test Rb(regb), Rb(rega);
        dasm_put(Dst, 5922, (rega), (regb));
#line 778 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| test Rw(regb), Rw(rega);
        dasm_put(Dst, 5931, (rega), (regb));
#line 781 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| test Rd(regb), Rd(rega);
        dasm_put(Dst, 5932, (rega), (regb));
#line 784 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| test Rq(regb), Rq(rega);
        dasm_put(Dst, 5940, (rega), (regb));
#line 787 "src/jit/x64/tiles.dasc"
        break;
    }
}

MVM_JIT_TILE_DECL(test_const) {
    MVMint8  reg = tile->values[1];
    MVMint32 val = tile->args[0];
    switch(tile->size) {
    case 1:
        //| test Rb(reg), val;
        dasm_put(Dst, 6018, (reg), val);
#line 797 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| test Rw(reg), val;
        dasm_put(Dst, 6027, (reg), val);
#line 800 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| test Rd(reg), val;
        dasm_put(Dst, 6036, (reg), val);
#line 803 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported size of constant");
        break;
    }
}

MVM_JIT_TILE_DECL(test_addr_const) {
    MVMint8  reg = tile->values[1];
    /* args: $ofs $lsize $val $csize */
    MVMint32 ofs = tile->args[0];
    MVMint32 val = tile->args[2];
    switch(tile->size) {
    case 1:
        //| test byte [Rq(reg)+ofs], val;
        dasm_put(Dst, 6044, (reg), ofs, val);
#line 818 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| test word [Rq(reg)+ofs], val;
        dasm_put(Dst, 6055, (reg), ofs, val);
#line 821 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| test dword [Rq(reg)+ofs], val;
        dasm_put(Dst, 6066, (reg), ofs, val);
#line 824 "src/jit/x64/tiles.dasc"
        break;
    default:
        DIE("Unsupported size of constant");
        break;
    }
}

MVM_JIT_TILE_DECL(test_num) {
    MVMint8 reg = REG_NUM(tile->values[1]);
    //| xorpd xmm0, xmm0;
    //| ucomisd xmm(reg), xmm0;
    dasm_put(Dst, 6076, (reg));
#line 835 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(cmp) {
    MVMint8 regl = tile->values[1];
    MVMint8 regr = tile->values[2];
    switch (tile->size) {
    case 1:
        //| cmp Rb(regl), Rb(regr);
        dasm_put(Dst, 6088, (regr), (regl));
#line 844 "src/jit/x64/tiles.dasc"
        break;
    case 2:
        //| cmp Rw(regl), Rw(regr);
        dasm_put(Dst, 6097, (regr), (regl));
#line 847 "src/jit/x64/tiles.dasc"
        break;
    case 4:
        //| cmp Rd(regl), Rd(regr);
        dasm_put(Dst, 6098, (regr), (regl));
#line 850 "src/jit/x64/tiles.dasc"
        break;
    case 8:
        //| cmp Rq(regl), Rq(regr);
        dasm_put(Dst, 6106, (regr), (regl));
#line 853 "src/jit/x64/tiles.dasc"
        break;
    }
}

MVM_JIT_TILE_DECL(cmp_num) {
    MVMint8 left = REG_NUM(tile->values[1]);
    MVMint8 right = REG_NUM(tile->values[2]);
    //| ucomisd xmm(left), xmm(right);
    dasm_put(Dst, 6115, (left), (right));
#line 861 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(flagval) {
    /* Intel SDM Volume 1, ch5.1.6 - Bit and Byte Instructions */
    MVMint8 out = tile->values[0];
    MVMint32 child = MVM_JIT_EXPR_LINKS(tree, tile->node)[0];
    enum MVMJitExprOperator flag  = tree->nodes[child];
    /* This isn't exactly elegant, better mechanism wanted */
    MVMuint8 test_type = MVM_JIT_EXPR_INFO(tree, child)->type;
    if (test_type == MVM_reg_num32 || test_type == MVM_reg_num64) {
        switch (flag) {
        case MVM_JIT_LT:
            //| setnp al;
            //| setb Rb(out);
            //| and Rb(out), al;
            dasm_put(Dst, 6125, (out), (out));
#line 877 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_LE:
            //| setnp al;
            //| setbe Rb(out);
            //| and Rb(out), al;
            dasm_put(Dst, 6142, (out), (out));
#line 882 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_ZR:
        case MVM_JIT_EQ:
            //| setnp al;
            //| setz Rb(out);
            //| and Rb(out), al;
            dasm_put(Dst, 6159, (out), (out));
#line 888 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_NZ:
        case MVM_JIT_NE:
            //| setp al;
            //| setnz Rb(out);
            //| or Rb(out), al;
            dasm_put(Dst, 6176, (out), (out));
#line 894 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_GE:
            //| setae Rb(out);
            dasm_put(Dst, 6193, (out));
#line 897 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_GT:
            //| seta Rb(out);
            dasm_put(Dst, 6201, (out));
#line 900 "src/jit/x64/tiles.dasc"
            break;
        default:
            abort();
        }
    } else {
        switch (flag) {
        case MVM_JIT_LT:
            //| setl Rb(out);
            dasm_put(Dst, 6209, (out));
#line 908 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_LE:
            //| setle Rb(out);
            dasm_put(Dst, 6217, (out));
#line 911 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_ZR:
        case MVM_JIT_EQ:
            //| setz Rb(out);
            dasm_put(Dst, 6225, (out));
#line 915 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_NZ:
        case MVM_JIT_NE:
            //| setnz Rb(out);
            dasm_put(Dst, 6233, (out));
#line 919 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_GE:
            //| setge Rb(out);
            dasm_put(Dst, 6241, (out));
#line 922 "src/jit/x64/tiles.dasc"
            break;
        case MVM_JIT_GT:
            //| setg Rb(out);
            dasm_put(Dst, 6249, (out));
#line 925 "src/jit/x64/tiles.dasc"
            break;
        default:
            abort();
        }
    }
    /* XXX THIS IS A HACK

     * The size cast is supposed to be applied by the expression template
     * builder, but that subtly doesn't work (it's not applied for STORE
     * operands, and when it is, it causes even subtler errors with CONST
     * arguments. (const_i64_16 returns a 64 bit signed integer as a 16 bit
     * signed integer argument, and currently CONST doesn't have a sign, and the
     * tile yielding the value (fortunately) doesn't respect the size. */

    //| movzx Rq(out), Rb(out);
    dasm_put(Dst, 5432, (out), (out));
#line 940 "src/jit/x64/tiles.dasc"
}


MVM_JIT_TILE_DECL(mark) {
    MVMint32 label = tile->args[0];
    //|=>(label):
    dasm_put(Dst, 245, (label));
#line 946 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(label) {
    MVMint8 reg = tile->values[0];
    MVMint32 label = tile->args[0];
    //| lea Rq(reg), [=>label];
    dasm_put(Dst, 6257, (reg), label);
#line 952 "src/jit/x64/tiles.dasc"
}

MVM_JIT_TILE_DECL(branch_label) {
    MVMint32 label = tile->args[0];
    if (label >= 0) {
        //| jmp =>(label);
        dasm_put(Dst, 4417, (label));
#line 958 "src/jit/x64/tiles.dasc"
    } else {
        //| jmp ->exit;
        dasm_put(Dst, 4412);
#line 960 "src/jit/x64/tiles.dasc"
    }
}



static void move_call_value(MVMThreadContext *tc, MVMJitCompiler *compiler, MVMJitTile *tile) {
    if (MVM_JIT_TILE_YIELDS_VALUE(tile)) {
        MVMint8 out = tile->values[0];
        if (IS_GPR(out)) {
            //| mov Rq(out), rax;
            dasm_put(Dst, 5387, (out));
#line 970 "src/jit/x64/tiles.dasc"
        } else {
            //| movsd xmm(REG_NUM(out)), xmm0;
            dasm_put(Dst, 6265, (REG_NUM(out)));
#line 972 "src/jit/x64/tiles.dasc"
        }
    }
}

MVM_JIT_TILE_DECL(call) {
    MVMint8 reg = tile->values[1];
    //| call Rq(reg);
    dasm_put(Dst, 6274, (reg));
#line 979 "src/jit/x64/tiles.dasc"
    move_call_value(tc, compiler, tile);
}

MVM_JIT_TILE_DECL(call_func) {
    uintptr_t ptr = tree->constants[tile->args[0]].u;
    //| callp ptr;
    dasm_put(Dst, 116);
    dasm_put(Dst, 118, (MVMuint32)((uintptr_t)(ptr)), (MVMuint32)((uintptr_t)(ptr) >> 32));
    dasm_put(Dst, 260);
#line 985 "src/jit/x64/tiles.dasc"
    move_call_value(tc, compiler, tile);
}


MVM_JIT_TILE_DECL(call_addr) {
    MVMint8  reg = tile->values[1];
    MVMint32 ofs = tile->args[0];
    //| call qword [Rq(reg)+ofs];
    dasm_put(Dst, 6281, (reg), ofs);
#line 993 "src/jit/x64/tiles.dasc"
    move_call_value(tc, compiler, tile);
}
